/*
 * bc_data.c - 
 */

/*
 * $Id: bc_data.c,v 1.10 2014/10/28 02:22:55 komiya Exp $
 *
 *  File Name : bc_data.c
 *  written by Mikio Yamamoto.
 *  Data for byte-code reader.
 */

static char *RCSid="$Id: bc_data.c,v 1.10 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

#ifdef THINK_C
#include <string.h>
#else
#include <strings.h>
#endif


/*

#define BCDATA_HASH_MASK
#define BCDATA_HASH_SIZE

     in scheme.h

 */

#define THE_NUM_OF_BC_INST 110

void open_frame();
void open_lframe();
void open_lframe_1();
void xcall();
void lcall();
void trcall();
void trlcall();
void strcall();
void ltrxcall();
void xreturn();
void lreturn();
void jmp();
void jmp_if_true();
void jmp_if_false();
void get_const();
void get_gval();
void get_lval();
void get_lval0();
void get_hval();
void get_hval0();
void get_cval();
void get_cval0();
void push_reg();
void push_const();
void push_gval();
void push_lval();
void push_lval0();
void push_hval();
void push_hval0();
void push_cval();
void push_cval0();
void set_gval();
void set_lval0();
void set_hval();
void set_hval0();
void set_cval();
void set_cval0();
void lift();
void lift0();
void lift_nil();
void make_rest();
void make_closure();
void make_promise();
#ifdef CTHREAD
void make_future();
# ifdef SHE
void make_nil_future();
void make_future_cond();
void make_nil_future_cond();
void make_future_cond1();
void make_stealable();
void make_nil_stealable();
void make_stealable_cond();
void make_nil_stealable_cond();
void make_stealable_cond1();
void push_env_lval0();
void push_env_lval();
void push_env_lval0_c();
void push_env_lval_c();
# endif
void make_plchld();
void touch();
void touch_top();
void touch_bx();
#ifndef SHE
void xspawn_thread();
void spawn_thread();
#endif
#endif /* CTHREAD */
#ifdef LTC /* Lazy Task Cration  06 Aug 1997 */
void open_ltframe();
void open_lltframe();
void open_lltframe_1();
#ifdef CONDITIONAL_FUTURE
void open_ltframe_c();
void open_ltframe_c_aux();
#endif
#endif /* LTC */
void reset_sp();
void get_car();
void get_cdr();
void get_cadr();
void get_caar();
void get_cdar();
void get_cddr();
void make_cons();
void make_cons1();
void make_cons2();
void ncons();
void pairp();
void symbolp();
void nullp();
void notp();
void zerop();
void eqp();
void eqvp();
void equalp();
void eq_constp();
void eqv_constp();
void equal_constp();
void add();
void mul();
void sub();
void minus();
void tus_div();
void inverse();
void add1();
void sub1();
void lessthan2();
void greaterthan2();
void lep2();
void gep2();
void numbereq2();
void setcar();
void setcdr();
void vectorref();
void vectorset();
void vectorp();
void vectorlen();

int codecount;
unsigned *bcspec;


/*  Written by Myama.   */
/*  Fair copied by Yass. Sep. 18 '90  */
bcdatainit()
{ 
    int i;

#ifdef THINK_C
    if ((bcdata_hash_table = (unsigned *)NewPtr(BCDATA_HASH_SIZE+4)) == NULL) {
        printf("not enough memory.\n");
        exit(1);
    }
    bcdata_hash_table = (unsigned *)((char *)bcdata_hash_table
                                        + ((unsigned)bcdata_hash_table % 4));
#elif defined(CTHREAD)
    bcdata_hash_table = (unsigned *)malloc(BCDATA_HASH_SIZE);
#else
    bcdata_hash_table = (unsigned *)sbrk(BCDATA_HASH_SIZE);
#endif
    for (i = 0 ; i < (BCDATA_HASH_SIZE / 4) ; ++i)
        *(bcdata_hash_table + i) = NULL;
    codecount = GETCONST;
#ifdef THINK_C
    if ((bcspec = (unsigned *)NewPtr(THE_NUM_OF_BC_INST * 11 * 4 + 4)) == NULL) {
        printf("not enough memory.\n");
        exit(1);
    }
    bcspec = (unsigned *)((char *)bcspec + ((unsigned)bcspec % 4));
#elif defined(CTHREAD)
    bcspec = (unsigned *)malloc(THE_NUM_OF_BC_INST * 11 * 4);
#else
    bcspec = (unsigned *)sbrk(THE_NUM_OF_BC_INST * 11 * 4);
#endif
    hash_bit_mask = BCDATA_HASH_MASK;

    bcdata("get-const", get_const,  OBJECT, NON, NON, NON);
    bcdata("xreturn", xreturn,          NON, NON, NON, NON);
    bcdata("lreturn", lreturn,      NON, NON, NON, NON);
    bcdata("xcall", xcall,      REST, NON, NON, NON);
    bcdata("open-frame", open_frame,    LABEL, NON, NON, NON);
    bcdata("open-lframe", open_lframe,  NUMBER, NUMBER, LABEL, NON);
    bcdata("open-lframe-1", open_lframe_1, NUMBER, LABEL, NON, NON);
    bcdata("lcall", lcall,      LABEL, REST, NON, NON);
    bcdata("trcall", trcall,        NUMBER, NON, NON, NON);
    bcdata("trlcall", trlcall,      NUMBER, NUMBER, LABEL, NON);
    bcdata("ltrxcall", ltrxcall,        NUMBER, NON, NON, NON);
    bcdata("strcall", strcall,      NUMBER, LABEL, NON, NON);
    bcdata("jmp", jmp,          LABEL, NON, NON, NON);
    bcdata("jmp-if-true", jmp_if_true,  LABEL, NON, NON, NON);
    bcdata("jmp-if-false", jmp_if_false,  LABEL, NON, NON, NON);
    bcdata("get-gval", get_gval,        OBJECT, NON, NON, NON);
    bcdata("get-lval", get_lval,        NUMBER, NUMBER, NUMBER, NON);
    bcdata("get-lval0", get_lval0,  NUMBER, NON, NON, NON);
    bcdata("get-hval", get_hval,        NUMBER, NUMBER, NUMBER, NON);
    bcdata("get-hval0", get_hval0,  NUMBER, NON, NON, NON);
    bcdata("get-cval", get_cval,        NUMBER, NUMBER, NUMBER, NUMBER);
    bcdata("get-cval0", get_cval0,      NUMBER, NUMBER, NON, NON);
    bcdata("push-bx", push_reg,         NON, NON, NON, NON);
    bcdata("push-const", push_const,    OBJECT, NON, NON, NON);
    bcdata("push-gval", push_gval,  OBJECT, NON, NON, NON);
    bcdata("push-lval", push_lval,  NUMBER, NUMBER, NUMBER, NON);
    bcdata("push-lval0", push_lval0,    NUMBER, NON, NON, NON);
    bcdata("push-hval", push_hval,  NUMBER, NUMBER, NUMBER, NON);
    bcdata("push-hval0", push_hval0,    NUMBER, NON, NON, NON);
    bcdata("push-cval", push_cval,  NUMBER, NUMBER, NUMBER, NUMBER);
    bcdata("push-cval0", push_cval0,    NUMBER, NUMBER, NON, NON);
    bcdata("set-gval", set_gval,        OBJECT, NON, NON, NON);
    bcdata("set-lval0", set_lval0,  NUMBER, NON, NON, NON);
    bcdata("set-hval", set_hval,        NUMBER, NUMBER, NUMBER, NON);
    bcdata("set-hval0", set_hval0,  NUMBER, NON, NON, NON);
    bcdata("set-cval", set_cval,        NUMBER, NUMBER, NUMBER, NUMBER);
    bcdata("set-cval0", set_cval0,  NUMBER, NUMBER, NON, NON);
    bcdata("lift", lift,            NUMBER, NUMBER, NUMBER, NUMBER);
    bcdata("lift0", lift0,      NUMBER, NUMBER, NON, NON);
    bcdata("lift-nil", lift_nil,        NUMBER, NON, NON, NON);
    bcdata("make-rest", make_rest,  NUMBER, NON, NON, NON);
    bcdata("make-closure", make_closure,    NUMBER, LABEL, OBJECT, NON);
    bcdata("make-nil-closure", get_const, NUMBER, LABEL, OBJECT, NON);
    bcdata("make-promise", make_promise,  LABEL, NON, NON, NON);
#ifdef CTHREAD
# ifdef SHE
#  ifdef SHE_ENV
    bcdata("push-env-lval0", push_env_lval0,    NUMBER, NON, NON, NON);
    bcdata("push-env-lval", push_env_lval,    NUMBER, NUMBER, NUMBER, NON);
    bcdata("push-env-lval0/c", push_env_lval0_c,    NUMBER, NON, NON, NON);
    bcdata("push-env-lval/c", push_env_lval_c,    NUMBER, NUMBER, NUMBER, NON);
    bcdata("make-future", make_future,  LABEL, NUMBER, NON, NON);
    bcdata("make-nil-future", make_nil_future,  LABEL, NUMBER, NON, NON);
    bcdata("make-future/c", make_future_cond,  LABEL, NUMBER, NON, NON);
    bcdata("make-nil-future/c", make_nil_future_cond,  LABEL, NUMBER, NON, NON);
    bcdata("make-stealable", make_stealable,  LABEL, NUMBER, NON, NON);
    bcdata("make-nil-stealable", make_nil_stealable,  LABEL, NUMBER, NON, NON);
    bcdata("make-stealable/c", make_stealable_cond,  LABEL, NUMBER, NON, NON);
    bcdata("make-nil-stealable/c", make_nil_stealable_cond,  LABEL, NUMBER, NON, NON);
    bcdata("make-nil-future/c1", make_future_cond1,  LABEL, NON, NON, NON);
    bcdata("make-nil-stealable/c1", make_stealable_cond1,  LABEL, NON, NON, NON);
#  else
    bcdata("make-future/c", make_future_cond,  LABEL, NON, NON, NON);
    bcdata("make-stealable", make_stealable,  LABEL, NON, NON, NON);
    bcdata("make-stealable/c", make_stealable_cond,  LABEL, NON, NON, NON);
    bcdata("make-future", make_future,  LABEL, NON, NON, NON);
#  endif
    bcdata("make-future/c1", make_future_cond1,  LABEL, NON, NON, NON);
    bcdata("make-stealable/c1", make_stealable_cond1,  LABEL, NON, NON, NON);
# else /* SHE */
    bcdata("make-future", make_future,  LABEL, NON, NON, NON);
# endif
    bcdata("make-placeholder", make_plchld,  NON, NON, NON, NON);
    bcdata("touch", touch,  NUMBER, NON, NON, NON);
    bcdata("touch-top", touch_top,  NON, NON, NON, NON);
    bcdata("touch-bx", touch_bx,  NON, NON, NON, NON);
#ifndef SHE
    bcdata("xspawn-thread", xspawn_thread,  LABEL, NON, NON, NON);
    bcdata("spawn-thread", spawn_thread,  LABEL, NON, NON, NON);
#endif
#endif
#ifdef LTC /* Lazy Task Cration (Aug 06, 1997) */
    bcdata("open-ltframe", open_ltframe,    LABEL, NON, NON, NON);
    bcdata("open-lltframe", open_lltframe,  NUMBER, NUMBER, LABEL, NON);
    bcdata("open-lltframe-1", open_lltframe_1, NUMBER, LABEL, NON, NON);
#ifdef CONDITIONAL_FUTURE
    bcdata("open-ltframe/c", open_ltframe_c,    LABEL, NON, NON, NON);
    bcdata("open-ltframe/c-aux", open_ltframe_c_aux,    LABEL, NUMBER, NON, NON);
#endif
#endif
    bcdata("reset-sp", reset_sp,        NUMBER, NON, NON, NON);
    bcdata("get-car", get_car,      NON, NON, NON, NON);
    bcdata("get-cdr", get_cdr,      NON, NON, NON, NON);
    bcdata("get-caar", get_caar,        NON, NON, NON, NON);
    bcdata("get-cadr", get_cadr,        NON, NON, NON, NON);
    bcdata("get-cdar", get_cdar,        NON, NON, NON, NON);
    bcdata("get-cddr", get_cddr,        NON, NON, NON, NON);
    bcdata("make-cons", make_cons,  NON, NON, NON, NON);
    bcdata("make-cons1", make_cons1,    OBJECT, NON, NON, NON);
    bcdata("make-cons2", make_cons2,    OBJECT, NON, NON, NON);
    bcdata("ncons", ncons,      NON, NON, NON, NON);
    bcdata("pair?", pairp,      NON, NON, NON, NON);
    bcdata("symbol?", symbolp,      NON, NON, NON, NON);
    bcdata("null?", nullp,      NON, NON, NON, NON);
    bcdata("not", notp,         NON, NON, NON, NON);
    bcdata("zero?", zerop,      NON, NON, NON, NON);
    bcdata("eq?", eqp,          NON, NON, NON, NON);
    bcdata("eqv?", eqvp,            NON, NON, NON, NON);
    bcdata("equal?", equalp,        NON, NON, NON, NON);
    bcdata("eq-const?", eq_constp,  OBJECT, NON, NON, NON);
    bcdata("eqv-const?", eqv_constp,    OBJECT, NON, NON, NON);
    bcdata("equal-const?", equal_constp,    OBJECT, NON, NON, NON);
    bcdata("+", add,    NON, NON, NON, NON);
    bcdata("*", mul,    NON, NON, NON, NON);
    bcdata("-", sub,    NON, NON, NON, NON);
    bcdata("0-", minus,    NON, NON, NON, NON);
    bcdata("/", tus_div,    NON, NON, NON, NON);
    bcdata("1/", inverse,    NON, NON, NON, NON);
    bcdata("1+", add1,    NON, NON, NON, NON);
    bcdata("1-", sub1,    NON, NON, NON, NON);
    bcdata("<", lessthan2,    NON, NON, NON, NON);
    bcdata(">", greaterthan2,    NON, NON, NON, NON);
    bcdata("<=", lep2,    NON, NON, NON, NON);
    bcdata(">=", gep2,    NON, NON, NON, NON);
    bcdata("=", numbereq2,    NON, NON, NON, NON);
    bcdata("set-car!", setcar,    NON, NON, NON, NON);
    bcdata("set-cdr!", setcdr,    NON, NON, NON, NON);
    bcdata("vector-ref", vectorref,    NON, NON, NON, NON);
    bcdata("vector-set!", vectorset,    NON, NON, NON, NON);
    bcdata("vector?", vectorp,    NON, NON, NON, NON);
    bcdata("vector-length", vectorlen,    NON, NON, NON, NON);

    hash_bit_mask = DEFAULT_HASH_B_M;
}


/*  !!! Written by Myama. '90.3.? */
/*  Written by Yass. Sep. 18 '90  */
bcdata(opname, funcp, operand1, operand2, operand3, operand4)
char    *opname;
int (*funcp)();
int operand1, operand2, operand3, operand4;
{ 
    unsigned *top;
    int word, i,
    label = NON,
    obj = NON;

    if (operand1 == OBJECT) 
        obj   = 1;
    if (operand1 == LABEL)  
        label = 1;
    if (operand1 == NON || operand1 == REST)
        word = 1;
    else
     { 
        if (operand2 == OBJECT) 
            obj   = 2;
        if (operand2 == LABEL)  
            label = 2;
        if (operand2 == NON || operand2 == REST)
            word = 2;
        else
         { 
            if (operand3 == OBJECT) 
                obj   = 3;
            if (operand3 == LABEL)  
                label = 3;
            if (operand3 == NON || operand3 == REST)
                word = 3;
            else
             { 
                if (operand4 == OBJECT) 
                    obj   = 4;
                if (operand4 == LABEL)  
                    label = 4;
                if (operand4 == NON || operand4 == REST)
                    word = 4;
                else
                    word = 5;
            }
        }
    }

    /* make a byte code specification data */

    top = bcspec;
    *(bcspec++) = LTAG_BLOCK2 | 40;  /*  vector header  */
    if (!strcmp(opname, "make-nil-closure"))
        *(bcspec++) = 2;               /*  1st element  */
    else
        *(bcspec++) = word;            /*  1st element  */
    *(bcspec++) = label;             /*  2nd element  */
    *(bcspec++) = obj;               /*  3rd element  */
    if (!strcmp(opname, "make-nil-closure"))
        *(bcspec++) = (unsigned)get_const;        /*  4th element  */
    else
        *(bcspec++) = (unsigned)funcp;            /*  4th element  */
    *(bcspec++) = operand1;          /*  5th element  */
    *(bcspec++) = operand2;          /*  6th element  */
    *(bcspec++) = operand3;          /*  7th element  */
    *(bcspec++) = operand4;          /*  8th element  */
    *(bcspec++) = (unsigned)opname;       /*  9th element  */
    *(bcspec++) = NULL;         /*  10th element  */

    /* register a byte code specification data */

    add_bcspec(opname, top);
}


/*  Written by Myama. Mar. '90  */
/*  Fair copied by Yass. Sep. 18 '90  */
add_bcspec(opname, a_bcspec)
char    *opname;
unsigned *a_bcspec;
{ 
    unsigned *obj;

#ifdef NIHONGO
    obj = bcdata_hash_table + a_hashing(opname, strlen(opname));
#else
    obj = bcdata_hash_table + hashing(opname, strlen(opname));
#endif

/*    obj = bcdata_hash_table + hashing(opname, strlen(opname)); */
    while (*obj != NULL)
        obj = ((unsigned *)(*obj)) + 10;
    *obj = (unsigned)a_bcspec;
}


/*  Written by Myama. ?  */
/*  Fair copied by Yass. Sep. 18 '90  */
unsigned *get_bcspec(strobj)
int strobj;
{
    unsigned *obj, *body;
    int def_hash_mask, strlength;
    char    *strp;

    def_hash_mask = hash_bit_mask;
    hash_bit_mask = BCDATA_HASH_MASK;
    obj = bcdata_hash_table + hash(strobj);
    hash_bit_mask = def_hash_mask;

    strp = (char *)(ADDRESS(strobj) + 12);
    strlength = ((STRING * )ADDRESS(strobj))->str_len;
    while (*obj != NULL) { 
        body = (unsigned *)(*obj);
        if (same_stringp((char *)(*(body + 9)), strp, strlength))
            return(body);
        else
            obj = body + 10;
    }
/*
    printf("System error: unknown byte code instruction %s\n", strp);
*/                              /* T.Komiya */
    return((unsigned *)NULL);
}


/*
 *
 *  special string compare routine : first string must have null code. 
 *                   second string need not to have null code.
 *                   length is the length of second string.
 */

/*  Written by Myama. ?  */
/*  Fair copied by Yass. Sep. 18 '90  */
int same_stringp(str1, str2, length)
char    *str1, *str2;
int length;
{
    while (*str1 != '\0' && length > 0) { 
        if (*(str1++) != *(str2++))
            return(FALSE);
        length--;
    }
    if (*str1 == '\0' && length == 0)
        return(TRUE);
    else
        return(FALSE);
}


