/*
 * callioc.c - 
 */

/*
 * $Id: callioc.c,v 1.5 2014/10/28 02:22:55 komiya Exp $
 *
          +-------------------------------------------+
       +5 |             reference count               |
          +-------------------------+-----------------+
       +4 | active stack link(next) | free stack link |
          +-------------------------+-----------------+
       +3 |         active stack link(prev.)          |
          +-------------------------------------------+
       +2 |                                           |
          +-------------------------------------------+
       +1 |             saved active_reg              |
          +-------------------------------------------+
       +0 |                saved more                 | : bottom
          +-------------------------------------------+
          |                    |                      |
          :                    V                      :
*/

static char *RCSid="$Id: callioc.c,v 1.5 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"
#ifdef CALLIOC
unsigned *__alloc_stack()
{
    unsigned *tmp;
    int top();

    if (free_stacks != NULL) {
        tmp = free_stacks;
        free_stacks = (unsigned *)free_stacks[4];
    } else {
        tmp = (unsigned *)malloc(STACK_SIZE);
        tmp = (unsigned *)((char *)tmp + STACK_SIZE - 28);
        tmp[-3] = tmp[-2] = 0;
        tmp[-1] = (unsigned)top;
        tmp[2] = 0;
    }
    tmp[3] = (unsigned)active_stacks;
    tmp[4] = NULL;
    active_stacks[4] = (unsigned)tmp;
    return(active_stacks = tmp);
}

free_stack(bottom)
unsigned *bottom;
{
    if (bottom[4]) {
        ((unsigned *)bottom[4])[3] = bottom[3];
        if (bottom[3])
            ((unsigned *)bottom[3])[4] = bottom[4];
    } else {
        ((unsigned *)bottom[3])[4] = NULL;
        active_stacks = (unsigned *)bottom[3];
    }
    bottom[4] = (unsigned)free_stacks;
    free_stacks = bottom;
}

void Scall_ioc()
{
    SOBJ cont;
    unsigned retaddr, *epframep, epretaddr;

    int iretaddrx();
    int find_if2();
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
    int map2_tch();
    int map2_ntch();
    int foreach2_tch();
    int foreach2_ntch();
    int mapcan2_tch();
    int mapcan2_ntch();
#else
    int map2();
    int mapcan2();
    int foreach2();
#endif
    int recover_set_gval();
    int err_recover_get_gval();
    int err_recover_set_gval();
    int err_recover_push_gval();
    int bcloader2_a_exp();
    int bcloader2();
    int bcload_with_cip_epilogue();
    int bcload_epilogue();
    int bcload_with_cip();
    int bctran_exec_form();
    int top();
#ifdef CTHREAD
# ifndef SHE
    int bc_intrp_future2();
    int bc_intrp_not_future2();
# endif
#endif

    int iretaddrep();
    int find_if2_ep();
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
/*  not yet implemented
    int map2_tch_ep();
    int map2_ntch_ep();
    int mapcan2_tch_ep();
    int mapcan2_ntch_ep();
    int foreach2_tch_ep();
    int foreach2_ntch_ep();
 */
#else
    int map2_ep();
    int mapcan2_ep();
    int foreach2_ep();
#endif
    int recover_set_gval_ep();
    int err_recover_push_gval_ep();
    int bcloader2_a_exp_ep();
    int bcloader2_ep();
    int bcload_with_cip_epilogue_ep();
    int bcload_epilogue_ep();
    int bcload_with_cip_ep();
    int bctran_exec_form_ep();
#ifdef CTHREAD
# ifndef SHE
    int bc_intrp_future2_ep();
    int bc_intrp_not_future2_ep();
# endif
#endif

    int iretaddrx_tr();
    int s_iretaddrx();

    retaddr = *(active_reg +2);

    if (retaddr == (unsigned)top) {
/*
        epframep = (unsigned *)ADDRESS(CARobj(CARobj(more.obj)))
            + (IMM(*((unsigned *)ADDRESS(CARobj(CARobj(more.obj)))))>>2);
*/
        /* 961204 */
        epframep = (unsigned *)ADDRESS(CDRobj(CARobj(more.obj))) 
            + (IMM(*((unsigned *)ADDRESS(CDRobj(CARobj(more.obj)))))>>2);
/*        epretaddr = *epframep; */
        epretaddr = fix_to_int(*epframep);  /* 961204 */
        if (GETtag(*(epframep-2)) != LTAG_IOC) {
#ifdef SPECIAL_CONS_TAG
            cont.obj = mk_ontcont(*(epframep - 2), mk_fix(stack_bottom));
#else
            cont.obj = mk_ontcont(*(epframep - 2), mk_fix(SSERDDA(stack_bottom)));
#endif
/*
            epframep = (unsigned *)ADDRESS(CARobj(CARobj(more.obj)))
                + (IMM(*((unsigned *)ADDRESS(CARobj(CARobj(more.obj)))))>>2);
*/
            /* 961204 */
            epframep = (unsigned *)ADDRESS(CDRobj(CARobj(more.obj))) 
                + (IMM(*((unsigned *)ADDRESS(CDRobj(CARobj(more.obj)))))>>2);
            if (epretaddr == (unsigned)iretaddrx)
                *epframep = (unsigned)mk_fix(iretaddrep); /* mk_fix - 961204 */
            else if (epretaddr == (unsigned)find_if2)
                *epframep  = (unsigned)mk_fix(find_if2_ep);
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
            /* not yet implemented */
#else
            else if (epretaddr == (unsigned)map2)
                *epframep  = (unsigned)mk_fix(map2_ep);
            else if (epretaddr == (unsigned)mapcan2)
                *epframep  = (unsigned)mk_fix(mapcan2_ep);
            else if (epretaddr == (unsigned)foreach2)
                *epframep  = (unsigned)mk_fix(foreach2_ep);
#endif
            else if (epretaddr == (unsigned)s_iretaddrx) {
                call_cc_arg.obj = *(active_reg - 2);
                open_frame2(iretaddrx_tr, cont.obj, 0);
                ((unsigned *)stack_bottom)[5]++;
                s_push(call_cc_arg.obj);
                s_push(cont.obj);
                set_up_stack();
                return;
            } else if (epretaddr == (unsigned)recover_set_gval ||
                     epretaddr == (unsigned)err_recover_get_gval ||
                     epretaddr == (unsigned)err_recover_set_gval )
                *epframep  = (unsigned)mk_fix(recover_set_gval_ep);
            else if (epretaddr == (unsigned)err_recover_push_gval)
                *epframep  = (unsigned)mk_fix(err_recover_push_gval_ep);
            else if (epretaddr == (unsigned)bcloader2_a_exp)
                *epframep  = (unsigned)mk_fix(bcloader2_a_exp_ep);
            else if (epretaddr == (unsigned)bcloader2)
                *epframep  = (unsigned)mk_fix(bcloader2_ep);
            else if (epretaddr == (unsigned)bcload_with_cip_epilogue)
                *epframep  = (unsigned)mk_fix(bcload_with_cip_epilogue_ep);
            else if (epretaddr == (unsigned)bcload_epilogue)
                *epframep  = (unsigned)mk_fix(bcload_epilogue_ep);
            else if (epretaddr == (unsigned)bcload_with_cip)
                *epframep  = (unsigned)mk_fix(bcload_with_cip_ep);
            else if (epretaddr == (unsigned)bctran_exec_form)
                *epframep  = (unsigned)mk_fix(bctran_exec_form_ep);
#ifdef CTHREAD
# ifndef SHE
            else if (epretaddr == (unsigned)bc_intrp_future2)
                *epframep = (unsigned)mk_fix(bc_intrp_future2_ep);
            else if (epretaddr == (unsigned)bc_intrp_not_future2)
                *epframep = (unsigned)mk_fix(bc_intrp_not_future2_ep);
# endif
#endif
            *(epframep - 2) = cont.obj;
            ((unsigned *)stack_bottom)[5]++;
        } else
            cont.obj = *(epframep - 2);
        /*
          else {
#ifdef SPECIAL_CONS_TAG
            cont.obj = mk_ontcont(LTAG_NIL, mk_fix(stack_bottom));
#else
            cont.obj = mk_ontcont(LTAG_NIL, mk_fix(SSERDDA(stack_bottom)));
#endif
            call_cc_arg.obj = *(active_reg - 2);
            open_frame2(iretaddrx_tr, cont.obj, 0);
            ((unsigned *)stack_bottom)[5]++;
            s_push(call_cc_arg.obj);
            s_push(cont.obj);
            set_up_stack();
            return;
        }
        */
    } else {
        if (GETtag(*(active_reg + 4)) != LTAG_IOC) {
            if (retaddr == (unsigned)iretaddrx)
                *(active_reg +2) = (unsigned)iretaddrep;  
            else if (retaddr == (unsigned)find_if2)
                *(active_reg +2) = (unsigned)find_if2_ep;
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
            /* not yet implemented */
#else
            else if (retaddr == (unsigned)map2)
                *(active_reg +2) = (unsigned)map2_ep;
            else if (retaddr == (unsigned)mapcan2)
                *(active_reg +2) = (unsigned)mapcan2_ep;
            else if (retaddr == (unsigned)foreach2)
                *(active_reg +2) = (unsigned)foreach2_ep;
#endif
            else if (retaddr == (unsigned)s_iretaddrx) {
#ifdef SPECIAL_CONS_TAG
                cont.obj = mk_ontcont(LTAG_NIL, mk_fix(stack_bottom));
#else
                cont.obj = mk_ontcont(LTAG_NIL, mk_fix(SSERDDA(stack_bottom)));
#endif
                call_cc_arg.obj = *(active_reg - 2);
                open_frame2(iretaddrx_tr, cont.obj, 0);
                ((unsigned *)stack_bottom)[5]++;
                s_push(call_cc_arg.obj);
                s_push(cont.obj);
                set_up_stack();
                return;
            } else if (retaddr == (unsigned)recover_set_gval ||
                     retaddr == (unsigned)err_recover_get_gval ||
                     retaddr == (unsigned)err_recover_set_gval)
                *(active_reg +2) = (unsigned)recover_set_gval_ep;
            else if (retaddr == (unsigned)err_recover_push_gval)
                *(active_reg +2) = (unsigned)err_recover_push_gval_ep;
            else if (retaddr == (unsigned)bcloader2_a_exp)
                *(active_reg +2) = (unsigned)bcloader2_a_exp_ep;
            else if (retaddr == (unsigned)bcloader2)
                *(active_reg +2) = (unsigned)bcloader2_ep;
            else if (retaddr == (unsigned)bcload_with_cip_epilogue)
                *(active_reg +2) = (unsigned)bcload_with_cip_epilogue_ep;
            else if (retaddr == (unsigned)bcload_epilogue)
                *(active_reg +2) = (unsigned)bcload_epilogue_ep;
            else if (retaddr == (unsigned)bcload_with_cip)
                *(active_reg +2) = (unsigned)bcload_with_cip_ep;
            else if (retaddr == (unsigned)bctran_exec_form)
                *(active_reg +2) = (unsigned)bctran_exec_form_ep;
#ifdef CTHREAD
# ifndef SHE
            else if (retaddr == (unsigned)bc_intrp_future2)
                *(active_reg +2) = (unsigned)bc_intrp_future2_ep;
            else if (retaddr == (unsigned)bc_intrp_not_future2)
                *(active_reg +2) = (unsigned)bc_intrp_not_future2_ep;
# endif
#endif
#ifdef SPECIAL_CONS_TAG
            cont.obj = mk_ontcont(*(active_reg + 4), mk_fix(stack_bottom));
#else
            cont.obj = mk_ontcont(*(active_reg + 4), mk_fix(SSERDDA(stack_bottom)));
#endif
            *(active_reg + 4) = cont.obj;
            ((unsigned *)stack_bottom)[5]++;
        } else
            cont.obj = *(active_reg + 4);
        /*
          else {
#ifdef SPECIAL_CONS_TAG
            cont.obj = mk_ontcont(LTAG_NIL, mk_fix(stack_bottom));
#else
            cont.obj = mk_ontcont(LTAG_NIL, mk_fix(SSERDDA(stack_bottom)));
#endif
            call_cc_arg.obj = *(active_reg - 2);
            open_frame2(iretaddrx_tr, cont.obj, 0);
            ((unsigned *)stack_bottom)[5]++;
            s_push(call_cc_arg.obj);
            s_push(cont.obj);
            set_up_stack();
            return;
        }
        */
    }
    
    call_cc_arg.obj = s_pop();         /* save a call/ep argument */
    s_pop();
    
    s_push(call_cc_arg.obj);
    s_push(cont.obj);

    set_up_stack();
}
#endif
