/*
 * closure.c - 
 */

/*
 * $Id: closure.c,v 1.3 2000/07/10 08:35:34 komiya Exp $
 */

static char *RCSid="$Id: closure.c,v 1.3 2000/07/10 08:35:34 komiya Exp $";

#include "scheme.h"

#ifdef THINK_C
#include <string.h>
#else
#include <strings.h>
#endif


Sclear_source()
{
    SOBJ x;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
        err_illegal_argument("Argument must be a closure.");

    y = (ENTITYP)(ADDRESS(x.obj));

    y->bcc.source.obj = LTAG_NIL;

    set_reg(LTAG_T);
}


Schange_bci()
{
    SOBJ x;
    ENTITYP new_obj, old_obj;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
        err_illegal_argument("Argument must be a closure.");
    old_obj = (ENTITYP)(ADDRESS(x.obj));

    x.obj = getarg(2);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
        err_illegal_argument("Argument must be a closure.");
    new_obj = (ENTITYP)(ADDRESS(x.obj));

    old_obj->bcc.start_addr = new_obj->bcc.start_addr;
    old_obj->bcc.body.obj = new_obj->bcc.body.obj;
    old_obj->bcc.const_vec.obj = new_obj->bcc.const_vec.obj;
    old_obj->bcc.arg_info = new_obj->bcc.arg_info;
    /*  old_obj->bcc.source.obj = new_obj->bcc.source.obj; */
    /*  old_obj->bcc.env.obj = new_obj->bcc.env.obj; */
    set_reg(LTAG_T);

}


Scheck_mac()
{
    SOBJ x;

    x.obj = getarg(1);
    if (GETtag(x.obj) == LTAG_MACRO)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


Scheck_sys()
{
    SOBJ x;

    x.obj = getarg(1);
    if (GETtag(x.obj) == LTAG_SFUNCTION)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


Scheck_fun()
{
    SOBJ x;

    x.obj = getarg(1);
    if ((GETtag(x.obj) == LTAG_BCLOSURE) || (GETtag(x.obj) == LTAG_MBCLOSURE))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


Sget_closure_source()
{
    SOBJ x;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
	err_illegal_argument("Argument must be a closure.");

    y = (ENTITYP)(ADDRESS(x.obj));

    set_reg(y->bcc.source.obj);
}


Sput_closure_source()
{
    SOBJ x, z;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
        err_illegal_argument("1st argument must be a closure.");
    y = (ENTITYP)(ADDRESS(x.obj));

    z.obj = getarg(2);
    if (GETtag(z.obj) != LTAG_CONS)
        err_illegal_argument("2nd argument must be a list.");

    y->bcc.source.obj = z.obj;

    set_reg(LTAG_T);
}


Sget_closure_name()
{
    SOBJ x;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE)
	&& (GETtag(x.obj) != LTAG_SFUNCTION))
	err_illegal_argument("Argument must be a closure.");	
	
    y = (ENTITYP)(ADDRESS(x.obj));	
    set_reg(y->bcc.fun_name.obj);
}


Sput_closure_name()
{
    SOBJ x, z;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
	err_illegal_argument("1st argument must be a closure.");
    y = (ENTITYP)(ADDRESS(x.obj));

    z.obj = getarg(2);
    if ((GETtag(z.obj) != LTAG_STRING) && (GETtag(z.obj) != LTAG_SSTRING)
	&& (GETtag(z.obj) != LTAG_NIL))
        err_illegal_argument("2nd argument must be a string or ().");

    y->bcc.fun_name.obj = z.obj;

    set_reg(LTAG_T); 
}


Sget_closure_env()
{
    SOBJ x;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
	err_illegal_argument("Argument must be a closure.");	
    y = (ENTITYP)(ADDRESS(x.obj));

    set_reg(y->bcc.env.obj);
}


Sput_closure_env()
{
    SOBJ x, z;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
        err_illegal_argument("1st argument must be a closure.");
    y = (ENTITYP)(ADDRESS(x.obj));

    z.obj = getarg(2);
    if ((GETtag(z.obj) != LTAG_CONS)
	&& (GETtag(z.obj) != LTAG_NIL))
        err_illegal_argument("2nd argument must be a list.");

    y->bcc.env.obj = z.obj;

    set_reg(x.obj);
}


Sget_closure_stad()
{
    SOBJ x;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
	err_illegal_argument("Argument must be a closure.");	
    y = (ENTITYP)(ADDRESS(x.obj));

    set_reg(mk_fix(y->bcc.start_addr));
}


Sput_closure_stad()
{
    SOBJ x, z;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
        err_illegal_argument("1st argument must be a closure.");
    y = (ENTITYP)(ADDRESS(x.obj));

    z.obj = getarg(2);
    if((GETtag(z.obj) != LTAG_FIXNUM) && (GETtag(z.obj) != LTAG_FIXNUM1))
        err_illegal_argument("2nd argument must be a number.");

    y->bcc.start_addr = fix_to_int(z.obj);

    set_reg(x.obj);
}


Sget_closure_arginfo()
{
    SOBJ x;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
	err_illegal_argument("Argument must be a closure.");	
    y = (ENTITYP)(ADDRESS(x.obj));

    set_reg(mk_fix(y->bcc.arg_info));
}


Sput_closure_arginfo()
{
    SOBJ x, z;
    ENTITYP y;

    x.obj = getarg(1);
    if ((GETtag(x.obj) != LTAG_BCLOSURE) && (GETtag(x.obj) != LTAG_MBCLOSURE))
        err_illegal_argument("1st argument must be a closure.");
    y = (ENTITYP)(ADDRESS(x.obj));

    z.obj = getarg(2);
    if((GETtag(z.obj) != LTAG_FIXNUM) && (GETtag(z.obj) != LTAG_FIXNUM1))
        err_illegal_argument("2nd argument must be a number.");

    y->bcc.arg_info = fix_to_int(z.obj);

    set_reg(x.obj);
}

