/*
 * compaction.c - 
 */

/*
 * $Id: compaction.c,v 1.3 2005/05/31 08:31:03 komiya Exp $
 *
 *
 *   compaction programme
 *      developed from 1990.8.7
 *                to   1990.8.13
 *             Mikio Yamamoto
 *
 */

static char *RCSid="$Id: compaction.c,v 1.3 2005/05/31 08:31:03 komiya Exp $";

#include "scheme.h"

#ifdef GC_TIME
#include <sys/time.h>
#include <sys/resource.h>
#endif


#define     GC_SUCCESS              1
#define     GC_FAIL                 0
#define     C_MARK_MASK             0x2
#define     A_MARK_MASK             0x1
#define     C_A_MARK_MASK           0x3
#define     C_MARK                  0x2
#define     A_MARK                  0x1
#define     C_A_MARK                0x3
#define     TAG_AND_MARK_MASK       0xfc000003
#define     TAG_AND_ADDRESS_MASK    0xfffffffc
#define     ADDRESS_AND_MARK_MASK   0x03ffffff
#define     OTHER_C_MARK_MASK       0xfffffffd


/* global variable */
/*
entity_base :
entity_fin :
entity_area_size :
max_eintity_area_size :
entity_end :
extent_rate :
*/
/*

   /|\        /|\               ----------------- entity_base
    |          |                |///////////////|
    |          |                |               |
    |   entity_area_size        |///////////////|
    |          |                |               |
    |         \|/               |---------------| entity_end
    |                           |               |
  max_entity_area_size          |               |
    |                           |               |
    |                           |               |
   \|/               entity_fin -----------------
*/

#if defined(THINK_C) || defined(MACHTEN)
static unsigned a2, a3, a4, a5;
static unsigned d3, d4;
#else
unsigned a2, a3, a4, a5;
unsigned d3, d4;
#endif
#if defined(THINK_C) || defined(MACHTEN) || defined(__CYGWIN32__)
#define G_VAR_NUM (100+SHARP_EQ_CONTEXT_SIZE*3+2) /* The # of global variable and regs */
char g_var_gc_tmp_tmp[G_VAR_NUM * sizeof(unsigned *) + 4];
unsigned *g_var_gc_tmp;
int g_var_gc_idx;
void add_dis(unsigned *, int);
#endif

unsigned *compaction();
unsigned *pass2p();

extern int  message_level;
extern sharp_eq_context_max;
extern SHARP_EQ_CONTEXT_STRUCT sharp_eq_context[];

reverse(p)
unsigned *p;
{
    unsigned *p2;
    int obj;

    p2 = (unsigned *)ADDRESS(*p);
    if (*p2 & C_MARK_MASK) {
        *p = ((unsigned)ADDRESS(*p2)) | (*p & A_MARK_MASK);
        *p2 = (TAG_AND_MARK_MASK & *p2) | SSERDDA(p);
    } else {
        obj = *p;
        *p = (TAG_AND_ADDRESS_MASK & *p2) | C_MARK | (obj & A_MARK_MASK);
        *p2 = GETtag(obj) | SSERDDA(p) | C_A_MARK;
    }
}

#if defined(THINK_C) || defined(MACHTEN) || defined(__CYGWIN32__)
if_pobj_reverse_g_var(p)
unsigned *p;
{
    g_var_gc_tmp[g_var_gc_idx] = *p;
    p = g_var_gc_tmp + g_var_gc_idx++;
    if ((int)GETtag(*p) <= 0)
        reverse(p);
}
#endif

if_pobj_reverse(p)
unsigned *p;
{
    if ((int)GETtag(*p) <= 0)
        reverse(p);
}


re_reverse(p, new_address)
unsigned *p;
unsigned *new_address;
{
    unsigned *p2;
    unsigned *p_temp;
    int m_obj;

    p2 = (unsigned *)ADDRESS(*p);
    m_obj = GETtag(*p) | SSERDDA(new_address);
    while (!(C_MARK_MASK & *p2)) {
        p_temp = (unsigned *)ADDRESS(*p2);
        *p2 = m_obj | (*p2 & A_MARK_MASK);
        p2 = p_temp;
    }
    *p = (*p2 & OTHER_C_MARK_MASK) | A_MARK;
    *p2 = m_obj | (*p2 & A_MARK_MASK);
}


unsigned *compaction(vacancy_size, req_size)
int vacancy_size;
int req_size;
{
    int c_strbuf_flag, temp;
    unsigned *wpl;

#ifdef GC_TIME
    struct rusage ru;
    long sec, usec;
    extern gc_time_sec, gc_time_usec;

    getrusage(RUSAGE_SELF, &ru);
    sec = ru.ru_utime.tv_sec;
    usec = ru.ru_utime.tv_usec;
#endif

#if defined(THINK_C) || defined(MACHTEN)
    g_var_gc_tmp = (unsigned *)(g_var_gc_tmp_tmp + ((unsigned)g_var_gc_tmp_tmp% 4));
#endif
#if defined(THINK_C) || defined(MACHTEN) || defined(__CYGWIN32__)
    g_var_gc_idx = 0;
#endif

    a2 = (unsigned)a2_val();
    if (a2 != LTAG_NIL)
        a2 = SSERDDA(a2) | LTAG_STRING;
    a3 = (unsigned)active_val();
    a4 = (unsigned)base_val();
    a5 = (unsigned)top_val();
    d3 = (unsigned)reg_val();
    d4 = (unsigned)d4_val();

    c_strbuf_flag = OFF;

    if (message_level)
        print_con("compaction start\n");

    wpl = (unsigned *)get_sval(wplist.obj);
    while (GETtag(wpl) != LTAG_NIL) {
        wpl = (unsigned *)ADDRESS(wpl);
        *(wpl + 2) = *(wpl + 4);
        *(wpl + 4) = LTAG_BLOCK2 | A_MARK;
        wpl = (unsigned *) * (wpl + 2);
    }
    /*  
  if ((wpl = (unsigned *)get_sval(wplist.obj)) != LTAG_NIL)
      set_sval(wplist.obj, (unsigned)wpl | LTAG_WEAKPAIR);
*/

    if (message_level >= 2)
        print_con("compaction_init_hash\n");
    compaction_init_hash();
    compaction_init_global_var();
#if defined(THINK_C) || defined(MACHTEN) || defined(__CYGWIN32__)
    {
	int i;
	
	for (i = 0; i < sharp_eq_context_max; i++) {
	    if_pobj_reverse_g_var(&(sharp_eq_context[i].sharp_index));
	    if_pobj_reverse_g_var(&(sharp_eq_context[i].sharp_eq));
	    if_pobj_reverse_g_var(&(sharp_eq_context[i].sharp_sharp));
	}
    }
#else
    {
	int i;
	
	for (i = 0; i < sharp_eq_context_max; i++) {
	    if_pobj_reverse(&(sharp_eq_context[i].sharp_index));
	    if_pobj_reverse(&(sharp_eq_context[i].sharp_eq));
	    if_pobj_reverse(&(sharp_eq_context[i].sharp_sharp));
	}
    }
#endif
    if (c_strbuf != strbuf) {
        c_strbuf = (char *)(SSERDDA(c_strbuf) | LTAG_STRING);
        c_strbuf_flag = ON;
        reverse((unsigned *)&c_strbuf);
    }
#if defined(THINK_C) || defined(MACHTEN) || defined(__CYGWIN32__)
    if_pobj_reverse_g_var(&a2);
    if_pobj_reverse_g_var(&d3);
#else
    if_pobj_reverse(&a2);
    if_pobj_reverse(&d3);
#endif
#ifdef CALLIOC
    {
        unsigned *sb;

        for (sb = active_stacks; sb != NULL; sb = (unsigned *)(sb[3]))
            compaction_init_stack(sb);
    }
#else
    compaction_init_stack();
#endif

    pass1(vacancy_size);
    pass2();
    last_entity = (unsigned *)pass3(vacancy_size);
    /*
  if ((wpl = (unsigned *)get_sval(wplist.obj)) != LTAG_NIL)
      set_sval(wplist.obj, ADDRESS(wpl));
*/
    wpl = (unsigned *)get_sval(wplist.obj);
    while (GETtag(wpl) != LTAG_NIL) {
        wpl = (unsigned *)ADDRESS(wpl);
        *(wpl + 4) = *(wpl + 2);
        *(wpl + 2) = LTAG_BLOCK2 | 8;
        wpl = (unsigned *) * (wpl + 4);
    }

    if (message_level)
        print_con("compaction end\n");

    if (a2 == LTAG_NIL)
        set_a2(LTAG_NIL);
    else
        set_a2(ADDRESS(a2));
    if (c_strbuf_flag == ON)
        c_strbuf = (char *)ADDRESS(c_strbuf);
    set_active(a3);
    set_base(a4);
    set_top(a5);
    set_reg(d3);
    set_pc(d4);
#ifdef GC_TIME
    getrusage(RUSAGE_SELF, &ru);
    gc_time_sec += (ru.ru_utime.tv_sec - sec);
    gc_time_usec += (ru.ru_utime.tv_usec - usec);
#endif
    return(last_entity);
}


compaction_init_hash()
{
    int i;
    for (i = 0; i < hash_table_size; ++i) {
        if ((int)GETtag(*(hash_table + i)) <= 0)
            reverse(hash_table + i);
    }
    for (i = 0; i < bchashsize; ++i) {
        if ((int)GETtag(*(bchash + i)) <= 0)
            reverse(bchash + i);
    }
}

#ifdef CALLIOC
compaction_init_stack(bottom)
unsigned *bottom;
{
    unsigned *base, *top;

    if (bottom == (unsigned *)stack_bottom) {
        unsigned *old_top_p, *old_top1_p;

        base = (unsigned *)a4;
        top = (unsigned *)a5;
        old_top_p = (unsigned *)old_top;
        old_top1_p = (unsigned *)old_top1;
        while (old_top_p != old_top1_p) {
            while (top != old_top1_p) {
                if ((int)GETtag(*top) <= 0)
                    reverse(top);
                top++;
            }
            old_top1_p = (unsigned *)(*top);
            top++;
        }
    } else {
        base = top = (unsigned *)bottom[1];
        if ((int)GETtag(bottom[0]) <= 0)
            reverse(bottom);
    }

    while (base != 0) {
        while (base != top) {
            if ((int)GETtag(*top) <= 0)
                reverse(top);
            top++;
        }
        base = (unsigned *)(*top);
        top = top + 4;
    }
}
#else
compaction_init_stack()
{
    unsigned *base, *top;
    unsigned *old_top_p, *old_top1_p;
    int i;
    i = 0;
    base = (unsigned *)a4;
    top = (unsigned *)a5;
    old_top_p = (unsigned *)old_top;
    old_top1_p = (unsigned *)old_top1;
    while (old_top_p != old_top1_p) {
        while (top != old_top1_p) {
            if ((int)GETtag(*top) <= 0)
                reverse(top);
            top++;
        }
        old_top1_p = (unsigned *)(*top);
        top++;
    }
    while (base != 0) {
        while (base != top) {
            if ((int)GETtag(*top) <= 0)
                reverse(top);
            top++;
        }
        base = (unsigned *)(*top);
        top = top + 4;
    }
}
#endif

#if defined(THINK_C) || defined(MACHTEN) || defined(__CYGWIN32__)
resume(sym)
unsigned *sym;
{
    *sym = g_var_gc_tmp[g_var_gc_idx++];
}

resume_g_var()
{
/*
 *  NOTE!! : Each entry (argument for resume()) must be same order
 *           of if_pobj_reverse()'s entry in compaction_init_global_var().
 *           c.f. G_VAR_NUM
 */

    g_var_gc_idx = 0;
    resume((unsigned *)&quotesym);
    resume((unsigned *)&qquotesym);
    resume((unsigned *)&atsym);
    resume((unsigned *)&commasym);
    
    resume((unsigned *)&definesym);
    resume((unsigned *)&macrosym);
    resume((unsigned *)&xreturnsym);
    resume((unsigned *)&lreturnsym);
    resume((unsigned *)&xcallsym);
    resume((unsigned *)&c_f_sym);
    resume((unsigned *)&mkncsym);
    resume((unsigned *)&sctopsym);
    resume((unsigned *)&errsym);		/* By N.Watanabe 92/11/19 */
    resume((unsigned *)&recomsym);		/* By A243 */
    resume((unsigned *)&recomlevel);		/* By A243 */
#ifdef PVM3
    resume((unsigned *)&bctran_exec_form_sym);     /* By A243 */
    resume((unsigned *)&sharp_closure_pvm);        /* By A243 */
    resume((unsigned *)&pvm_recv_function);        /* By A243 */
    resume((unsigned *)&pvm_reduce_function);        /* By A243 */
    resume((unsigned *)&pvm_get_unbound_obj);        /* By A243 */
    resume((unsigned *)&pvm_put_unbound_obj);        /* By A243 */
#endif
    resume((unsigned *)&debugsym);
    resume((unsigned *)&user_exec_sym);
    resume((unsigned *)&sys_debug_sym);
    resume((unsigned *)&bcloadsym);
    resume((unsigned *)&bc_trace_proc_sym);
    resume((unsigned *)&sysfun_tracer_body);
    resume((unsigned *)&max_back_trace_depth_sym);
    resume((unsigned *)&gc_message_level_sym);
    resume((unsigned *)&msgc_to_copygc_sym);
    resume((unsigned *)&struct_sym);
    resume((unsigned *)&l_t_e_sym);
#ifdef PVM3
    resume((unsigned *)&pvm_l_t_e_sym);     /* By A243 */
#endif
    resume((unsigned *)&local_fun_sym);
    resume((unsigned *)&beginsym);
    resume((unsigned *)&bcload_with_cip_sym);
    
    /* 2nd: the other object which the scheme system hold */
    resume((unsigned *)&unbound_obj);
    resume((unsigned *)&eof_obj);
    resume((unsigned *)&reg1);
    resume((unsigned *)&reg2);
    resume((unsigned *)&reg3);
    resume((unsigned *)&stdin_port);
    resume((unsigned *)&stdout_port);
    resume((unsigned *)&c_in_port);
    resume((unsigned *)&c_out_port);
    resume((unsigned *)&bcconst);
    resume((unsigned *)&xfunconst);
    resume((unsigned *)&bcraw);
    resume((unsigned *)&bcraw2);
    resume((unsigned *)&bcbody);
    resume((unsigned *)&acode);
    resume((unsigned *)&tempp);
    resume((unsigned *)&cdrbody);
    resume((unsigned *)&bcf);
    resume((unsigned *)&bcfhead);
    resume((unsigned *)&call_cc_arg);
    resume((unsigned *)&top_of_aflk);
    resume((unsigned *)&end_of_aflk);
    resume((unsigned *)&af_tmp);
    resume((unsigned *)&more);
#ifdef CTHREAD
    resume((unsigned *)&optcnt);
#endif
    resume((unsigned *)&portlist);
    resume((unsigned *)&ncclist);
    resume((unsigned *)&wplist);

#ifdef TCPIP
    resume (&conn_timeout);
    resume (&tcp_timeout);
    resume (&udp_timeout);
    resume (&accept_timeout);
    resume (&localhostname);
#endif

#ifdef NIHONGO
    resume((unsigned *)&default_kanji_input_code_sym);
    resume((unsigned *)&default_kanji_output_code_sym);
#ifdef TCPIP
    resume((unsigned *)&default_network_kanji_input_code_sym);
    resume((unsigned *)&default_network_kanji_output_code_sym);
#endif
    resume((unsigned *)&euc_sym);
    resume((unsigned *)&jis_sym);
    resume((unsigned *)&sjis_sym);
    resume((unsigned *)&noc_sym);
#endif

    resume((unsigned *)&print_circle_sym);	/* By ushijima */

    if (system_function_loading_flag == ON)
        resume(&protect_symbol_listsym);
}

compaction_init_global_var()    /* for Macintosh */
{

    /* 1st : the symbol which the scheme system hold  initialize. */
    if_pobj_reverse_g_var((unsigned *)&quotesym);
    if_pobj_reverse_g_var((unsigned *)&qquotesym);
    if_pobj_reverse_g_var((unsigned *)&atsym);
    if_pobj_reverse_g_var((unsigned *)&commasym);

    /*
  if_pobj_reverse_g_var(&loadsym);
  if_pobj_reverse_g_var(&dumpsym);
  if_pobj_reverse_g_var(&setsym);
  if_pobj_reverse_g_var(&endsym);
  if_pobj_reverse_g_var(&breakfunsym);
  if_pobj_reverse_g_var(&breaknumsym);
  if_pobj_reverse_g_var(&tracesym);
  if_pobj_reverse_g_var(&untracesym);
  if_pobj_reverse_g_var(&gctracesym);
  if_pobj_reverse_g_var(&ungctracesym);
  if_pobj_reverse_g_var(&pctracesym);
  if_pobj_reverse_g_var(&unpctracesym);
  if_pobj_reverse_g_var(&settracesym);
  if_pobj_reverse_g_var(&breakpointsym);
  if_pobj_reverse_g_var(&dumppointsym);
  if_pobj_reverse_g_var(&stacksym);
*/

    if_pobj_reverse_g_var((unsigned *)&definesym);
    if_pobj_reverse_g_var((unsigned *)&macrosym);
    if_pobj_reverse_g_var((unsigned *)&xreturnsym);
    if_pobj_reverse_g_var((unsigned *)&lreturnsym);
    if_pobj_reverse_g_var((unsigned *)&xcallsym);
    if_pobj_reverse_g_var((unsigned *)&c_f_sym);
    if_pobj_reverse_g_var((unsigned *)&mkncsym);
    if_pobj_reverse_g_var((unsigned *)&sctopsym);
    if_pobj_reverse_g_var((unsigned *)&errsym);	/* By N.Watanabe 92/11/19 */
    if_pobj_reverse_g_var((unsigned *)&recomsym);	/* By A243 */
    if_pobj_reverse_g_var((unsigned *)&recomlevel);	/* By A243 */
#ifdef PVM3
    if_pobj_reverse_g_var((unsigned *)&bctran_exec_form_sym);	/* By A243 *
    if_pobj_reverse_g_var((unsigned *)&sharp_closure_pvm);	/* By A243 */
    if_pobj_reverse_g_var((unsigned *)&pvm_recv_function);	/* By A243 */
    if_pobj_reverse_g_var((unsigned *)&pvm_reduce_function);	/* By A243 */
    if_pobj_reverse_g_var((unsigned *)&pvm_get_unbound_obj);	/* By A243 */
    if_pobj_reverse_g_var((unsigned *)&pvm_put_unbound_obj);	/* By A243 */
#endif
    if_pobj_reverse_g_var((unsigned *)&debugsym);
    if_pobj_reverse_g_var((unsigned *)&user_exec_sym);
    if_pobj_reverse_g_var((unsigned *)&sys_debug_sym);
    if_pobj_reverse_g_var((unsigned *)&bcloadsym);
    if_pobj_reverse_g_var((unsigned *)&bc_trace_proc_sym);
    if_pobj_reverse_g_var((unsigned *)&sysfun_tracer_body);
    if_pobj_reverse_g_var((unsigned *)&max_back_trace_depth_sym);
    if_pobj_reverse_g_var((unsigned *)&gc_message_level_sym);
    if_pobj_reverse_g_var((unsigned *)&msgc_to_copygc_sym);
    if_pobj_reverse_g_var((unsigned *)&struct_sym);
    if_pobj_reverse_g_var((unsigned *)&l_t_e_sym);
#ifdef PVM3
    if_pobj_reverse_g_var((unsigned *)&pvm_l_t_e_sym);     	/* By A243 */
#endif
    if_pobj_reverse_g_var((unsigned *)&local_fun_sym);
    if_pobj_reverse_g_var((unsigned *)&beginsym);
    if_pobj_reverse_g_var((unsigned *)&bcload_with_cip_sym);

    /* 2nd: the other object which the scheme system hold */
    if_pobj_reverse_g_var((unsigned *)&unbound_obj);
    if_pobj_reverse_g_var((unsigned *)&eof_obj);
    if_pobj_reverse_g_var((unsigned *)&reg1);
    if_pobj_reverse_g_var((unsigned *)&reg2);
    if_pobj_reverse_g_var((unsigned *)&reg3);
    if_pobj_reverse_g_var((unsigned *)&stdin_port);
    if_pobj_reverse_g_var((unsigned *)&stdout_port);
    if_pobj_reverse_g_var((unsigned *)&c_in_port);
    if_pobj_reverse_g_var((unsigned *)&c_out_port);
    if_pobj_reverse_g_var((unsigned *)&bcconst);
    if_pobj_reverse_g_var((unsigned *)&xfunconst);
    if_pobj_reverse_g_var((unsigned *)&bcraw);
    if_pobj_reverse_g_var((unsigned *)&bcraw2);
    if_pobj_reverse_g_var((unsigned *)&bcbody);
    if_pobj_reverse_g_var((unsigned *)&acode);
    if_pobj_reverse_g_var((unsigned *)&tempp);
    if_pobj_reverse_g_var((unsigned *)&cdrbody);
    if_pobj_reverse_g_var((unsigned *)&bcf);
    if_pobj_reverse_g_var((unsigned *)&bcfhead);
    if_pobj_reverse_g_var((unsigned *)&call_cc_arg);
    if_pobj_reverse_g_var((unsigned *)&top_of_aflk);
    if_pobj_reverse_g_var((unsigned *)&end_of_aflk);
    if_pobj_reverse_g_var((unsigned *)&af_tmp);
    if_pobj_reverse_g_var((unsigned *)&more);
#ifdef CTHREAD
    if_pobj_reverse_g_var((unsigned *)&optcnt);
#endif
    if_pobj_reverse_g_var((unsigned *)&portlist);
    if_pobj_reverse_g_var((unsigned *)&ncclist);
    if_pobj_reverse_g_var((unsigned *)&wplist);

#ifdef TCPIP
    if_pobj_reverse_g_var (&conn_timeout);
    if_pobj_reverse_g_var (&tcp_timeout);
    if_pobj_reverse_g_var (&udp_timeout);
    if_pobj_reverse_g_var (&accept_timeout);
    if_pobj_reverse_g_var (&localhostname);
#endif

#ifdef NIHONGO
    if_pobj_reverse_g_var((unsigned *)&default_kanji_input_code_sym);
    if_pobj_reverse_g_var((unsigned *)&default_kanji_output_code_sym);
#ifdef TCPIP
    if_pobj_reverse_g_var((unsigned *)&default_network_kanji_input_code_sym);
    if_pobj_reverse_g_var((unsigned *)&default_network_kanji_output_code_sym);
#endif
    if_pobj_reverse_g_var((unsigned *)&euc_sym);
    if_pobj_reverse_g_var((unsigned *)&jis_sym);
    if_pobj_reverse_g_var((unsigned *)&sjis_sym);
    if_pobj_reverse_g_var((unsigned *)&noc_sym);
#endif

    if_pobj_reverse_g_var((unsigned *)&print_circle_sym);	/* By ushijima */

    if (system_function_loading_flag == ON)
        if_pobj_reverse_g_var(&protect_symbol_listsym);
}

#else

compaction_init_global_var()
{

    /* 1st : the symbol which the scheme system hold  initialize. */
    if_pobj_reverse(&quotesym);
    if_pobj_reverse(&qquotesym);
    if_pobj_reverse(&atsym);
    if_pobj_reverse(&commasym);

    /*
  if_pobj_reverse(&loadsym);
  if_pobj_reverse(&dumpsym);
  if_pobj_reverse(&setsym);
  if_pobj_reverse(&endsym);
  if_pobj_reverse(&breakfunsym);
  if_pobj_reverse(&breaknumsym);
  if_pobj_reverse(&tracesym);
  if_pobj_reverse(&untracesym);
  if_pobj_reverse(&gctracesym);
  if_pobj_reverse(&ungctracesym);
  if_pobj_reverse(&pctracesym);
  if_pobj_reverse(&unpctracesym);
  if_pobj_reverse(&settracesym);
  if_pobj_reverse(&breakpointsym);
  if_pobj_reverse(&dumppointsym);
  if_pobj_reverse(&stacksym);
*/

    if_pobj_reverse(&definesym);
    if_pobj_reverse(&macrosym);
    if_pobj_reverse(&xreturnsym);
    if_pobj_reverse(&lreturnsym);
    if_pobj_reverse(&xcallsym);
    if_pobj_reverse(&c_f_sym);
    if_pobj_reverse(&mkncsym);
    if_pobj_reverse(&sctopsym);
    if_pobj_reverse(&errsym);		/* By N.Watanabe 92/11/19 */
    if_pobj_reverse(&recomsym);		/* By A243 */
    if_pobj_reverse(&recomlevel);		/* By A243 */
#ifdef PVM3
    if_pobj_reverse(&bctran_exec_form_sym);		/* By A243 */    
    if_pobj_reverse(&sharp_closure_pvm);		/* By A243 */    
    if_pobj_reverse(&pvm_recv_function);		/* By A243 */    
    if_pobj_reverse(&pvm_reduce_function);		/* By A243 */    
    if_pobj_reverse(&pvm_get_unbound_obj);		/* By A243 */    
    if_pobj_reverse(&pvm_put_unbound_obj);		/* By A243 */    
#endif
    if_pobj_reverse(&debugsym);
    if_pobj_reverse(&user_exec_sym);
    if_pobj_reverse(&sys_debug_sym);
    if_pobj_reverse(&bcloadsym);
    if_pobj_reverse(&bc_trace_proc_sym);
    if_pobj_reverse(&sysfun_tracer_body);
    if_pobj_reverse(&max_back_trace_depth_sym);
    if_pobj_reverse(&gc_message_level_sym);
    if_pobj_reverse(&msgc_to_copygc_sym);
    if_pobj_reverse(&struct_sym);
    if_pobj_reverse(&l_t_e_sym);	
#ifdef PVM3
    if_pobj_reverse(&pvm_l_t_e_sym);	/* By A243 */
#endif
    if_pobj_reverse(&local_fun_sym);
    if_pobj_reverse(&beginsym);
    if_pobj_reverse(&bcload_with_cip_sym);

    /* 2nd: the other object which the scheme system hold */
    if_pobj_reverse(&unbound_obj);
    if_pobj_reverse(&eof_obj);
    if_pobj_reverse(&reg1);
    if_pobj_reverse(&reg2);
    if_pobj_reverse(&reg3);
    if_pobj_reverse(&stdin_port);
    if_pobj_reverse(&stdout_port);
    if_pobj_reverse(&c_in_port);
    if_pobj_reverse(&c_out_port);
    if_pobj_reverse(&bcconst);
    if_pobj_reverse(&xfunconst);
    if_pobj_reverse(&bcraw);
    if_pobj_reverse(&bcraw2);
    if_pobj_reverse(&bcbody);
    if_pobj_reverse(&acode);
    if_pobj_reverse(&tempp);
    if_pobj_reverse(&cdrbody);
    if_pobj_reverse(&bcf);
    if_pobj_reverse(&bcfhead);
    if_pobj_reverse(&call_cc_arg);
    if_pobj_reverse(&top_of_aflk);
    if_pobj_reverse(&end_of_aflk);
    if_pobj_reverse(&af_tmp);
    if_pobj_reverse(&more);
#ifdef CTHREAD
    if_pobj_reverse(&optcnt);
#endif
    if_pobj_reverse(&portlist);
    if_pobj_reverse(&ncclist);
    if_pobj_reverse(&wplist);

#ifdef TCPIP
    if_pobj_reverse (&conn_timeout);
    if_pobj_reverse (&tcp_timeout);
    if_pobj_reverse (&udp_timeout);
    if_pobj_reverse (&accept_timeout);
    if_pobj_reverse (&localhostname);
#endif

#ifdef NIHONGO
    if_pobj_reverse(&default_kanji_input_code_sym);
    if_pobj_reverse(&default_kanji_output_code_sym);
#ifdef TCPIP
    if_pobj_reverse(&default_network_kanji_input_code_sym);
    if_pobj_reverse(&default_network_kanji_output_code_sym);
#endif
    if_pobj_reverse(&euc_sym);
    if_pobj_reverse(&jis_sym);
    if_pobj_reverse(&sjis_sym);
    if_pobj_reverse(&noc_sym);
#endif

    if_pobj_reverse(&print_circle_sym);		/* By ushijima */

    if (system_function_loading_flag == ON)
        if_pobj_reverse(&protect_symbol_listsym);
}
#endif

pass1(vacancy_size)
int vacancy_size;
{
    unsigned *p;
    unsigned *c_bottom;
    int block1_size;
    int block2_size;
    char    messtr[256];

    if (message_level >= 2) {
        sprintf(messtr, "start pass1: entity_base=%x, entity_end=%x, vacancy_size=%x\n",
            entity_base, entity_end, vacancy_size);
        print_con(messtr);
    }

    p = entity_base;
    c_bottom = (unsigned *)(((char *)entity_base) + vacancy_size);
    while (p < entity_end) {
        if (*p & A_MARK_MASK) {
            if (*p & C_MARK_MASK)
                re_reverse(p, c_bottom);
            switch (GETtag(*p)) {
            case LTAG_BLOCK2 :
                ac_block2++;
                block2_size = (int)IMM(*p);
                block2_exchange(p, block2_size);
                p = (unsigned *)(((char *)p) + block2_size + 4);
                c_bottom = (unsigned *)(((char *)c_bottom) + block2_size + 4);
                break;
            case LTAG_BLOCK1 :
                ac_block1++;
                block1_size = pass1p(p);
                p = (unsigned *)(((char *)p) + block1_size + 4);
                c_bottom = (unsigned *)(((char *)c_bottom) + block1_size + 4);
                break;
            default :
                ac_cons++;
                if ((int)GETtag(*p) <= 0) {
                    if ((unsigned *)ADDRESS(*p) > p)
                        reverse(p);
                }
                p = p + 1;
                if ((int)GETtag(*p) <= 0) {
                    if ((unsigned *)ADDRESS(*p) > p)
                        reverse(p);
                }
                p = p + 1;
                c_bottom = c_bottom + 2;
            }
        } else {
            if (GETtag(*p) == LTAG_BLOCK2) { /* consistency check (not necessary) */
                block2_size = (int)IMM(*p);
                if (block2_size != 0)
                    block2_exchange(p, block2_size);
                p = (unsigned *)(((char *)p) + block2_size + 4);
            } else {
                print_con("system error!!!!!! there is non-marked non-block2 object\n");
                sprintf(messtr, "p:%x, *p:%x\n", p, *p);
                print_con(messtr);
                p = p + 1;
            }
        }
    } /* while */
} /* pass1 */


block2_exchange(p, block2_size)
unsigned *p;
int block2_size;
{
    int block2_end_word;
    block2_end_word = *((unsigned *)((char *)p + block2_size));
    *((unsigned *)((char *)p + block2_size)) = 
        (*p & TAG_AND_ADDRESS_MASK) | (block2_end_word & C_A_MARK_MASK);
    *p = (block2_end_word & TAG_AND_ADDRESS_MASK) | (*p & A_MARK_MASK);
}


block2_re_exchange(p, block2_top)
unsigned *p;
unsigned *block2_top;
{
    int block2_end_word;
    block2_end_word = (*block2_top & TAG_AND_ADDRESS_MASK) | (*p & C_A_MARK_MASK);
    *block2_top = (*p & TAG_AND_ADDRESS_MASK) | (*block2_top & A_MARK_MASK);
    *p = block2_end_word;
}


block2_exchange_in_block1(p)
unsigned *p;
{
    int block2_end_word;
    int block2_size;

    block2_size = IMM(*p);
    if (block2_size == 0)
        *p = LTAG_GCFORWARD;
    else {
        block2_end_word = *((unsigned *)((char *)p + block2_size));
        *((unsigned *)((char *)p + block2_size)) = LTAG_GCFORWARD | block2_size;
        *p = block2_end_word;
    }
    return(block2_size);
}


block2_re_exchange_in_block1(p, block2_top)
unsigned *p;
unsigned *block2_top;
{
    int block2_end_word;

    if (p == block2_top)
        *p = LTAG_BLOCK2 | A_MARK;
    else {
        block2_end_word = *block2_top;
        *block2_top = IMM(*p) | LTAG_BLOCK2 | A_MARK;
        *p = block2_end_word;
    }
}


pass1p(p)
unsigned *p;
{
    int block1_size;
    unsigned *top_p;
    top_p = p;
    block1_size = IMM(*p);
    p = p + 1;
    while (!(*p & A_MARK_MASK)) {
        if (((int)GETtag(*p) <= 0) && ((unsigned *)ADDRESS(*p) > p))
            reverse(p);
        p = p + 1;
    }
    if (GETtag(*p) == LTAG_BLOCK2) {
        p = (unsigned *)(((char *)p) + block2_exchange_in_block1(p));
    } else if (((int)GETtag(*p) <= 0) && ((unsigned *)ADDRESS(*p) > p))
        reverse(p);
    return(block1_size);
}


pass2()
{
    unsigned *p;
    unsigned *c_bottom;
    int block2_size;
    unsigned *block2_top;
    int block1_size;
    int escaped_top_word;

    if (message_level >= 2)
        print_con("start pass2: \n");

    p = entity_end - 1;
    c_bottom = entity_end;

    while (p >= entity_base) {
        switch (GETtag(*p)) {
        case LTAG_BLOCK2 :
            block2_size = IMM(*p);
            if (block2_size != 0) {
                block2_top = (unsigned *)(((char *)p) - block2_size);
                if (*block2_top & A_MARK_MASK) {
                    if (*block2_top & C_MARK_MASK)
                        re_reverse(block2_top,
                            (unsigned *)(((char *)c_bottom) -block2_size - 4));
                    block2_re_exchange(p, block2_top);
                    p = block2_top - 1;
                    c_bottom = (unsigned *)(((char *)c_bottom)-block2_size-4);
                } else {
                    block2_re_exchange(p, block2_top);
                    p = block2_top - 1;
                }
            } else {
                p = p - 1;
            }
            break;
        case LTAG_GCFORWARD :
            block2_top = (unsigned *)(((char *)p) - IMM(*p));
            block2_re_exchange_in_block1(p, block2_top);
            p = pass2p(block2_top - 1);
            if (*p & C_MARK_MASK) {
                escaped_top_word = get_escaped_word(p); /* MARK bits are all 0 */
                c_bottom = 
                    (unsigned *)(((char *)c_bottom) - (int)IMM(escaped_top_word) - 4);
                re_reverse(p, c_bottom);
            } else {
                c_bottom = 
                    (unsigned *)(((char *)c_bottom) - (int)IMM(*p) - 4);
            }
            p = p - 1;
            break;
        default :
            if (((int)GETtag(*p) <= 0) && ((unsigned *)ADDRESS(*p) < p))
                reverse(p);
            p = pass2p(p - 1);
            if (*p & C_MARK_MASK) {
                escaped_top_word = get_escaped_word(p); /* MARK bits are all 0 */
                if (GETtag(escaped_top_word) == LTAG_BLOCK1)
                    c_bottom = 
                        (unsigned *)(((char *)c_bottom) - (int)IMM(escaped_top_word) - 4);
                else
                    c_bottom = c_bottom - 2;
                re_reverse(p, c_bottom);
                if (((int)GETtag(*p) <= 0) && ((unsigned *)ADDRESS(*p) < p))
                    reverse(p);
                else if (((int)GETtag(*p) <= 0) && ((unsigned *)ADDRESS(*p) == p))
                    *p = GETtag(*p) | SSERDDA(c_bottom) | A_MARK;
                p = p - 1;
            } else {
                if (GETtag(*p) == LTAG_BLOCK1) {
                    c_bottom = (unsigned *)(((char *)c_bottom) - (int)IMM(*p) - 4);
                    p = p - 1;
                } else {
                    c_bottom = c_bottom - 2;
                    if ((int)GETtag(*p) <= 0) {
                        if ((unsigned *)ADDRESS(*p) < p)
                            reverse(p);
                        else if ((unsigned *)ADDRESS(*p) == p)
                            *p = GETtag(*p) | SSERDDA(c_bottom) | A_MARK;
                    }
                    p = p - 1;
                }
            }
            break;
        } /* switch */
    } /* while */
}


unsigned *pass2p(p)
unsigned *p;
{
    while (!(*p & A_MARK_MASK)) {
        if (((int)GETtag(*p) <= 0) && ((unsigned *)ADDRESS(*p) < p))
            reverse(p);
        p = p - 1;
    }
    return(p);
}


get_escaped_word(p)
unsigned *p;
{
    unsigned *p2;
    p2 = (unsigned *)ADDRESS(*p);
    while (!(*p2 & C_MARK_MASK))
        p2 = (unsigned *)ADDRESS(*p2);
    return(*p2 & TAG_AND_ADDRESS_MASK);
}


pass3(vacancy_size)
int vacancy_size;
{
    unsigned *p;
    unsigned *p2;
    int size;
    int i;

    if (message_level >= 2)
        print_con("start pass3:\n");

    p = p2 = entity_base;
    while (p < entity_end) {
        if (*p & A_MARK_MASK) {
            switch (GETtag(*p)) {
            case LTAG_BLOCK1 :
                *(p2++) = *(p++) & TAG_AND_ADDRESS_MASK;
                while (!(*p & A_MARK_MASK)) {
                    if ((int)GETtag(*p) <= 0)
                        *(p2++) = *(p++) - vacancy_size;
                    else
                        *(p2++) = *(p++);
                }
                if (GETtag(*p) == LTAG_BLOCK2) {
                    size = IMM(*p) >> 2;
                    *(p2++) = *(p++) & TAG_AND_ADDRESS_MASK;
                    for (i = 0; i < size; i++)
                        *(p2++) = *(p++);
                } else {
                    if ((int)GETtag(*p) <= 0)
                        *(p2++) = (*(p++) - vacancy_size) & TAG_AND_ADDRESS_MASK;
                    else
                        *(p2++) = *(p++) & TAG_AND_ADDRESS_MASK;
                }
                break;
            case LTAG_BLOCK2 :
                size = IMM(*p) >> 2;
                *(p2++) = *(p++) & TAG_AND_ADDRESS_MASK;
                for (i = 0; i < size; i++)
                    *(p2++) = *(p++);
                break;
            default :
                if ((int)GETtag(*p) <= 0)
                    *(p2++) = (*(p++) - vacancy_size) & TAG_AND_ADDRESS_MASK;
                else
                    *(p2++) = *(p++) & TAG_AND_ADDRESS_MASK;
                if ((int)GETtag(*p) <= 0)
                    *(p2++) = (*(p++) - vacancy_size) & TAG_AND_ADDRESS_MASK;
                else
                    *(p2++) = *(p++) & TAG_AND_ADDRESS_MASK;
            }
        } else {
            if (GETtag(*p) == LTAG_BLOCK2)
                p = (unsigned *)(((char *)p) + (int)IMM(*p) + 4);
            else
                print_con("system error : There is dead area which is not block2 area(in pass3)\n");
        }
    }
    add_dis_pobj(vacancy_size);
    return((int)p2);
}


add_dis_pobj(dist)
int dist;
{
    int i;

#if defined(THINK_C) || defined(MACHTEN) || defined(__CYGWIN32__)
    resume_g_var();
    for (i = 0; i < sharp_eq_context_max; i++) {
	resume((unsigned *)&(sharp_eq_context[i].sharp_index.obj));
	resume((unsigned *)&(sharp_eq_context[i].sharp_eq.obj));
	resume((unsigned *)&(sharp_eq_context[i].sharp_sharp.obj));
    }
    resume((unsigned *)&a2);
    resume((unsigned *)&d3);
#endif
    add_dis((unsigned *)&quotesym, dist);
    add_dis((unsigned *)&qquotesym, dist);
    add_dis((unsigned *)&atsym, dist);
    add_dis((unsigned *)&commasym, dist);

    /*
  add_dis(&loadsym, dist);
  add_dis(&dumpsym, dist);
  add_dis(&setsym, dist);
  add_dis(&endsym, dist);
  add_dis(&breakfunsym, dist);
  add_dis(&breaknumsym, dist);
  add_dis(&tracesym, dist);
  add_dis(&untracesym, dist);
  add_dis(&gctracesym, dist);
  add_dis(&ungctracesym, dist);
  add_dis(&pctracesym, dist);
  add_dis(&unpctracesym, dist);
  add_dis(&settracesym, dist);
  add_dis(&breakpointsym, dist);
  add_dis(&dumppointsym, dist);
  add_dis(&stacksym, dist);
*/

    add_dis((unsigned *)&definesym, dist);
    add_dis((unsigned *)&macrosym, dist);
    add_dis((unsigned *)&xreturnsym, dist);
    add_dis((unsigned *)&lreturnsym, dist);
    add_dis((unsigned *)&xcallsym, dist);
    add_dis((unsigned *)&c_f_sym, dist);
    add_dis((unsigned *)&mkncsym, dist);
    add_dis((unsigned *)&sctopsym, dist);
    add_dis((unsigned *)&errsym, dist);	/* By N.Watanabe 92/11/19 */
    add_dis((unsigned *)&recomsym, dist);	/* By A243 */
    add_dis((unsigned *)&recomlevel, dist);	/* By A243 */
#ifdef PVM3
    add_dis((unsigned *)&bctran_exec_form_sym, dist);	/* By A243 */    
    add_dis((unsigned *)&sharp_closure_pvm, dist);	/* By A243 */    
    add_dis((unsigned *)&pvm_recv_function, dist);	/* By A243 */    
    add_dis((unsigned *)&pvm_reduce_function, dist);	/* By A243 */    
    add_dis((unsigned *)&pvm_get_unbound_obj, dist);	/* By A243 */    
    add_dis((unsigned *)&pvm_put_unbound_obj, dist);	/* By A243 */    
#endif
    add_dis((unsigned *)&debugsym, dist);
    add_dis((unsigned *)&user_exec_sym, dist);
    add_dis((unsigned *)&sys_debug_sym, dist);
    add_dis((unsigned *)&bcloadsym, dist);
    add_dis((unsigned *)&bc_trace_proc_sym, dist);
    add_dis((unsigned *)&sysfun_tracer_body, dist);
    add_dis((unsigned *)&max_back_trace_depth_sym, dist);
    add_dis((unsigned *)&gc_message_level_sym, dist);
    add_dis((unsigned *)&msgc_to_copygc_sym, dist);
    add_dis((unsigned *)&struct_sym, dist);
    add_dis((unsigned *)&l_t_e_sym, dist);
#ifdef PVM3
    add_dis((unsigned *)&pvm_l_t_e_sym, dist);       /* By A243 */
#endif
    add_dis((unsigned *)&local_fun_sym, dist);
    add_dis((unsigned *)&beginsym, dist);
    add_dis((unsigned *)&bcload_with_cip_sym, dist);

    add_dis((unsigned *)&unbound_obj, dist);
    add_dis((unsigned *)&eof_obj, dist);
    add_dis((unsigned *)&reg1, dist);
    add_dis((unsigned *)&reg2, dist);
    add_dis((unsigned *)&reg3, dist);
    add_dis((unsigned *)&stdin_port, dist);
    add_dis((unsigned *)&stdout_port, dist);
    add_dis((unsigned *)&c_in_port, dist);
    add_dis((unsigned *)&c_out_port, dist);
    add_dis((unsigned *)&bcconst, dist);
    add_dis((unsigned *)&xfunconst, dist);
    add_dis((unsigned *)&bcraw, dist);
    add_dis((unsigned *)&bcraw2, dist);
    add_dis((unsigned *)&bcbody, dist);
    add_dis((unsigned *)&acode, dist);
    add_dis((unsigned *)&tempp, dist);
    add_dis((unsigned *)&cdrbody, dist);
    add_dis((unsigned *)&bcf, dist);
    add_dis((unsigned *)&bcfhead, dist);
    add_dis((unsigned *)&call_cc_arg, dist);
    add_dis((unsigned *)&top_of_aflk, dist);
    add_dis((unsigned *)&end_of_aflk, dist);
    add_dis((unsigned *)&af_tmp, dist);
    add_dis((unsigned *)&more, dist);
#ifdef CTHREAD
    add_dis((unsigned *)&optcnt, dist);
#endif
    add_dis((unsigned *)&portlist, dist);
    add_dis((unsigned *)&ncclist, dist);
    add_dis((unsigned *)&wplist, dist);

#ifdef TCPIP
    add_dis (&conn_timeout, dist);
    add_dis (&tcp_timeout, dist);
    add_dis (&udp_timeout, dist);
    add_dis (&accept_timeout, dist);
    add_dis (&localhostname, dist);
#endif

#ifdef NIHONGO
    add_dis((unsigned *)&default_kanji_input_code_sym, dist);
    add_dis((unsigned *)&default_kanji_output_code_sym, dist);
#ifdef TCPIP
    add_dis((unsigned *)&default_network_kanji_input_code_sym, dist);
    add_dis((unsigned *)&default_network_kanji_output_code_sym, dist);
#endif
    add_dis((unsigned *)&euc_sym, dist);
    add_dis((unsigned *)&jis_sym, dist);
    add_dis((unsigned *)&sjis_sym, dist);
    add_dis((unsigned *)&noc_sym, dist);
#endif

    add_dis((unsigned *)&print_circle_sym, dist);	/* By ushijima */

    if (system_function_loading_flag == ON)
        add_dis(&protect_symbol_listsym, dist);

    {
	int i;

	for (i = 0; i < sharp_eq_context_max; i++) {
	    add_dis(&(sharp_eq_context[i].sharp_index.obj), dist);
	    add_dis(&(sharp_eq_context[i].sharp_eq.obj), dist);
	    add_dis(&(sharp_eq_context[i].sharp_sharp.obj), dist);
	}
    }
    for (i = 0; i < hash_table_size; ++i)
        add_dis(hash_table + i, dist);
    for (i = 0; i < bchashsize; ++i)
        add_dis( bchash + i , dist);
#ifdef ASMGC
    add_dist_stack(dist);
#else
# ifdef CALLIOC
    {
        unsigned *sb;

        for (sb = active_stacks; sb != NULL; sb = (unsigned *)(sb[3]))
            add_dist_stack(dist, sb);
    }
# else
    add_dist_stack(dist, (unsigned *)a4, (unsigned *)a5);
# endif
#endif
    if (a2 != LTAG_NIL)
        a2 = a2 - dist;
    if (c_strbuf != strbuf)
        c_strbuf = c_strbuf - dist;
    add_dis(&d3, dist);
}
