/*
 * control.c - 
 */

/*
 * $Id: control.c,v 1.7 2014/10/28 02:22:55 komiya Exp $
 *
 *    File Name : control.c
 *    (for the version written with C-language only.)
 *    map, mapcan, for-each, apply : Mikio Yamamoto  1990.10
 *                   Original version is mvscheme(Taiichi Yuasa).
 *    force : Mikio Yamamoto. 1990.11
 *                   Original version is written by Yass.
 *    some, every, notany, notevery : Mikio Yamamoto. 1990.10
 *    call/cc, procp, ... : Yass.
 *               the same as SUN3 version.
 */

static char *RCSid="$Id: control.c,v 1.7 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

int iretaddrx();
int iretaddrl();
int s_iretaddrx();

//#ifdef THINK_C
void foreach(int (*)(), int);
void prot_senn2(int (*)(), int, int);
void open_frame2(int (*)(), int, int);
//#endif

void set_up_stack();

#define OPEN_FRAME_PUSHES 5
#define ADJUST_STACK(n) { sp_reg = base_reg + OPEN_FRAME_PUSHES + (n); \
                          base_reg = active_reg; }
#define ADJUST_STACK_MAP() { sp_reg = base_reg + OPEN_FRAME_PUSHES; \
                             while (*sp_reg++ != LTAG_LOSTOBJ) \
                                 ; \
                             base_reg = active_reg; }

/*
 *    (map procedure arg-list1 arg-list2 ....)
 *
 */

void map(int (*)());
void map2();

void Smap()
{
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
    int map2_tch(), map2_ntch();

    if (GETtag(getarg(1)) == LTAG_SFUNCTION)
	map(map2_tch);
    else
	map(map2_ntch);
#else
    map(map2);
#endif
}


void map(cont_proc)
int (*cont_proc)();
{
    unsigned *oldtop;
    unsigned *p, q;
#ifdef CTHREAD
    int touch_obj();
#endif

#ifdef TOUCH_ARG
    if ( !FUNp(touch_obj(getarg(1)) )){
        err_illegal_argument_type(touch_obj(getarg(1)), "procedure");
#else
    if ( !FUNp(getarg(1)) ){
        err_illegal_argument_type(getarg(1), "procedure");
#endif
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    s_push(LTAG_LOSTOBJ);  /* map argument terminator */
    oldtop = sp_reg;
    
                     /* Check argument type By N.Watanabe */
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p = (p - 1)) {
#ifdef TOUCH_ARG
        switch (GETtag(touch_obj(*p))) {
#else
        switch (GETtag(*p)) {
#endif
        case LTAG_CONS :
        case LTAG_NIL  :
	    break;
        default :
	    s_pop();
#ifdef TOUCH_ARG
	    err_illegal_argument_type(touch_obj(*p), "list");
#else
	    err_illegal_argument_type(*p, "list");
#endif
	    return ;
        }
    }

    open_frame2(cont_proc, LTAG_NIL, 0);
#ifdef TOUCH_ARG
    s_push(touch_obj(getarg(1)));
#else
    s_push(getarg(1));
#endif
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
    if (GETtag(*sp_reg) == LTAG_SFUNCTION)
	for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p = (p - 1)) {
	    switch (GETtag(*p)) {
	    case LTAG_CONS :
		s_push(touch_obj(CARobj(*p)));
		switch (GETtag(CDRobj(*p))) {
		case LTAG_CONS :
		case LTAG_NIL  :
		case LTAG_FUTURE  :
		    break;
		default :
                    ADJUST_STACK_MAP(); /* for error handler */
		    err_illegal_argument_type(CDRobj(*p), "list");
		    return ;
		}
		*p = CDRobj(*p);
		break;
	    case LTAG_NIL  :
		reg_reg = LTAG_NIL;
		return;
	    default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	}
    else
	for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p = (p - 1)) {
	    switch (GETtag(*p)) {
	    case LTAG_CONS :
		s_push(CARobj(*p));
		switch (GETtag(CDRobj(*p))) {
		case LTAG_CONS :
		case LTAG_NIL  :
		case LTAG_FUTURE  :
		    break;
		default :
                    ADJUST_STACK_MAP(); /* for error handler */
		    err_illegal_argument_type(CDRobj(*p), "list");
		    return ;
		}
		*p = CDRobj(*p);
		break;
	    case LTAG_NIL  :
		reg_reg = LTAG_NIL;
		return;
	    default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	}
#else
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p = (p - 1)) {
# ifdef TOUCH_ARG
	q = touch_obj(*p);
        switch (GETtag(q)) {
        case LTAG_CONS :
            s_push(CARobj(q));
            switch (GETtag(touch_obj(CDRobj(q)))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(touch_obj(CDRobj(q)), "list");
		return ;
            }
            *p = CDRobj(q);
            break;
        case LTAG_NIL  :
            reg_reg = LTAG_NIL;
            return;
        default :
	    err_illegal_argument_type(q, "list");
	    return ;
        }
# else
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            reg_reg = LTAG_NIL;
            return;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
# endif
    }
#endif
    if (p == oldtop) {
        set_up_stack();
    } else {
        err_illegal_argument("Argument must be a list.");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
}

#if (defined(CTHREAD) && !defined(TOUCH_ARG))

void map2_tch()
{
    unsigned *p, q;
    int touch_obj();

    s_pop();
    s_pop();
    s_push(reg_reg);
    open_frame2(map2_tch, LTAG_NIL, 0);
    s_push(getarg(1));
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p = (p - 1)) {
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(touch_obj(CARobj(*p)));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
	    case LTAG_FUTURE  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            reg_reg = LTAG_NIL;
            for (; sp_reg < p; )
                reg_reg = (unsigned)mk_cons(s_pop(), reg_reg);
            xreturn();
            return;
	case LTAG_FUTURE :
	    q = touch_obj(*p);
	    switch (GETtag(q)) {
	    case LTAG_CONS :
		s_push(touch_obj(CARobj(q)));
		*p = CDRobj(q);
		break;
	    case LTAG_NIL  :
		for (p--; *p != LTAG_LOSTOBJ; p--)
		    ;
		sp_reg = base_reg + 5;
		base_reg = active_reg;
		reg_reg = LTAG_NIL;
		for (; sp_reg < p; )
		    reg_reg = (unsigned)mk_cons(s_pop(), reg_reg);
		xreturn();
		return;
            default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	    break;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
    }
    xcall();
}

void map2_ntch()
{
    unsigned *p, q;
    int touch_obj();

    s_pop();
    s_pop();
    s_push(reg_reg);
    open_frame2(map2_ntch, LTAG_NIL, 0);
    s_push(getarg(1));
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p = (p - 1)) {
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
	    case LTAG_FUTURE  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            reg_reg = LTAG_NIL;
            for (; sp_reg < p; )
                reg_reg = (unsigned)mk_cons(s_pop(), reg_reg);
            xreturn();
            return;
	case LTAG_FUTURE :
	    q = touch_obj(*p);
	    switch (GETtag(q)) {
	    case LTAG_CONS :
		s_push(CARobj(q));
		*p = CDRobj(q);
		break;
	    case LTAG_NIL  :
		for (p--; *p != LTAG_LOSTOBJ; p--)
		    ;
		sp_reg = base_reg + 5;
		base_reg = active_reg;
		reg_reg = LTAG_NIL;
		for (; sp_reg < p; )
		    reg_reg = (unsigned)mk_cons(s_pop(), reg_reg);
		xreturn();
		return;
            default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	    break;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
    }
    xcall();
}

#else

void map2()
{
    unsigned *p;
    int q;

    s_pop();
    s_pop();
/*
#ifdef TOUCH_ARG
    s_push(touch_obj(reg_reg));
#else
*/
    s_push(reg_reg);
/*
#endif
*/
    open_frame2(map2, LTAG_NIL, 0);
# ifdef TOUCH_ARG
    s_push(touch_obj(getarg(1)));
# else
    s_push(getarg(1));
# endif
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p = (p - 1)) {
# ifdef TOUCH_ARG
	q = touch_obj(*p);
        switch (GETtag(q)) {
        case LTAG_CONS :
            s_push(CARobj(q));
            switch (GETtag(touch_obj(CDRobj(q)))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(touch_obj(CDRobj(q)), "list");
		return ;
            }
            *p = CDRobj(q);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            reg_reg = LTAG_NIL;
            for (; sp_reg < p; )
                reg_reg = (unsigned)mk_cons(s_pop(), reg_reg);
            xreturn();
            return;
        default :
	    err_illegal_argument_type(q, "list");
	    return ;
        }
# else
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            reg_reg = LTAG_NIL;
            for (; sp_reg < p; )
                reg_reg = (unsigned)mk_cons(s_pop(), reg_reg);
            xreturn();
            return;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
# endif
    }
    xcall();
}

# ifdef CALLIOC

void map2_ep()
{
    unsigned *p;
    int q;

    ((unsigned *)stack_bottom)[5]--;
    s_pop();
    s_pop();
/*
#ifdef TOUCH_ARG
    s_push(touch_obj(reg_reg));
#else
*/
    s_push(reg_reg);
/*
#endif
*/
    open_frame2(map2, LTAG_NIL, 0);
#  ifdef TOUCH_ARG
    s_push(touch_obj(getarg(1)));
#  else
    s_push(getarg(1));
#  endif
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p = (p - 1)) {
#  ifdef TOUCH_ARG
	q = touch_obj(*p);
        switch (GETtag(q)) {
        case LTAG_CONS :
            s_push(CARobj(q));
            switch (GETtag(touch_obj(CDRobj(q)))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(touch_obj(CDRobj(q)), "list");
		return ;
            }
            *p = CDRobj(q);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            reg_reg = LTAG_NIL;
            for (; sp_reg < p; )
                reg_reg = (unsigned)mk_cons(s_pop(), reg_reg);
            xreturn();
            return;
        default :
	    err_illegal_argument_type(q, "list");
	    return ;
        }
#  else
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            reg_reg = LTAG_NIL;
            for (; sp_reg < p; )
                reg_reg = (unsigned)mk_cons(s_pop(), reg_reg);
            xreturn();
            return;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
#  endif
    }
    xcall();
}

# endif

#endif /* (defined(CTHREAD) && !defined(TOUCH_ARG)) */

/*
 *   (mapcan procedure args-list1 args-list2 ...)
 *
 */

void mapcan2();

void Smapcan()
{
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
    int mapcan2_tch(), mapcan2_ntch();

    if (GETtag(getarg(1)) == LTAG_SFUNCTION)
	map(mapcan2_tch);
    else
	map(mapcan2_ntch);
#else
    map(mapcan2);
#endif
}

#if (defined(CTHREAD) && !defined(TOUCH_ARG))

void mapcan2_tch()
{
    unsigned *p, q, touch_obj();
    SOBJ result;
    unsigned *append_p;

    s_pop();
    s_pop();
    s_push(reg_reg);
    open_frame2(mapcan2_tch, LTAG_NIL, 0);
    s_push(getarg(1));
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p--) {
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(touch_obj(CARobj(*p)));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
	    case LTAG_FUTURE  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            result.obj = LTAG_NIL;
            append_p = &result.obj;
            for (; sp_reg < p; ) {
                while (GETtag(*append_p) == LTAG_CONS) {
#ifdef SPECIAL_CONS_TAG
                    append_p = ((unsigned *)(*append_p)) + 1;
#else
                    append_p = ((unsigned *)ADDRESS(*append_p)) + 1;
#endif
                }
                if (*append_p == LTAG_NIL) {
                    *append_p = *(--p);
                } else
                    bokkan("mapcan's procedure must return list.");
            }
            reg_reg = result.obj;
            xreturn();
            return;
	case LTAG_FUTURE :
	    q = touch_obj(*p);
	    switch (GETtag(q)) {
	    case LTAG_CONS :
		s_push(touch_obj(CARobj(q)));
		*p = CDRobj(q);
		break;
	    case LTAG_NIL  :
		for (p--; *p != LTAG_LOSTOBJ; p--)
		    ;
		sp_reg = base_reg + 5;
		base_reg = active_reg;
		result.obj = LTAG_NIL;
		append_p = &result.obj;
		for (; sp_reg < p; ) {
		    while (GETtag(*append_p) == LTAG_CONS) {
#ifdef SPECIAL_CONS_TAG
			append_p = ((unsigned *)(*append_p)) + 1;
#else
			append_p = ((unsigned *)ADDRESS(*append_p)) + 1;
#endif
		    }
		    if (*append_p == LTAG_NIL) {
			*append_p = *(--p);
		    } else
			bokkan("mapcan's procedure must return list.");
		}
		reg_reg = result.obj;
		xreturn();
		return;
            default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	    break;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
    }
    xcall();
}

void mapcan2_ntch()
{
    unsigned *p, q, touch_obj();
    SOBJ result;
    unsigned *append_p;

    s_pop();
    s_pop();
    s_push(reg_reg);
    open_frame2(mapcan2_ntch, LTAG_NIL, 0);
    s_push(getarg(1));
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p--) {
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
	    case LTAG_FUTURE  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            result.obj = LTAG_NIL;
            append_p = &result.obj;
            for (; sp_reg < p; ) {
                while (GETtag(*append_p) == LTAG_CONS) {
#ifdef SPECIAL_CONS_TAG
                    append_p = ((unsigned *)(*append_p)) + 1;
#else
                    append_p = ((unsigned *)ADDRESS(*append_p)) + 1;
#endif
                }
                if (*append_p == LTAG_NIL) {
                    *append_p = *(--p);
                } else
                    bokkan("mapcan's procedure must return list.");
            }
            reg_reg = result.obj;
            xreturn();
            return;
	case LTAG_FUTURE :
	    q = touch_obj(*p);
	    switch (GETtag(q)) {
	    case LTAG_CONS :
		s_push(CARobj(q));
		*p = CDRobj(q);
		break;
	    case LTAG_NIL  :
		for (p--; *p != LTAG_LOSTOBJ; p--)
		    ;
		sp_reg = base_reg + 5;
		base_reg = active_reg;
		result.obj = LTAG_NIL;
		append_p = &result.obj;
		for (; sp_reg < p; ) {
		    while (GETtag(*append_p) == LTAG_CONS) {
#ifdef SPECIAL_CONS_TAG
			append_p = ((unsigned *)(*append_p)) + 1;
#else
			append_p = ((unsigned *)ADDRESS(*append_p)) + 1;
#endif
		    }
		    if (*append_p == LTAG_NIL) {
			*append_p = *(--p);
		    } else
			bokkan("mapcan's procedure must return list.");
		}
		reg_reg = result.obj;
		xreturn();
		return;
            default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	    break;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
    }
    xcall();
}

#else

void mapcan2()
{
    unsigned *p, *append_p;
    int q;
    SOBJ result;

    s_pop();
    s_pop();
/*
#ifdef TOUCH_ARG
    s_push(touch_obj(reg_reg));
#else
*/
    s_push(reg_reg);
/*
#endif
*/
    open_frame2(mapcan2, LTAG_NIL, 0);
#ifdef TOUCH_ARG
    s_push(touch_obj(getarg(1)));
#else
    s_push(getarg(1));
#endif
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p--) {
#ifdef TOUCH_ARG
	q = touch_obj(*p);
        switch (GETtag(q)) {
        case LTAG_CONS :
            s_push(CARobj(q));
            switch (GETtag(touch_obj(CDRobj(q)))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(touch_obj(CDRobj(q)), "list");
		return ;
            }
            *p = CDRobj(q);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            result.obj = LTAG_NIL;
            append_p = &result.obj;
            for (; sp_reg < p; ) {
                while (GETtag(*append_p) == LTAG_CONS) {
#ifdef SPECIAL_CONS_TAG
                    append_p = ((unsigned *)(*append_p)) + 1;
#else
                    append_p = ((unsigned *)ADDRESS(*append_p)) + 1;
#endif
                }
                if (*append_p == LTAG_NIL) {
                    *append_p = *(--p);
                } else
                    bokkan("mapcan's procedure must return list.");
            }
            reg_reg = result.obj;
            xreturn();
            return;
        default :
	    err_illegal_argument_type(q, "list");
	    return ;
        }
#else
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            result.obj = LTAG_NIL;
            append_p = &result.obj;
            for (; sp_reg < p; ) {
                while (GETtag(*append_p) == LTAG_CONS) {
#ifdef SPECIAL_CONS_TAG
                    append_p = ((unsigned *)(*append_p)) + 1;
#else
                    append_p = ((unsigned *)ADDRESS(*append_p)) + 1;
#endif
                }
                if (*append_p == LTAG_NIL) {
                    *append_p = *(--p);
                } else
                    bokkan("mapcan's procedure must return list.");
            }
            reg_reg = result.obj;
            xreturn();
            return;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
#endif
    }
    xcall();
}

# ifdef CALLIOC

void mapcan2_ep()
{
    unsigned *p, *append_p;
    int q;
    SOBJ result;

    ((unsigned *)stack_bottom)[5]--;
    s_pop();
    s_pop();
/*
#ifdef TOUCH_ARG
    s_push(touch_obj(reg_reg));
#else
*/
    s_push(reg_reg);
/*
#endif
*/
    open_frame2(mapcan2, LTAG_NIL, 0);
#ifdef TOUCH_ARG
    s_push(touch_obj(getarg(1)));
#else
    s_push(getarg(1));
#endif
    for (p = (active_reg - 3); *p != LTAG_LOSTOBJ; p--) {
#ifdef TOUCH_ARG
	q = touch_obj(*p);
        switch (GETtag(q)) {
        case LTAG_CONS :
            s_push(CARobj(q));
            switch (GETtag(touch_obj(CDRobj(q)))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(touch_obj(CDRobj(q)), "list");
		return ;
            }
            *p = CDRobj(q);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            result.obj = LTAG_NIL;
            append_p = &result.obj;
            for (; sp_reg < p; ) {
                while (GETtag(*append_p) == LTAG_CONS) {
#ifdef SPECIAL_CONS_TAG
                    append_p = ((unsigned *)(*append_p)) + 1;
#else
                    append_p = ((unsigned *)ADDRESS(*append_p)) + 1;
#endif
                }
                if (*append_p == LTAG_NIL) {
                    *append_p = *(--p);
                } else
                    bokkan("mapcan's procedure must return list.");
            }
            reg_reg = result.obj;
            xreturn();
            return;
        default :
	    err_illegal_argument_type(q, "list");
	    return ;
        }
#else
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
                break;
            default :
                ADJUST_STACK_MAP(); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
		return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            for (p--; *p != LTAG_LOSTOBJ; p--)
                ;
            sp_reg = base_reg + 5;
            base_reg = active_reg;
            result.obj = LTAG_NIL;
            append_p = &result.obj;
            for (; sp_reg < p; ) {
                while (GETtag(*append_p) == LTAG_CONS) {
#ifdef SPECIAL_CONS_TAG
                    append_p = ((unsigned *)(*append_p)) + 1;
#else
                    append_p = ((unsigned *)ADDRESS(*append_p)) + 1;
#endif
                }
                if (*append_p == LTAG_NIL) {
                    *append_p = *(--p);
                } else
                    bokkan("mapcan's procedure must return list.");
            }
            reg_reg = result.obj;
            xreturn();
            return;
        default :
	    err_illegal_argument_type(*p, "list");
	    return ;
        }
#endif
    }
    xcall();
}

# endif

#endif

/*
 *   (for-each procedure args-list1 args-list2 ...)
 *
 */

void foreach2();

void Sforeach()
{
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
    int foreach2_tch(), foreach2_ntch();

    if (GETtag(getarg(1)) == LTAG_SFUNCTION)
	foreach(foreach2_tch, LTAG_NIL);
    else
	foreach(foreach2_ntch, LTAG_NIL);
#else
    foreach(foreach2, LTAG_NIL);
#endif
}

#ifdef THINK_C
void
#endif
void foreach(retaddr, retval)
int (*retaddr)();
int retval;
{
    unsigned *p, q, *oldtop;
#ifdef CTHREAD
    int touch_obj();
#endif

#ifdef TOUCH_ARG
    if ( !FUNp(touch_obj(getarg(1)) )){
        err_illegal_argument_type(touch_obj(getarg(1), "procedure"));
#else
    if ( !FUNp(getarg(1)) ){
        err_illegal_argument_type(getarg(1), "procedure");
#endif
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    oldtop = sp_reg;

    for (p = (active_reg - 3); p >= oldtop; p--) {  /* Check argument type */
#ifdef TOUCH_ARG
        switch (GETtag(touch_obj(*p))) {            /* By N.Watanabe       */
#else
        switch (GETtag(*p)) {			    /* By N.Watanabe       */
#endif
        case LTAG_CONS :
        case LTAG_NIL  :
            break;
        default :
#ifdef TOUCH_ARG
            err_illegal_argument_type(touch_obj(*p), "list");
#else
            err_illegal_argument_type(*p, "list");
#endif
	    return ;
        }
    }

    open_frame2(retaddr, LTAG_NIL, 0);
#ifdef TOUCH_ARG
    s_push(touch_obj(getarg(1)));
#else
    s_push(getarg(1));
#endif
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
    if (GETtag(*sp_reg) == LTAG_SFUNCTION)
	for (p = (active_reg - 3); p >= oldtop; p--) {
	    switch (GETtag(*p)) {
	    case LTAG_CONS :
		s_push(touch_obj(CARobj(*p)));
		*p = CDRobj(*p);
		break;
	    case LTAG_NIL  :
		reg_reg = retval;
		return;
	    default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	}
    else
	for (p = (active_reg - 3); p >= oldtop; p--) {
	    switch (GETtag(*p)) {
	    case LTAG_CONS :
		s_push(CARobj(*p));
		*p = CDRobj(*p);
		break;
	    case LTAG_NIL  :
		reg_reg = retval;
		return;
	    default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	}
#else
    for (p = (active_reg - 3); p >= oldtop; p--) {
# ifdef TOUCH_ARG
	q = touch_obj(*p);
        switch (GETtag(q)) {
        case LTAG_CONS :
            s_push(CARobj(q));
            *p = CDRobj(q);
            break;
        case LTAG_NIL  :
            reg_reg = retval;
            return;
        default :
            err_illegal_argument_type(q, "list");
	    return ;
        }
# else
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch(GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
            case LTAG_FUTURE  :
                break;
            default :
                ADJUST_STACK(0); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
                return;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            reg_reg = retval;
            return;
        default :
            err_illegal_argument_type(*p, "list");
	    return ;
        }
# endif
    }
#endif
    set_up_stack();
}

#if (defined(CTHREAD) && !defined(TOUCH_ARG))

void foreach2_tch()
{
    unsigned *p, q, *oldtop;
    int touch_obj();

    s_pop();
    s_pop();
    oldtop = sp_reg;
    open_frame2(foreach2_tch, LTAG_NIL, 0);
    s_push(getarg(1));
    for (p = (active_reg - 3); p >= oldtop; p--) {
	switch (GETtag(*p)) {
	case LTAG_CONS :
	    s_push(touch_obj(CARobj(*p)));
	    *p = CDRobj(*p);
	    break;
	case LTAG_NIL  :
            xreturn();
            return;
	case LTAG_FUTURE :
	    q = touch_obj(*p);
	    switch (GETtag(q)) {
	    case LTAG_CONS :
		s_push(touch_obj(CARobj(q)));
		*p = CDRobj(q);
		break;
	    case LTAG_NIL  :
		xreturn();
		return;
            default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	    break;
	default :
	    err_illegal_argument_type(*p, "list");
	    return ;
	}
    }
    xcall();
}

void foreach2_ntch()
{
    unsigned *p, q, *oldtop;
    int touch_obj();

    s_pop();
    s_pop();
    oldtop = sp_reg;
    open_frame2(foreach2_ntch, LTAG_NIL, 0);
    s_push(getarg(1));
    for (p = (active_reg - 3); p >= oldtop; p--) {
	switch (GETtag(*p)) {
	case LTAG_CONS :
	    s_push(CARobj(*p));
	    *p = CDRobj(*p);
	    break;
	case LTAG_NIL  :
	    xreturn();
	    return;
	case LTAG_FUTURE :
	    q = touch_obj(*p);
	    switch (GETtag(q)) {
	    case LTAG_CONS :
		s_push(CARobj(q));
		*p = CDRobj(q);
		break;
	    case LTAG_NIL  :
		xreturn();
		return;
            default :
		err_illegal_argument_type(*p, "list");
		return ;
	    }
	    break;
	default :
	    err_illegal_argument_type(*p, "list");
	    return ;
	}
    }
    xcall();
}

#else

void foreach2()
{
    unsigned *p, q, *oldtop;

    s_pop();
    s_pop();
    oldtop = sp_reg;
    open_frame2(foreach2, LTAG_NIL, 0);
#ifdef TOUCH_ARG
    s_push(touch_obj(getarg(1)));
#else
    s_push(getarg(1));
#endif
    for (p = (active_reg - 3); p >= oldtop; p--) {
#ifdef TOUCH_ARG
	q = touch_obj(*p);
        switch (GETtag(q)) {
        case LTAG_CONS :
            s_push(CARobj(q));
            *p = CDRobj(q);
            break;
        case LTAG_NIL  :
            xreturn();
            return;
        default :
            ADJUST_STACK(0); /* for error handler */
            err_illegal_argument_type(q, "list");
	    return ;
        }
#else
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch(GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
            case LTAG_FUTURE  :
                break;
            default :
                ADJUST_STACK(0); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
                return;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            xreturn();
            return;
        default :
            ADJUST_STACK(0); /* for error handler */
            err_illegal_argument_type(*p, "list");
	    return ;
        }
#endif
    }
    xcall();
}

# ifdef CALLIOC

void foreach2_ep()
{
    unsigned *p, q, *oldtop;

    ((unsigned *)stack_bottom)[5]--;
    s_pop();
    s_pop();
    oldtop = sp_reg;
    open_frame2(foreach2, LTAG_NIL, 0);
#ifdef TOUCH_ARG
    s_push(touch_obj(getarg(1)));
#else
    s_push(getarg(1));
#endif
    for (p = (active_reg - 3); p >= oldtop; p--) {
#ifdef TOUCH_ARG
	q = touch_obj(*p);
        switch (GETtag(q)) {
        case LTAG_CONS :
            s_push(CARobj(q));
            *p = CDRobj(q);
            break;
        case LTAG_NIL  :
            xreturn();
            return;
        default :
            ADJUST_STACK(0); /* for error handler */
            err_illegal_argument_type(q, "list");
	    return ;
        }
#else
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            xreturn();
            return;
        default :
            ADJUST_STACK(0); /* for error handler */
            err_illegal_argument_type(*p, "list");
	    return ;
        }
#endif
    }
    xcall();
}

# endif

#endif

/*
 *    some, every, notany, notevery
 *
 *    example:(some procedure args-list1 args-list2 ...)
 *
 */

#define SOME      0
#define EVERY     1
#define NOTANY    2
#define NOTEVERY  3

void some2();
void every2();
void notany2();
void notevery2();

void Ssome()
{
    foreach(some2, LTAG_FALSE);
}


void some2()
{
    prot_senn2(some2, LTAG_FALSE, SOME);
}



void Severy()
{
    foreach(every2, LTAG_T);
}


void every2()
{
    prot_senn2(every2, LTAG_T, EVERY);
}


void Snotany()
{
    foreach(notany2, LTAG_T);
}


void notany2()
{
    prot_senn2(notany2, LTAG_T, NOTANY);
}


void Snotevery()
{
    foreach(notevery2, LTAG_FALSE);
}


void notevery2()
{
    prot_senn2(notevery2, LTAG_FALSE, NOTEVERY);
}

#ifdef THINK_C
void
#endif
void prot_senn2(retaddr, final_retval, fun_type)
int (*retaddr)();
int final_retval;
int fun_type;
{
    unsigned *p, *oldtop;

    s_pop();
    s_pop();
    switch (fun_type) {
    case SOME :
        if (reg_reg != LTAG_FALSE && reg_reg != LTAG_NIL) { 
            xreturn(); 
            return; 
        }
        break;
    case EVERY :
        if (reg_reg == LTAG_FALSE || reg_reg == LTAG_NIL) {
            reg_reg = LTAG_FALSE; 
            xreturn(); 
            return; 
        }
        break;
    case NOTANY :
        if (reg_reg != LTAG_FALSE && reg_reg != LTAG_NIL) {
            reg_reg = LTAG_FALSE; 
            xreturn(); 
            return; 
        }
        break;
    case NOTEVERY :
        if (reg_reg == LTAG_FALSE || reg_reg == LTAG_NIL) {
            reg_reg = LTAG_T; 
            xreturn(); 
            return; 
        }
        break;
    }
    oldtop = sp_reg;
    open_frame2(retaddr, LTAG_NIL, 0);
    s_push(getarg(1));
    for (p = (active_reg - 3); p >= oldtop; p--) {
        switch (GETtag(*p)) {
        case LTAG_CONS :
            s_push(CARobj(*p));
            switch (GETtag(CDRobj(*p))) {
            case LTAG_CONS :
            case LTAG_NIL  :
            case LTAG_FUTURE  :
                break;
            default :
                ADJUST_STACK(0); /* for error handler */
                err_illegal_argument_type(CDRobj(*p), "list");
                return ;
            }
            *p = CDRobj(*p);
            break;
        case LTAG_NIL  :
            reg_reg = final_retval;
            xreturn();
            return;
        default :
            ADJUST_STACK(0); /* for error handler */
            err_illegal_argument_type(*p, "list");
	    return ;
        }
    }
    xcall();
}


/*
 *   (apply procedure arg1 arg2 ... argn  . last_arg_list)
 *
 */
void Sapply()
{
    SOBJ last_arg;
    unsigned *p;
#ifdef CTHREAD
    int touch_obj();
#endif

#ifdef TOUCH_ARG                /* T.Komiya */
    if ( !FUNp(touch_obj(getarg(1)) )){
        err_illegal_argument_type(touch_obj(getarg(1)), "procedure");
        return;
    }
    if (GETtag(touch_obj(*sp_reg)) != LTAG_CONS
        && GETtag(touch_obj(*sp_reg)) != LTAG_NIL) {
        err_illegal_argument_type(touch_obj(*sp_reg), "list");
        return;
    }
#else                           /* T.Komiya */
    if ( !FUNp(getarg(1)) ){
        err_illegal_argument_type(getarg(1), "procedure");
        return;
    }
    if (GETtag(*sp_reg) != LTAG_CONS && GETtag(*sp_reg) != LTAG_NIL) {
        err_illegal_argument_type(*sp_reg, "list");
        return;
    }
#endif
    for (p = (base_reg - 2); p > sp_reg; p--) {
        *(p + 1) = *p;
    }
    sp_reg = sp_reg + 2;
    last_arg.obj = *p;
#if (defined(CTHREAD) && !defined(TOUCH_ARG))
    if (GETtag(*(base_reg - 1)) == LTAG_SFUNCTION)
	while (last_arg.obj != LTAG_NIL) {
	    if (GETtag(last_arg.obj) == LTAG_CONS) {
		s_push(touch_obj(CARobj(last_arg.obj)));
		last_arg.obj = CDRobj(last_arg.obj);
	    } else if (GETtag(last_arg.obj) == LTAG_FUTURE)
		last_arg.obj = touch_obj(last_arg.obj);
	    else {
		err_illegal_argument_type(last_arg.obj, "list");
		return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	    }
	}
    else
	while (last_arg.obj != LTAG_NIL) {
	    if (GETtag(last_arg.obj) == LTAG_CONS) {
		s_push(CARobj(last_arg.obj));
		last_arg.obj = CDRobj(last_arg.obj);
	    } else if (GETtag(last_arg.obj) == LTAG_FUTURE)
		last_arg.obj = touch_obj(last_arg.obj);
	    else {
		err_illegal_argument_type(last_arg.obj, "list");
		return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	    }
	}
#else
# ifdef TOUCH_ARG
    last_arg.obj = touch_obj(last_arg.obj);
# endif
    while (last_arg.obj != LTAG_NIL) {
        if (GETtag(last_arg.obj) == LTAG_CONS) {
            s_push(CARobj(last_arg.obj));
# ifdef TOUCH_ARG
            last_arg.obj = touch_obj(CDRobj(last_arg.obj));
# else
            last_arg.obj = CDRobj(last_arg.obj);
# endif
        } else {
            err_illegal_argument_type(last_arg.obj, "list");
	    return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	}
    }
#endif
    set_up_stack();
}



#ifdef THINK_C
void
#endif
void open_frame2(ret_address, bc_body, start_pc)
int (*ret_address)();
int bc_body;
int start_pc;
{
#ifdef LTC
    if (((unsigned int **)stack_top)[LTQ_TAIL] + CHILD_GETA_OF_STACK > sp_reg)
#else
    if ((unsigned *)stack_top > sp_reg)
#endif
        bokkan_stack_overflow();
    s_push(bc_body);
    s_push(start_pc);
    s_push(ret_address);
    s_push(active_reg);
    s_push(base_reg);
    base_reg = sp_reg;
}


void set_up_stack()
{
    xcall();
    open_frame2(iretaddrx, LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg);
    active_reg = base_reg;
}


/***********************************/
/*                                 */
/*  Essential standard procedures  */
/*                                 */
/***********************************/


void Sprocp()  /*  T.Komiya */
{
#ifdef TOUCH_ARG
    switch (GETtag(touch_obj(getarg(1))) ){
#else
    switch (GETtag(getarg(1))) {
#endif
    case LTAG_BCLOSURE :
    case LTAG_NCLOSURE :
    case LTAG_SFUNCTION :
    case LTAG_CONTINUATION :
#ifdef CALLIOC
    case LTAG_IOC :
#endif
    case LTAG_MBCLOSURE :	/* Macro is not function, but ... */
    case LTAG_MNCLOSURE :	/*            "                   */
    case LTAG_MSFUNCTION :	/*            "                   */
        set_reg(LTAG_T);
	break;
    default :
        set_reg(LTAG_FALSE);
	break;
    }
}


/*
 *  ------------
 *  CONTINUATION
 *  ------------
 *  written by Yass.
 *
 */

void Scall_cc()  /*  Yass. Sep. 20 '90  */
/* modified for all C version scheme by Myama. */
/* modified for SYSTEM-V UNIX by Myama. */
{
    SOBJP a_frame;
    int (*ret_addr)();
    int frame_size, tmp_frame, pc, active;

#ifdef TOUCH_ARG
    call_cc_arg.obj = touch_obj(s_pop());  /* save a call/cc argument */
#else
    call_cc_arg.obj = s_pop();  /* save a call/cc argument */
#endif
    s_pop();                /* pop a call/cc itself */
    if (top_val() != (unsigned *)stack_bottom - 3) { /* by T.Komiya */
        top_of_aflk.obj = end_of_aflk.obj = mk_cons(LTAG_NIL, LTAG_NIL);
        do /* loop for current stack */
        {
            af_tmp.obj = LTAG_NIL;
            set_base(s_pop());    /* recovering a base frame */
            set_active(s_pop());  /* recovering an active frame */
	    ret_addr = (int (*)())s_pop();
	    pc = s_pop();
#ifdef CALLIOC
            frame_size = (unsigned *)base_val() - (unsigned *)top_val();
            a_frame = (SOBJP)mk_evecp(frame_size + 2);
            reg1 = LTAG_VECTOR | SSERDDA(a_frame);
# if defined(__ELF__) && defined(i386)
            (a_frame + frame_size + 2)->obj = mk_fix(SSERDDA(ret_addr));
# else
            (a_frame + frame_size + 2)->obj = mk_fix((unsigned)ret_addr);
# endif
            (a_frame + (frame_size + 1))->obj = mk_fix(pc);
            /* loop for elements in the frame */
            for (; frame_size > 0 ; frame_size--)
                (a_frame + frame_size)->obj = s_pop();
            af_tmp.obj = mk_cons((LTAG_VECTOR | SSERDDA(a_frame)),
                                 af_tmp.obj);
            if (top_val() < active_val()) {
                set_base(s_pop());
                active = s_pop();
                frame_size = (unsigned *)active - (unsigned *)top_val();
                ret_addr = (int (*)())s_pop();
                pc = s_pop();
                af_tmp.obj = mk_cons(mk_fix(frame_size), af_tmp.obj);
                do /* loop for active links */
                {
                    frame_size = (unsigned *)base_val() - (unsigned *)top_val();
                    a_frame = (SOBJP)mk_evecp(frame_size + 2);
# if defined(__ELF__) && defined(i386)
                    (a_frame + frame_size + 2)->obj = mk_fix(SSERDDA(ret_addr));
# else
                    (a_frame + frame_size + 2)->obj = mk_fix((unsigned)ret_addr);
# endif
                    (a_frame + (frame_size + 1))->obj = mk_fix(pc);
                    /* loop for elements in the frame */
                    for (; frame_size > 0 ; frame_size--)
                        (a_frame + frame_size)->obj = s_pop();
                    af_tmp.obj = mk_cons((LTAG_VECTOR | SSERDDA(a_frame)),
                                         af_tmp.obj);
                    if (top_val() < active_val()) {
                        set_base(s_pop());
                        active = s_pop();
                        frame_size = (unsigned *)active - (unsigned *)top_val();
                        ret_addr = (int (*)())s_pop();
                        pc = s_pop();
                        af_tmp.obj = mk_cons(mk_fix(frame_size), af_tmp.obj);
                    } else
                        break;
                } while (1);
            }
            af_tmp.obj = mk_cons(af_tmp.obj, reg1);
#else /* CALLIOC */
            do /* loop for active links */
            {
                frame_size = (unsigned *)base_val() - (unsigned *)top_val();
                a_frame = (SOBJP)mk_evecp(frame_size + 2);
# if defined(__ELF__) && defined(i386)
                (a_frame + frame_size + 2)->obj = mk_fix(SSERDDA(ret_addr));
# else
                (a_frame + frame_size + 2)->obj = mk_fix((unsigned)ret_addr);
# endif
                (a_frame + (frame_size + 1))->obj = mk_fix(pc);
                /* loop for elements in the frame */
                for (; frame_size > 0 ; frame_size--)
                    (a_frame + frame_size)->obj = s_pop();
                af_tmp.obj = mk_cons((LTAG_VECTOR | SSERDDA(a_frame)),
                                     af_tmp.obj);
                if (top_val() < active_val()) {
                    set_base(s_pop());
                    active = s_pop();
		    frame_size = (unsigned *)active - (unsigned *)top_val();
		    ret_addr = (int (*)())s_pop();
		    pc = s_pop();
                    af_tmp.obj = mk_cons(mk_fix(frame_size), af_tmp.obj);
                } else
                    break;
            } while (1);
#endif /* CALLIOC */
            set_car(end_of_aflk.obj, af_tmp.obj);
            if ((unsigned)stack_bottom - (unsigned)top_val() > 12) {
                tmp_frame = mk_cons(LTAG_NIL, LTAG_NIL);
                set_cdr(end_of_aflk.obj, tmp_frame);
                end_of_aflk.obj = tmp_frame;
            } else
                break;
        } while (1);
        set_cdr(end_of_aflk.obj, more.obj);
        more.obj = top_of_aflk.obj;
    }
    s_push(call_cc_arg.obj);
    {
        unsigned tmp;
#ifdef CTHREAD
        tmp = mk_cont(more.obj, optcnt.obj);
        s_push(tmp);
#else
        tmp = mk_cont(more.obj);
        s_push(tmp);
#endif
    }

#ifdef CALLIOC
    reg1 =
#endif
    call_cc_arg.obj = 
        top_of_aflk.obj = 
        end_of_aflk.obj = 
        af_tmp.obj      = LTAG_NIL;

    set_up_stack();
}


/*
 *  -----
 *  FORCE
 *  -----
 *
 *  first version was written by Yass.
 *  C-version was written by Myama.
 *
 */

void force2()
{
    PROMISE * pro;

    s_pop();
#ifdef TOUCH_ARG
    pro = (PROMISE * )ADDRESS(touch_obj(getarg(1)));
#else
    pro = (PROMISE * )ADDRESS(getarg(1));
#endif
    if (pro->start_addr.obj != LTAG_NIL) {
        pro->body_result.obj = reg_reg;
        pro->start_addr.obj = LTAG_NIL;
        pro->env.obj = LTAG_NIL;
    } else
        reg_reg = pro->body_result.obj;
    xreturn();
}


void Sforce()
{
    SOBJ  promise;
    PROMISE * pro;
    BCCLOS * fun;

#ifdef TOUCH_ARG
    promise.obj = touch_obj(getarg(1));
#else
    promise.obj = getarg(1);
#endif
    if (GETtag(promise.obj) != LTAG_PROMISE) {
        reg_reg = getarg(1);
        return;
    }
    if (((PROMISE * )ADDRESS(promise.obj))->start_addr.obj == LTAG_NIL) {
        set_reg(((PROMISE * )ADDRESS(promise.obj))->body_result.obj);
        return;
    }
    pro = (PROMISE * )ADDRESS(promise.obj);
    open_frame2(force2, LTAG_NIL, 0);
    s_push(pro->body_result.obj);
    s_push(pro->env.obj);
    active_reg = base_reg;
    fun = (BCCLOS * )ADDRESS(pro->body_result.obj);
    open_frame2(iretaddrx, fun->body.obj, fix_to_int(pro->start_addr.obj));
    active_reg = base_reg;
}


void Scontinuationp()  /*  Yass. Sep. 12 '90  */
{
#ifdef TOUCH_ARG
    if (GETtag(touch_obj(getarg(1))) == LTAG_CONTINUATION)
#else
    if (GETtag(getarg(1)) == LTAG_CONTINUATION)
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


Spromisep()  /*  Yass. Sep. 12 '90  */
{
#ifdef TOUCH_ARG
    if (GETtag(touch_obj(getarg(1))) == LTAG_PROMISE)
#else
    if (GETtag(getarg(1)) == LTAG_PROMISE)
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}
