/*
 * copygc.c - 
 */

/*
 * $Id: copygc.c,v 1.2 1998/10/29 05:11:51 shige Exp $
 */

/***************************************/
/*                                     */
/*  File Name : copygc.c               */
/*     Mikio Yamamoto 1990.7           */
/*  Update    : Myama.                 */
/*                                     */
/*    Copy method Gabage Collection    */
/*                                     */
/***************************************/

static char *RCSid="$Id: copygc.c,v 1.2 1998/10/29 05:11:51 shige Exp $";

#include "scheme.h"

#ifdef GC_TIME
#include <sys/time.h>
#include <sys/resource.h>
#endif


#define     GC_SUCCESS  1
#define     GC_FAIL     0

unsigned *new_ent_add;
int act;

#ifdef THINK_C
void copygc_body(int);
void gcunit(unsigned *);
void move_up_entity_area(int, int, int);
void add_dis(unsigned *, int);
void a_gc_debug(int, int);
#endif

extern int  message_level;
extern sharp_eq_context_max;
extern SHARP_EQ_CONTEXT_STRUCT sharp_eq_context[];

/* for mark & sweep debug -------------------------------*/
extern FILE *debug_stream;
/* for mark & sweep debug  end --------------------------*/

/* global variable */
/* 
entity_base : 
entity_fin :
entity_area_size :
max_eintity_area_size :
entity_top :
entity_middle :
entity_bottom :
entity_start :
entity_end :
last_entity :

extent_rate :
*/
/*

   /|\              entity_base -----------------
    |                           |               |   
    |                           |               |   
    |                           |               |   
    |                           |               |   
    |                           |               |   
    |                           |               |   
    |                           |               |   
    |         /|\               |---------------| entity_top    (entity_start)
    |          |                |///////////////|
    |          |                |///////////////|
    |          |                |///////////////|
    |          |                |~~~~~~~~~~~~~~~|<--------------(last_entity)
    |          |                |               |
    |   entity_area_size        |- - - - - - - -| entity_middle (entity_end)
    |          |                |               |
    |          |                |               |
    |          |                |               |
    |          |                |               |
    |          |                |               |
    |         \|/               |---------------| entity_bottom
    |                           |               |
    |                           |               |
    |                           |               |
    |                           |               |
    |                           |               |
  max_entity_area_size          |               |
    |                           |               |
    |                           |               |
    |                           |               |
    |                           |               |
   \|/               entity_fin -----------------
*/


copygc(size)
int size;
{
    int half_size1; /* real entity area size of full extention */
    int half_size2; /* real entity area size of semi extention */
    int entity_edge;
    int active_entity_size;
    char    messtr[256];

#ifdef GC_TIME
    struct rusage ru;
    long sec, usec;
    extern gc_time_sec, gc_time_usec;

    getrusage(RUSAGE_SELF, &ru);
    sec = ru.ru_utime.tv_sec;
    usec = ru.ru_utime.tv_usec;
#endif
    message_level = fix_to_int(get_sval(gc_message_level_sym.obj));

    if (message_level)
        print_con("\ncopygc start:\n");
    if (message_level >= 2) {
        sprintf(messtr, "base = 0x%x,  fin = 0x%x, c_size = 0x%x(%d), max_size = 0x%x(%d)\n",
            (int)entity_base,
            (int)entity_fin,
            entity_area_size, entity_area_size,
            max_entity_area_size, max_entity_area_size);
        print_con(messtr);
        sprintf(messtr, "top = 0x%x, middle = 0x%x, bottom = 0x%x,\n", (int)entity_top,
            (int)entity_middle, (int)entity_bottom );
        print_con(messtr);
        sprintf(messtr, "start = 0x%x, end = 0x%x, last = 0x%x\n", (int)entity_start,
            (int)entity_end, (int)last_entity);
        print_con(messtr);
    }

    if (entity_position == HIGH) {
        copygc_body((unsigned)entity_middle);
        active_entity_size = (unsigned)last_entity - (unsigned)entity_start;
        if (((unsigned)entity_bottom - (unsigned)last_entity) >= size) {
            entity_start = entity_middle;
            entity_end = entity_bottom;
            entity_position = LOW;
        } else if ((entity_base != entity_top)
             && ((entity_area_size / 2) >= (size + active_entity_size)) ) {
            move_up_entity_area((unsigned)entity_start, (unsigned)last_entity, (unsigned)entity_base);
            half_size1 = ((entity_area_size / 2) / 4) * 4;
            entity_position = HIGH;
            last_entity = (unsigned *)((unsigned)last_entity - ((unsigned)entity_start - (unsigned)entity_base));
            entity_start = entity_base;
            entity_middle = (unsigned *)((unsigned)entity_base + half_size1);
            entity_bottom = (unsigned *)((unsigned)entity_middle + half_size1);
            entity_top = entity_base;
            entity_end = entity_middle;
        } else
            while (1) {
                if (entity_area_size == max_entity_area_size) {
                    move_up_entity_area((unsigned)entity_start, (unsigned)last_entity, (unsigned)entity_base);
                    last_entity = last_entity - (entity_start - entity_base);
                    if (message_level)
                        print_con("copygc end:\n");
#ifdef GC_TIME
    getrusage(RUSAGE_SELF, &ru);
    gc_time_sec += (ru.ru_utime.tv_sec - sec);
    gc_time_usec += (ru.ru_utime.tv_usec - usec);
#endif
                    return(GC_FAIL);
                }
                entity_area_size = (int)((float)entity_area_size * extent_rate);
                if (max_entity_area_size < entity_area_size)
                    entity_area_size = max_entity_area_size;
                entity_edge = (unsigned)entity_base + (unsigned)entity_area_size;
                half_size2 = ((((unsigned)entity_edge - (unsigned)entity_middle) / 2 ) / 4) * 4;
                if (( half_size2 - active_entity_size ) > size) {
                    entity_position = HIGH;
                    entity_top = entity_middle;
                    entity_middle = (unsigned *)((unsigned)entity_top + half_size2);
                    entity_bottom = (unsigned *)((unsigned)entity_middle + half_size2);
                    /* entity_start is updatede by copygc_body */
                    entity_end = entity_middle;
                    break;
                }
                half_size1 = ((entity_area_size / 2) / 4) * 4;
                if (( half_size1 - active_entity_size ) > size ) {
                    move_up_entity_area((unsigned)entity_start, (unsigned)last_entity, (unsigned)entity_base);
                    entity_position = HIGH;
                    last_entity = last_entity - (entity_start - entity_base);
                    entity_start = entity_base;
                    entity_middle = (unsigned *)((unsigned)entity_base + half_size1);
                    entity_bottom = (unsigned *)((unsigned)entity_middle + half_size1);
                    entity_top = entity_base;
                    entity_end = entity_middle;
                    break;
                }
            } /* while */
    } /* if */ else {
        if (message_level)
            print_con("from low to high\n");
        copygc_body((unsigned)entity_base);
        entity_position = HIGH;
        active_entity_size = (unsigned)last_entity - (unsigned)entity_base;
        if ( ((float)active_entity_size / ((float)entity_area_size / 2.0)) > 0.7 )
            entity_area_size = (int)((float)entity_area_size * extent_rate);
        if (entity_area_size > max_entity_area_size)
            entity_area_size = max_entity_area_size;

        half_size1 = ((entity_area_size / 2) / 4) * 4;
        while ( (half_size1 - active_entity_size) < size) {
            if (entity_area_size == max_entity_area_size) {
                if (message_level)
                    print_con("copygc end:\n");
#ifdef GC_TIME
    getrusage(RUSAGE_SELF, &ru);
    gc_time_sec += (ru.ru_utime.tv_sec - sec);
    gc_time_usec += (ru.ru_utime.tv_usec - usec);
#endif
                return(GC_FAIL);
            }
            entity_area_size = (int)((float)entity_area_size * extent_rate);
            if (entity_area_size > max_entity_area_size)
                entity_area_size = max_entity_area_size;
            half_size1 = ((entity_area_size / 2) / 4) * 4;
        }/* while */
        entity_area_size = half_size1 * 2;
        entity_top = entity_base;
        entity_middle = (unsigned *)((unsigned)entity_base + half_size1);
        entity_bottom = (unsigned *)((unsigned)entity_base + entity_area_size);
        entity_end = entity_middle; /* entity_start is updated by copygc_body */
    }
    if (message_level)
        print_con("copygc end:\n");
    if (message_level >= 2) {
        sprintf(messtr, "base = 0x%x,  fin = 0x%x, c_size = 0x%x(%d), max_size = 0x%x(%d)\n",
            (int)entity_base,
            (int)entity_fin,
            entity_area_size, entity_area_size,
            max_entity_area_size, max_entity_area_size);
        print_con(messtr);
        sprintf(messtr, "top = 0x%x, middle = 0x%x, bottom = 0x%x,\n", (int)entity_top,
            (int)entity_middle, (int)entity_bottom );
        print_con(messtr);
        sprintf(messtr, "start = 0x%x, end = 0x%x, last = 0x%x\n", (int)entity_start,
            (int)entity_end, (int)last_entity);
        print_con(messtr);
        sprintf(messtr, "vacancy =%5.1f %%\n\n" , 
            ( ((float)((int)entity_end - (int)last_entity)) / ((float)(entity_area_size / 2)) ) * 100.0);
        print_con(messtr);
    }
    act = (int)((unsigned)last_entity - (unsigned)entity_start);
#ifdef GC_TIME
    getrusage(RUSAGE_SELF, &ru);
    gc_time_sec += (ru.ru_utime.tv_sec - sec);
    gc_time_usec += (ru.ru_utime.tv_usec - usec);
#endif
    return(GC_SUCCESS);
}


int a4, a5;
extern gctraceflag;

Scopygc_trace_on()
{
    gctraceflag = 1;
    set_reg(LTAG_T);
}


Scopygc_trace_off()
{
    gctraceflag = 0;
    set_reg(LTAG_NIL);
}


Scopygc_state()
{
    char    messtr[256];

    if (fix_to_int(get_sval(gc_message_level_sym.obj)) >= 2) {
        sprintf(messtr, "base = 0x%x,  fin = 0x%x, c_size = 0x%x(%d), max_size = 0x%x(%d)\n",
            (int)entity_base,
            (int)entity_fin,
            entity_area_size, entity_area_size,
            max_entity_area_size, max_entity_area_size);
        print_con(messtr);
        sprintf(messtr, "top = 0x%x, middle = 0x%x, bottom = 0x%x,\n", (int)entity_top,
            (int)entity_middle, (int)entity_bottom );
        print_con(messtr);
        sprintf(messtr, "start = 0x%x, end = 0x%x, last = 0x%x\n", (int)entity_start,
            (int)entity_end, (int)last_entity);
        print_con(messtr);
        sprintf(messtr, "vacancy =%5.1f %%\n\n" , 
            ( ((float)((int)entity_end - (int)last_entity)) / ((float)(entity_area_size / 2)) ) * 100.0);
        print_con(messtr);
    }
    set_reg(LTAG_T);
}

#ifdef CALLIOC
extern unsigned *marked_stack_list;
#endif

#ifdef THINK_C
void
#endif
copygc_body(new_start)
unsigned new_start;
{
    unsigned a2, a3, d3, d4;
    unsigned *tmp;

#ifdef CALLIOC
    marked_stack_list = (unsigned *)LTAG_NIL;
    ((unsigned *)stack_bottom)[2] = 1;
#endif

    a2 = (unsigned)a2_val();
    if (a2 != LTAG_NIL)
        a2 = SSERDDA(a2) | LTAG_STRING;
    a3 = (unsigned)active_val();
    a4 = (unsigned)base_val();
    a5 = (unsigned)top_val();
    d3 = (unsigned)reg_reg;
    d4 = (unsigned)bcpc_reg;
    /* debug */ /* gctraceflag = 1; */

    if ((tmp = (unsigned *)get_sval(wplist.obj)) != (unsigned *)LTAG_NIL)
        set_sval(wplist.obj, ADDRESS(tmp) | LTAG_NIL);

    entity_start = (unsigned *)new_start; /* copygc_start will use entity_start */

#ifdef ASMGC
    set_active(new_start);
#else
    new_ent_add = (unsigned *)new_start;
#endif

    if (gctraceflag != 0) {
        gctraceflag = 0;
        copygc_init_hash();
        copygc_init_global_var();
	{
	    int i;

	    for (i = 0; i < sharp_eq_context_max; i++) {
		gcunit(&(sharp_eq_context[i].sharp_index));
		gcunit(&(sharp_eq_context[i].sharp_eq));
		gcunit(&(sharp_eq_context[i].sharp_sharp));
	    }
	}
        gctraceflag = 1;
    } else {
        copygc_init_hash();
        copygc_init_global_var();
	{
	    int i;

	    for (i = 0; i < sharp_eq_context_max; i++) {
		gcunit(&(sharp_eq_context[i].sharp_index));
		gcunit(&(sharp_eq_context[i].sharp_eq));
		gcunit(&(sharp_eq_context[i].sharp_sharp));
	    }
	}
    }

    if (c_strbuf != strbuf) {
        c_strbuf = (char *)(SSERDDA(c_strbuf) | LTAG_STRING);
        gcunit((unsigned *)&c_strbuf);
        c_strbuf = (char *)ADDRESS(c_strbuf);
    }
    /* printf("a2 gc : a2 = %x\n",a2); */
    /* printf("d3 gc : d3 = %x\n", d3); */
    /* printf("copygc init a2\n"); */
    gcunit(&a2);
    /* printf("copygc init reg\n"); */
    gcunit(&d3);
    /* printf("copy gc inint stack\n"); */
    /* stackdump2(1000); */

#ifdef ASMGC
    copygc_init_stack();
#else
# ifdef CALLIOC
    copygc_init_stack((unsigned *)stack_bottom);
# else
    copygc_init_stack((unsigned *)a4, (unsigned *)a5);
# endif
#endif

    /* printf("copy gc start\n");  */
    copygc_start();

#ifdef CALLIOC
    {
        unsigned *sb;

        for (sb = active_stacks; sb != NULL; sb = (unsigned *)(sb[3]))
            if (!sb[2])
                free_stack(sb);
            else
                sb[2] = 0;
    }
#endif
#ifdef ASMGC
    last_entity = active_val();
#else
    last_entity = new_ent_add;
#endif

    if ((tmp = (unsigned *)get_sval(wplist.obj)) != (unsigned *)LTAG_NIL)
        set_sval(wplist.obj, LTAG_WEAKPAIR | SSERDDA(ADDRESS(tmp)));

    if (a2 == LTAG_NIL)
        set_a2(LTAG_NIL);
    else
        set_a2(ADDRESS(a2));
    set_active(a3);
    set_base(a4);
    set_top(a5);
    set_reg(d3);
    set_pc(d4);
}


copygc_init_hash()
{
#ifdef ASMGC
    int i;
#else
    register int    i;
#endif

    /* printf("copygc init hash tabel\n"); */
    for (i = 0; i < hash_table_size; ++i)
        gcunit(hash_table + i);
    for (i = 0; i < bchashsize; ++i)
        gcunit(bchash + i);
}


copygc_init_global_var()
{
    /* printf("copygc int global var\n"); */
    /* This routine must be call after calling 
            'copygc_init_hash()' . */
    /* 1st : the symbol which the scheme system hold  initialize. */
    gcunit((unsigned *)&quotesym);
    gcunit((unsigned *)&qquotesym);
    gcunit((unsigned *)&atsym);
    gcunit((unsigned *)&commasym);

    /*
  gcunit((unsigned *)&loadsym);
  gcunit((unsigned *)&dumpsym);
  gcunit((unsigned *)&setsym);
  gcunit((unsigned *)&endsym);
  gcunit((unsigned *)&breakfunsym);
  gcunit((unsigned *)&breaknumsym);
  gcunit((unsigned *)&tracesym);
  gcunit((unsigned *)&untracesym);
  gcunit((unsigned *)&gctracesym);
  gcunit((unsigned *)&ungctracesym);
  gcunit((unsigned *)&pctracesym);
  gcunit((unsigned *)&unpctracesym);
  gcunit((unsigned *)&settracesym);
  gcunit((unsigned *)&breakpointsym);
  gcunit((unsigned *)&dumppointsym);
  gcunit((unsigned *)&stacksym);
*/

    gcunit((unsigned *)&definesym);
    gcunit((unsigned *)&macrosym);
    gcunit((unsigned *)&xreturnsym);
    gcunit((unsigned *)&lreturnsym);
    gcunit((unsigned *)&xcallsym);
    gcunit((unsigned *)&c_f_sym);
    gcunit((unsigned *)&mkncsym);
    gcunit((unsigned *)&sctopsym);
    gcunit((unsigned *)&errsym); 		/* By N.Watanabe 92/11/19 */
    gcunit((unsigned *)&recomsym); 		/* By A243  */
    gcunit((unsigned *)&recomlevel); 		/* By A243  */
#ifdef PVM3
    gcunit((unsigned *)&bctran_exec_form_sym); 		/* By A243  */    
    gcunit((unsigned *)&sharp_closure_pvm); 		/* By A243  */    
    gcunit((unsigned *)&pvm_recv_function); 		/* By A243  */    
    gcunit((unsigned *)&pvm_reduce_function); 		/* By A243  */    
    gcunit((unsigned *)&pvm_get_unbound_obj); 		/* By A243  */    
    gcunit((unsigned *)&pvm_put_unbound_obj); 		/* By A243  */    
#endif
    gcunit((unsigned *)&debugsym);
    gcunit((unsigned *)&user_exec_sym);
    gcunit((unsigned *)&sys_debug_sym);
    gcunit((unsigned *)&bcloadsym);
    gcunit((unsigned *)&bc_trace_proc_sym);
    gcunit((unsigned *)&sysfun_tracer_body);
    gcunit((unsigned *)&max_back_trace_depth_sym);
    gcunit((unsigned *)&gc_message_level_sym);
    gcunit((unsigned *)&msgc_to_copygc_sym);
    gcunit((unsigned *)&struct_sym);
    gcunit((unsigned *)&l_t_e_sym);
#ifdef PVM3
    gcunit((unsigned *)&pvm_l_t_e_sym);      /* By A243 */
#endif
    gcunit((unsigned *)&local_fun_sym);
    gcunit((unsigned *)&beginsym);
    gcunit((unsigned *)&bcload_with_cip_sym);

    /* 2nd: the other object which the scheme system hold */
    gcunit((unsigned *)&unbound_obj);
    gcunit((unsigned *)&eof_obj);
    gcunit((unsigned *)&reg1);
    gcunit((unsigned *)&reg2);
    gcunit((unsigned *)&reg3);
    gcunit((unsigned *)&stdin_port);
    gcunit((unsigned *)&stdout_port);
    gcunit((unsigned *)&c_in_port);
    gcunit((unsigned *)&c_out_port);
    gcunit((unsigned *)&bcconst);
    gcunit((unsigned *)&xfunconst);
    gcunit((unsigned *)&bcraw);
    gcunit((unsigned *)&bcraw2);
    gcunit((unsigned *)&bcbody);
    gcunit((unsigned *)&acode);
    gcunit((unsigned *)&tempp);
    gcunit((unsigned *)&cdrbody);
    gcunit((unsigned *)&bcf);
    gcunit((unsigned *)&bcfhead);
    gcunit((unsigned *)&call_cc_arg);
    gcunit((unsigned *)&top_of_aflk);
    gcunit((unsigned *)&end_of_aflk);
    gcunit((unsigned *)&af_tmp);
    gcunit((unsigned *)&more);
#ifdef CTHREAD
    gcunit((unsigned *)&optcnt);
#endif
    gcunit((unsigned *)&portlist);
    gcunit((unsigned *)&ncclist);
    gcunit((unsigned *)&wplist);

#ifdef TCPIP
    gcunit (&conn_timeout);
    gcunit (&tcp_timeout);
    gcunit (&udp_timeout);
    gcunit (&accept_timeout);
    gcunit (&localhostname);
#endif

#ifdef NIHONGO
    gcunit((unsigned *)&default_kanji_input_code_sym);
    gcunit((unsigned *)&default_kanji_output_code_sym);
#ifdef TCPIP
    gcunit((unsigned *)&default_network_kanji_input_code_sym);
    gcunit((unsigned *)&default_network_kanji_output_code_sym);
#endif
    gcunit((unsigned *)&euc_sym);
    gcunit((unsigned *)&jis_sym);
    gcunit((unsigned *)&sjis_sym);
    gcunit((unsigned *)&noc_sym);
#endif

    gcunit((unsigned *)&print_circle_sym);	/* By ushijima */

    if (system_function_loading_flag == ON)
        gcunit((unsigned *)&protect_symbol_listsym);
}


gcunit1(add)
unsigned *add;
{
    a_gc_debug(*add, (int)NULL);
    gcunit(add);
}

#ifdef THINK_C
void
#endif
move_up_entity_area(start, end, to)
unsigned start;
unsigned end;
unsigned to;
{
    int dist;
    int i;
    unsigned a2, a3, d3, d4;
    a2 = (unsigned)a2_val();
    a3 = (unsigned)active_val();
    a4 = (unsigned)base_val();
    a5 = (unsigned)top_val();
    d3 = (unsigned)reg_val();
    d4 = (unsigned)d4_val();
    dist = start - to;
    if (message_level)
        print_con("moveing up a entity area from low to high.\n");
    add_dis((unsigned *)&quotesym, dist);
    add_dis((unsigned *)&qquotesym, dist);
    add_dis((unsigned *)&atsym, dist);
    add_dis((unsigned *)&commasym, dist);

    /*
  add_dis((unsigned *)&loadsym, dist);
  add_dis((unsigned *)&dumpsym, dist);
  add_dis((unsigned *)&setsym, dist);
  add_dis((unsigned *)&endsym, dist);
  add_dis((unsigned *)&breakfunsym, dist);
  add_dis((unsigned *)&breaknumsym, dist);
  add_dis((unsigned *)&tracesym, dist);
  add_dis((unsigned *)&untracesym, dist);
  add_dis((unsigned *)&gctracesym, dist);
  add_dis((unsigned *)&ungctracesym, dist);
  add_dis((unsigned *)&pctracesym, dist);
  add_dis((unsigned *)&unpctracesym, dist);
  add_dis((unsigned *)&settracesym, dist);
  add_dis((unsigned *)&breakpointsym, dist);
  add_dis((unsigned *)&dumppointsym, dist);
  add_dis((unsigned *)&stacksym, dist);
*/

    add_dis((unsigned *)&definesym, dist);
    add_dis((unsigned *)&macrosym, dist);
    add_dis((unsigned *)&xreturnsym, dist);
    add_dis((unsigned *)&lreturnsym, dist);
    add_dis((unsigned *)&xcallsym, dist);
    add_dis((unsigned *)&c_f_sym, dist);
    add_dis((unsigned *)&mkncsym, dist);
    add_dis((unsigned *)&sctopsym, dist);
    add_dis((unsigned *)&errsym, dist);	/* By N.Watanabe 92/11/19 */
    add_dis((unsigned *)&recomsym, dist);	/* By A243 */
    add_dis((unsigned *)&recomlevel, dist);	/* By A243 */
#ifdef PVM3
    add_dis((unsigned *)&bctran_exec_form_sym, dist);	/* By A243 */    
    add_dis((unsigned *)&sharp_closure_pvm, dist);	/* By A243 */    
    add_dis((unsigned *)&pvm_recv_function, dist);	/* By A243 */    
    add_dis((unsigned *)&pvm_reduce_function, dist);	/* By A243 */    
    add_dis((unsigned *)&pvm_get_unbound_obj, dist);	/* By A243 */    
    add_dis((unsigned *)&pvm_put_unbound_obj, dist);	/* By A243 */    
#endif
    add_dis((unsigned *)&debugsym, dist);
    add_dis((unsigned *)&user_exec_sym, dist);
    add_dis((unsigned *)&sys_debug_sym, dist);
    add_dis((unsigned *)&bcloadsym, dist);
    add_dis((unsigned *)&bc_trace_proc_sym, dist);
    add_dis((unsigned *)&sysfun_tracer_body, dist);
    add_dis((unsigned *)&max_back_trace_depth_sym, dist);
    add_dis((unsigned *)&gc_message_level_sym, dist);
    add_dis((unsigned *)&msgc_to_copygc_sym, dist);
    add_dis((unsigned *)&struct_sym, dist);
    add_dis((unsigned *)&l_t_e_sym, dist);
#ifdef PVM3
    add_dis((unsigned *)&pvm_l_t_e_sym, dist);   /* By A243 */
#endif
    add_dis((unsigned *)&local_fun_sym, dist);
    add_dis((unsigned *)&beginsym, dist);
    add_dis((unsigned *)&bcload_with_cip_sym, dist);

    add_dis((unsigned *)&unbound_obj, dist);
    add_dis((unsigned *)&eof_obj, dist);
    add_dis((unsigned *)&reg1, dist);
    add_dis((unsigned *)&reg2, dist);
    add_dis((unsigned *)&reg3, dist);
    add_dis((unsigned *)&stdin_port, dist);
    add_dis((unsigned *)&stdout_port, dist);
    add_dis((unsigned *)&c_in_port, dist);
    add_dis((unsigned *)&c_out_port, dist);
    add_dis((unsigned *)&bcconst, dist);
    add_dis((unsigned *)&xfunconst, dist);
    add_dis((unsigned *)&bcraw, dist);
    add_dis((unsigned *)&bcraw2, dist);
    add_dis((unsigned *)&bcbody, dist);
    add_dis((unsigned *)&acode, dist);
    add_dis((unsigned *)&tempp, dist);
    add_dis((unsigned *)&cdrbody, dist);
    add_dis((unsigned *)&bcf, dist);
    add_dis((unsigned *)&bcfhead, dist);
    add_dis((unsigned *)&call_cc_arg, dist);
    add_dis((unsigned *)&top_of_aflk, dist);
    add_dis((unsigned *)&end_of_aflk, dist);
    add_dis((unsigned *)&af_tmp, dist);
    add_dis((unsigned *)&more, dist);
#ifdef CTHREAD
    add_dis((unsigned *)&optcnt, dist);
#endif
    add_dis((unsigned *)&portlist, dist);
    add_dis((unsigned *)&ncclist, dist);
    add_dis((unsigned *)&wplist, dist);

#ifdef TCPIP
    add_dis (&conn_timeout, dist);
    add_dis (&tcp_timeout, dist);
    add_dis (&udp_timeout, dist);
    add_dis (&accept_timeout, dist);
    add_dis (&localhostname, dist);
#endif

#ifdef NIHONGO
    add_dis((unsigned *)&default_kanji_input_code_sym, dist);
    add_dis((unsigned *)&default_kanji_output_code_sym, dist);
#ifdef TCPIP
    add_dis((unsigned *)&default_network_kanji_input_code_sym, dist);
    add_dis((unsigned *)&default_network_kanji_output_code_sym, dist);
#endif
    add_dis((unsigned *)&euc_sym, dist);
    add_dis((unsigned *)&jis_sym, dist);
    add_dis((unsigned *)&sjis_sym, dist);
    add_dis((unsigned *)&noc_sym, dist);
#endif

    add_dis((unsigned *)&print_circle_sym, dist);	/* By ushijima */

    if (system_function_loading_flag == ON)
        add_dis(&protect_symbol_listsym, dist);

    for (i = 0; i < hash_table_size; ++i)
        add_dis(hash_table + i, dist);
    for (i = 0; i < bchashsize; ++i)
        add_dis( bchash + i , dist);

#ifdef ASMGC
    add_dist_stack(dist);
#else
# ifdef CALLIOC
    {
        unsigned *sb;

        for (sb = active_stacks; sb != NULL; sb = (unsigned *)(sb[3]))
            add_dist_stack(dist, sb);
    }
# else
    add_dist_stack(dist, (unsigned *)a4, (unsigned *)a5);
# endif
#endif

    block_move(start, end, to, dist);
    if (a2 != LTAG_NIL)
        a2 = a2 - dist;
    if (c_strbuf != strbuf)
        c_strbuf = c_strbuf - dist;
    set_a2(a2);
    add_dis(&d3, dist);
    set_active(a3);
    set_base(a4);
    set_top(a5);
    set_reg(d3);
    set_pc(d4);
}

#ifdef THINK_C
void
#endif
add_dis(pointer, dist)
unsigned *pointer;
int dist;
{
    if ( (!(*pointer & 0xfc000000)) || (*pointer & 0x80000000) ) {
        *pointer = *pointer - dist;
    }
}

#ifdef THINK_C
void
#endif
a_gc_debug(obj, address)
int obj;
int address;
{
    fprintf(debug_stream, "(debug)");
    fprintf(debug_stream, "obj=%x, address=%x, gctraceflag = %d\n", obj, address, gctraceflag);
    fflush(debug_stream);
}


