/*
 * equivalence.c - 
 */

/*
 * $Id: equivalence.c,v 1.3 2004/06/24 11:15:05 komiya Exp $
 */

/****************************************/
/*                                      */
/*  File Name : equivalence.c           */
/*  Update    : Yass.  Sep.  6 '90      */
/*              Yass.  Aug. 27 '90      */
/*              Yass.  Aug. 24 '90      */
/*              Yass.  Jul. 17 '90      */
/*              Yass.  Jul.  6 '90      */
/*              Myama. ?                */
/*                                      */
/*    Equivalence predicate operations  */
/*                                      */
/****************************************/

static char *RCSid="$Id: equivalence.c,v 1.3 2004/06/24 11:15:05 komiya Exp $";

#include "scheme.h"


/********************************/
/*                              */
/*  Internal useful procedures  */
/*                              */
/********************************/

eqeq(obj1, obj2)  /*  by T.Komiya  */
unsigned obj1, obj2;
{ 
    int tag,
    cplx_flag = FALSE;

    tag = GETnum_tag(obj1);
    if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2 && tag != LTAG_NUMBER3 && 
        GETtag(obj1) != LTAG_FLOAT)
        return(FALSE);
    if (GETtag(obj1) == LTAG_COMPLEX)
        cplx_flag = TRUE;
    tag = GETnum_tag(obj2);
    if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2 && tag != LTAG_NUMBER3 && 
        GETtag(obj2) != LTAG_FLOAT)
        return(FALSE);
    if (GETtag(obj2) == LTAG_COMPLEX && cplx_flag) { 
        if (comp_cplx(obj1, obj2) == EQUAL)
            return(TRUE);
        else
            return(FALSE);
    }
    if (cplx_flag || GETtag(obj2) == LTAG_COMPLEX)
        return(FALSE);
    if (comp_obj(obj1, obj2, 0) & NEQ)
        return(FALSE);
    return(TRUE);
}

int eqv(obj1, obj2)  /*  Yass. Jul. 17 '90  */
unsigned obj1, obj2;
{ 
    unsigned int tag1, tag2;

    if (EQ(obj1, obj2))
        return(TRUE);
    tag1 = GETtag(obj1);
    tag2 = GETtag(obj2);
    if (tag1 != tag2)
    	return(eqeq(obj1, obj2));
/*        return(FALSE); */
    switch (tag1) { 
    case LTAG_BIGNUM   :
    case LTAG_FLOAT    :
    case LTAG_FRACTION :
        if (comp_obj(obj1, obj2, 0) == EQUAL)
            return(TRUE);
        else
            return(FALSE);
        break;
    case LTAG_COMPLEX  :
        if (comp_cplx(obj1, obj2) == EQUAL)
            return(TRUE);
        else
            return(FALSE);
        break;
    case LTAG_STRING   :
    case LTAG_SSTRING  :
        if (((ENTITYP)ADDRESS(obj1))->str.str_len == 0 && 
            ((ENTITYP)ADDRESS(obj2))->str.str_len == 0)
            return(TRUE);
        else
            return(FALSE);
        break;
    case LTAG_NILVECTOR   :
        return(TRUE);
    case LTAG_VECTOR   :
        return(FALSE);
        break;
    default :
        return(FALSE);
        break;
    }
}


int equal(obj1, obj2)  /*  Yass. Sep. 6 '90  */
unsigned obj1, obj2;
{ 
    unsigned int elm1, elm2, tag1, tag2, i;

BEGIN:

#ifdef CTHREAD
    if (GETtag(obj1) == LTAG_FUTURE)
	obj1 = touch_obj(obj1);
    if (GETtag(obj2) == LTAG_FUTURE)
	obj2 = touch_obj(obj2);
#endif
    if (eqv(obj1, obj2))
        return(TRUE);
    tag1 = GETtag(obj1);
    tag2 = GETtag(obj2);
    if (tag1 != tag2 && ((tag1 != LTAG_STRING && tag1 != LTAG_SSTRING) || 
        (tag2 != LTAG_STRING && tag2 != LTAG_SSTRING)))
        return(FALSE);
    switch (tag1) { 
    case LTAG_CONS    :         /* T.Komiya */
        if (!equal(CARobj(obj1), CARobj(obj2)))
            return(FALSE);
        obj1 = CDRobj(obj1);
        obj2 = CDRobj(obj2);
        goto BEGIN;
    case LTAG_VECTOR  :
        elm1 = IMM(((ENTITYP)ADDRESS(obj1))->vec.head) >> 2;
        elm2 = IMM(((ENTITYP)ADDRESS(obj2))->vec.head) >> 2;
        if (elm1 != elm2)
            return(FALSE);
        for (i = 1 ; i <= elm1 ; i++) { 
            if (equal(*(((unsigned *)ADDRESS(obj1)) + i), *(((unsigned *)ADDRESS(obj2)) + i)) == FALSE)
                return(FALSE);
        }
        return(TRUE);
        break;
    case LTAG_STRING :
    case LTAG_SSTRING :
	if (GETtag(((STRING * )ADDRESS(obj1))->head) == LTAG_BLOCK1)
	    obj1 = ((STRING * )ADDRESS(obj1))->str_len;
	if (GETtag(((STRING * )ADDRESS(obj2))->head) == LTAG_BLOCK1)
	    obj2 = ((STRING * )ADDRESS(obj2))->str_len;

        elm1 = ((ENTITYP)ADDRESS(obj1))->str.str_len;
        elm2 = ((ENTITYP)ADDRESS(obj2))->str.str_len;

        if (elm1 != elm2)
            return(FALSE);
        if (((ENTITYP)ADDRESS(obj1))->str.str_kind == A_STRING) { 
            if (((ENTITYP)ADDRESS(obj2))->str.str_kind == A_STRING) { 
                for (i = 1 ; i <= elm1 ; i++) { 
                    if (*(((char *)ADDRESS(obj1)) + i + 11) != *(((char *)ADDRESS(obj2)) + i + 11))
                        return(FALSE);
                }
            } else { 
                for (i = 1 ; i <= elm1 ; i++) { 
                    if (*(((char *)ADDRESS(obj1)) + i + 11) != *(((char *)ADDRESS(obj2)) + i*2 + 11))
                        return(FALSE);
                }
            }
        } else { 
            if (((ENTITYP)ADDRESS(obj2))->str.str_kind == A_STRING) { 
                for (i = 1 ; i <= elm1 ; i++) { 
                    if (*(((char *)ADDRESS(obj1)) + i*2 + 11) != *(((char *)ADDRESS(obj2)) + i + 11))
                        return(FALSE);
                }
            } else { 
                for (i = 1 ; i <= elm1 ; i++) { 
                    if (*(((char *)ADDRESS(obj1)) + i + 11) != *(((char *)ADDRESS(obj2)) + i + 11))
                        return(FALSE);
                }
            }
        }
        return(TRUE);
        break;
    case LTAG_WEAKPAIR :        /* T.Komiya */
        if (!equal(*((unsigned *)ADDRESS(obj1) + 3), *((unsigned *)ADDRESS(obj2) + 3)))
            return(FALSE);
        obj1 = *((unsigned *)ADDRESS(obj1) + 1);
        obj2 = *((unsigned *)ADDRESS(obj2) + 1);
        goto BEGIN;
    case LTAG_LOSTOBJ1 :
	return(TRUE);
    case LTAG_STRUCTURE :
	for (i = 1; i <= IMM(*((unsigned *)ADDRESS(obj1))) >> 2; i++)
	    if (equal(*((unsigned *)ADDRESS(obj1) + i), *((unsigned *)ADDRESS(obj2) + i))
		== FALSE)
		return(FALSE);
	return(TRUE);
    default :
        return(FALSE);
        break;
    }
}


/***********************************/
/*                                 */
/*  Essential standard procedures  */
/*                                 */
/***********************************/

Seq()  /*  Yass. Jul. 6 '90  */
{
#ifdef TOUCH_ARG
    if (EQ(touch_obj(getarg(1)), touch_obj(getarg(2))))
#else
    if (EQ(getarg(1), getarg(2)))
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


Seqv()  /*  Yass. Jul. 6 '90  */
{
#ifdef TOUCH_ARG
    if (eqv(touch_obj(getarg(1)), touch_obj(getarg(2))))
#else
    if (eqv(getarg(1), getarg(2)))
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


Sequal()  /*  Yass. Jul. 6 '90  */
{
    if (equal(getarg(1), getarg(2)))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


