/*
 * err_handler.c - 
 */

/*
 * $Id: err_handler.c,v 1.3 2004/06/24 09:18:43 komiya Exp $
 *

        TUTScheme system's error handle routines.
	File Name : err_handler.c
	Produced By N.Watanabe     Sep. 26, 1992  

*/

static char *RCSid="$Id: err_handler.c,v 1.3 2004/06/24 09:18:43 komiya Exp $";

#include "scheme.h"

#define  SCPOP()	(*(sp_reg++)) 
#define  SCPUSH(val)    *(--sp_reg)=(unsigned)(val)
#define  PCUP(n)        bcpc_reg+=(n)

#define FUNCTION_ARGV_MAX 128

#if defined(__CYGWIN32__) || defined(linux)
extern sigjmp_buf 	exit_bc_interpreter;
#else
extern jmp_buf 	exit_bc_interpreter;
#endif

int iretaddrx();

int err_recover();            /*  By N.Watanabe Sep. 21 1992  */
int err_recover_get_gval();   /*  By N.Watanabe Nov. 02 1992  */
int err_recover_push_gval();  /*  By N.Watanabe Nov. 02 1992  */
int err_recover_set_gval();   /*  By N.Watanabe Nov. 06 1992  */
int err_nonrecover();        

int make_symbol_obj(sym_str)  /*  By N.Watanabe Sep. 25, 1992 */
char *sym_str;
{
    return(addsymbol(mk_str(SYMBOL_STRING,A_STRING,strlen(sym_str),
			    sym_str)
			    ,LTAG_ORDINARY));
}

int make_string_obj(str)  /*  By N.Watanabe Sep. 26, 1992 */
char *str;
{
    return(mk_str(SYMBOL_STRING, A_STRING, strlen(str), str));
}

int make_list_obj(argc,args)  /*  By N.Watanabe Sep. 26, 1992  */
int argc, args[];
{
    CARCDR *top, *cell;
    int i;
    
    if(argc <= 0) 
	return(LTAG_NIL);
    else {
	for(i=argc ; i>0 ; i--){
	    s_push(args[i-1]);
	}
/*	s_push(argc); ??? */
	top = cell = (CARCDR * )mk_nconsp(argc);
/*	argc = s_pop(); ??? */
	for(i=0 ; i<argc ; i++){
	    cell->car.obj = s_pop();
	    cell++;
	}
	return(SSERDDA(top) | LTAG_CONS);
    }
}

get_function_and_arguments(fun,arglist)  /*  By N.Watanabe Dec. 10, 1992. */
unsigned *fun, *arglist;
{
    int i, argc;
    unsigned *active_p;
    CARCDR *top, *cell;

    active_p = (unsigned *) active_val();
    argc = (unsigned *) active_p - (unsigned *) top_val();
    argc--;

    if(argc >= 0){
	*fun = *(active_p - 1); 
    }
    else {
	*fun = LTAG_NIL;
    }

    if(argc <= 0) {
	*arglist = LTAG_NIL;
    }
    else {
/*	int tmp, *p;

	for(i=0, p=0 ; i<argc ; i++){
	    tmp = *(active_p - (unsigned *)((argc+1)*4) + p);
	    s_push(tmp);
	    p++;
	}
*/
	int tmp;

	for(i=argc; i > 0; i--){
	    tmp = *(active_p - i - 1);
	    s_push(tmp);
	}
/*	s_push(argc); */   /* GC taisaku. */ /* T.Komiya */
/*	s_push(arglist); ??? */
	top = cell = (CARCDR * )mk_nconsp(argc);
/*	arglist = (unsigned *) s_pop(); ??? */
/*	argc = s_pop(); */  /* GC taisaku. */ /* T.Komiya */
	for(i=0 ; i<argc ; i++){
	    cell->car.obj = s_pop();
	    cell++;
	}
	*arglist = (SSERDDA(top) | LTAG_CONS);
    }
}

set_up_stack_for_error_handler(class_str)  /* By N.Watanabe Oct. 6, 1993 */
char *class_str;
{
    int arglist, fun;
    unsigned tmp;

    error_prologue();
    get_function_and_arguments(&fun, &arglist);
    open_frame2(err_recover, LTAG_NIL, 0);
    active_reg = base_reg;
    s_push(get_sval(errsym));
    tmp = make_symbol_obj(class_str);
    s_push(tmp);
    tmp = make_symbol_obj("function");
    s_push(tmp);
    s_push(fun);
    tmp = make_symbol_obj("arguments");
    s_push(tmp);
    s_push(arglist);
}

set_up_stack_epilogue()  /*  By N.Watanabe Oct. 6, 1993  */
{
    xcall();
    open_frame2(iretaddrx, LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg);
    active_reg = base_reg;
    xreturn();
}


error_handler(message)  /*  By N.Watanabe Aug. 25, 1992  */
char *message;
{
    unsigned *dumy, tmp;

    set_up_stack_for_error_handler("simple-error");

    tmp = make_symbol_obj("format-string");
    s_push(tmp);
    tmp = make_string_obj(message);
    s_push(tmp);
    tmp = make_symbol_obj("format-arguments");
    s_push(tmp);
    tmp = make_list_obj(0,dumy);
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}


err_error(errmsg)  /*  By N.Watanabe Sep. 26, 1992  */
char *errmsg;
{
    unsigned tmp;

    error_prologue();
    open_frame2(err_recover, LTAG_NIL, 0);
    active_reg = base_reg;
    s_push(get_sval(errsym));
    tmp = make_string_obj(errmsg);
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}    
 
err_simple_error(format_str, format_args) /* By N.Watanabe Set. 26, 1992 */
char *format_str;
int  format_args[];
{
    set_up_stack_for_error_handler("simple-error");

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

err_illegal_number_of_arguments(message, arginfo) 
                                           /* By N.Watanabe Oct. 08, 1992 */
char * message;
int    arginfo;
{
    int argnum;
    unsigned tmp;

    argnum = (IMM(arginfo) >> 2) - 1;

    set_up_stack_for_error_handler("illegal-number-of-arguments");

    tmp = make_symbol_obj("message");
    s_push(tmp);
    tmp = make_string_obj(message);
    s_push(tmp);
    tmp = make_symbol_obj("number-of-arguments");
    s_push(tmp);
    s_push(mk_fix(argnum));
    tmp = make_symbol_obj("rest");
    s_push(tmp);
    if(arginfo & 0x3){
	s_push(LTAG_T);
    }
    else{
	s_push(LTAG_FALSE);
    }

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
}

err_illegal_argument(message) /* By N.Watanabe Oct. 05, 1992 */
char * message;
{
    unsigned tmp;

    set_up_stack_for_error_handler("illegal-argument");

    tmp = make_symbol_obj("message");
    s_push(tmp);
    tmp = make_string_obj(message);
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

err_illegal_argument_type(obj,type) /* By N.Watanabe Nov. 24, 1992 */
int    obj;
char * type;
{
    unsigned tmp;

    set_up_stack_for_error_handler("illegal-argument-type");

    tmp = make_symbol_obj("object");
    s_push(tmp);
    s_push(obj);
    tmp = make_symbol_obj("type");
    s_push(tmp);
    tmp = make_string_obj(type);
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

err_not_function_apply() /* By N.Watanabe Oct. 04, 1992 */
{
    set_up_stack_for_error_handler("not-function-apply");

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

err_unbound_symbol(obj)  /*  By N.Watanabe Oct. 05, 1992.  */
int obj;
{
    unsigned tmp;

    set_up_stack_for_error_handler("unbound-symbol");

    tmp = make_symbol_obj("object");
    s_push(tmp);
    s_push(obj);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

err_unbound_symbol2(obj)  /*  By N.Watanabe Nov. 02, 1992.  */
int obj;                 
{
    unsigned tmp;

    error_prologue();
    open_frame2(err_recover_get_gval,
		LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg);
    active_reg = base_reg;
    s_push(get_sval(errsym));
    tmp = make_symbol_obj("unbound-symbol-bci");
    s_push(tmp);
    tmp = make_symbol_obj("object");
    s_push(tmp);
    s_push(obj);
    tmp = make_symbol_obj("byte-code-function");
    s_push(tmp);
    tmp = make_symbol_obj("get-gval");
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
}

err_unbound_symbol3(obj)  /*  By N.Watanabe Nov. 02, 1992.  */
int obj;
{
    unsigned tmp;

    error_prologue();
    open_frame2(err_recover_push_gval, 
		LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg);
    active_reg = base_reg;
    s_push(get_sval(errsym));
    tmp = make_symbol_obj("unbound-symbol-bci");
    s_push(tmp);
    tmp = make_symbol_obj("object");
    s_push(tmp);
    s_push(obj);
    tmp = make_symbol_obj("byte-code-function");
    s_push(tmp);
    tmp = make_symbol_obj("push-gval");
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
}

err_unbound_symbol4(obj)  /*  By N.Watanabe Nov. 19, 1992.  */
int obj;
{
    unsigned tmp;

    error_prologue();
    open_frame2(err_recover_set_gval, 
		LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg);
    active_reg = base_reg;
    s_push(get_sval(errsym));
    tmp = make_symbol_obj("unbound-symbol-bci");
    s_push(tmp);
    tmp = make_symbol_obj("object");
    s_push(tmp);
    s_push(obj);
    tmp = make_symbol_obj("byte-code-function");
    s_push(tmp);
    tmp = make_symbol_obj("set-gval");
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
}

err_not_ordinary_symbol(obj)  /*  By N.Watanabe Oct. 05, 1992.  */
int obj;
{
    unsigned tmp;

    set_up_stack_for_error_handler("not-ordinary-symbol");

    tmp = make_symbol_obj("object");
    s_push(tmp);
    s_push(obj);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
}



err_division_by_zero()  /*  By N.Watanabe Sep. 26, 1992  */
{
    set_up_stack_for_error_handler("division-by-zero");

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

err_stream_error(message, stream)  /*  By N.Watanabe Nov. 09, 1992  */
char *message;
int stream;
{
    unsigned tmp;

    set_up_stack_for_error_handler("stream-error");

    tmp = make_symbol_obj("stream");
    s_push(tmp);
    s_push(stream);
    tmp = make_symbol_obj("message");
    s_push(tmp);
    tmp = make_string_obj(message);
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

err_file_error(message, pathname)  /*  By N.Watanabe Nov. 09, 1992  */
char *message;
int pathname;
{
    unsigned tmp;

    set_up_stack_for_error_handler("file-error");

    tmp = make_symbol_obj("pathname");
    s_push(tmp);
    s_push(pathname);
    tmp = make_symbol_obj("message");
    s_push(tmp);
    tmp = make_string_obj(message);
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

err_read_error(message)  /*  By N.Watanabe Nov. 17, 1992  */
char *message;
{
    unsigned tmp;

    set_up_stack_for_error_handler("read-error");

    tmp = make_symbol_obj("message");
    s_push(tmp);
    tmp = make_string_obj(message);
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}


err_system_error(message)  /*  By N.Watanabe Nov. 24, 1992  */
char *message;
{
    unsigned tmp;

    set_up_stack_for_error_handler("system-error");

    tmp = make_symbol_obj("message");
    s_push(tmp);
    tmp = make_string_obj(message);
    s_push(tmp);

    set_up_stack_epilogue();  /*  By N.Watanabe Oct. 6, 1993  */
    return_to_bc_interpreter();
}

/* Note : Following function is same as "xreturn". */
int err_recover()  /*  By N.Watanabe Sep. 21 1992  */
{
    int (*retaddr)();

    sp_reg = active_reg;
    base_reg = (unsigned *)SCPOP();
    active_reg = (unsigned *)SCPOP();
    retaddr = (int (*)())SCPOP();
    retaddr();
}

int err_recover_get_gval()  /*  By N.Watanabe Nov. 02 1992  */
{
    bcpc_reg = SCPOP();
    bcbody_reg = (unsigned *)ADDRESS(SCPOP());
    PCUP(2);
}

#ifdef CALLIOC
/* same as recover_set_gval_ep() */
/*
int err_recover_get_gval_ep()
{
    bcpc_reg = SCPOP();
    bcbody_reg = (unsigned *)ADDRESS(*((unsigned *)ADDRESS(SCPOP())+1));
    PCUP(2);
}

int err_recover_set_gval_ep()
{
    bcpc_reg = SCPOP();
    bcbody_reg = (unsigned *)ADDRESS(*((unsigned *)ADDRESS(SCPOP())+1));
    PCUP(2);
}
*/
int err_recover_push_gval_ep()
{
    bcpc_reg = SCPOP();
    bcbody_reg = (unsigned *)ADDRESS(*((unsigned *)ADDRESS(SCPOP())+1));
    SCPUSH(reg_reg);
    PCUP(2);
    ((unsigned *)stack_bottom)[5]--;
}

#endif

int err_recover_push_gval()  /*  By N.Watanabe Nov. 02 1992  */
{
    bcpc_reg = SCPOP();
    bcbody_reg = (unsigned *)ADDRESS(SCPOP());
    SCPUSH(reg_reg);
    PCUP(2);
}

int err_recover_set_gval()  /*  By N.Watanabe Nov. 06. 1992  */
{
    bcpc_reg = SCPOP();
    bcbody_reg = (unsigned *)ADDRESS(SCPOP());
    PCUP(2);
}

int err_nonrecover()  /*  By N.Watanabe Sep. 21 1992  */
{
}

/*
  Back trace function.
*/
Sback_trace()
{
    back_trace();
    set_reg(LTAG_T);
}

/*
  Return to scheme top level loop
*/
Sreturn_sctop()
{
#ifdef LTC
    interr(2);
#else
# if defined(__CYGWIN32__) || defined(linux)
    siglongjmp(toplevel, 1);
# else
    longjmp(toplevel, 1);
# endif
#endif
}

#ifdef CTHREAD
extern REGS saved_context;
#endif

return_to_bc_interpreter()
{
#ifdef CTHREAD
# ifdef USE_REG
#  if defined(LUNA)
    saved_context._base_reg = base_reg;
    saved_context._sp_reg = sp_reg;
    saved_context._reg_reg = reg_reg;
    saved_context._bcpc_reg = bcpc_reg;
    saved_context._bcbody_reg = bcbody_reg;
#  elif defined(SUN)
    saved_context = *main_thread_regs;
#  endif
# endif
#endif
#ifdef LTC
    interr(2);
#else
# if defined(__CYGWIN32__) || defined(linux)
    siglongjmp(exit_bc_interpreter, 2);
# else
    longjmp(exit_bc_interpreter, 2);
# endif
#endif
}
