/*
 * inet.h
 */

/*
 * $Id: inet.h,v 1.2 1998/10/29 05:11:54 shige Exp $
 *
 * Definitions for networking functions.
 *
 *					N.Kurabayashi
 */

#ifdef TCPIP

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/param.h>
#include <netinet/in.h>
#include <netdb.h>

#ifndef SOMAXCONN
#define SOMAXCONN  5
#endif

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN	64
#endif

#define UDP_BOUND	1		/* flag stored in dummy field */

#define IPPORT_ULIMIT     32767		/* limit most port number */
#define FREEZE_FILE_NAME  "saved_dtus"	/* default file name of freeze */

#define _tcpportp(p)    (((PORT *) ADDRESS (p))->kind == TCP_STREAM)
#define _udpportp(p)    (((PORT *) ADDRESS (p))->kind == UDP_DGRAM)
#define _netportp(p)    (_tcpportp (p) || _udpportp (p))
#define _boundportp(p)  (((PORT *) ADDRESS (p))->kind == TCP_BOUND)

#define tcpportp(x)    (GETtag (x) == LTAG_PORT && _tcpportp (x))
#define udpportp(x)    (GETtag (x) == LTAG_PORT && _udpportp (x))
#define netportp(x)    (GETtag (x) == LTAG_PORT && _netportp (x))
#define boundportp(x)  (GETtag (x) == LTAG_PORT && _boundportp (x))

#define mk_tcpport(s,p)    mk_netport (TCP_STREAM, (s), (p))
#define mk_udpport(s,p)    mk_netport (UDP_DGRAM, (s), (p))
#define mk_boundport(s,p)  mk_netport (TCP_BOUND, (s), (p))

#endif /* TCPIP */
