/*
 * number.c - 
 */

/*
 * $Id: number.c,v 1.6 2014/10/28 02:22:55 komiya Exp $
 */

/************************************/
/*                                  */
/*  File Name : number.c            */
/*  Update    : Yass.  Sep. 17 '90  */
/*              Yass.  Sep. 14 '90  */
/*              Yass.  Sep. 11 '90  */
/*              Yass.  Sep. 10 '90  */
/*              Yass.  Sep.  7 '90  */
/*              Yass.  Sep.  6 '90  */
/*              Yass.  Sep.  4 '90  */
/*              Yass.  Sep.  3 '90  */
/*              Yass.  Aug. 31 '90  */
/*              Yass.  Aug. 30 '90  */
/*              Yass.  Aug. 29 '90  */
/*              Yass.  Aug. 28 '90  */
/*              Yass.  Aug. 27 '90  */
/*              Yass.  Aug. 24 '90  */
/*              Yass.  Aug. 23 '90  */
/*              Yass.  Aug. 22 '90  */
/*              Yass.  Aug. 21 '90  */
/*              Yass.  Aug. 10 '90  */
/*              Yass.  Jul. 18 '90  */
/*              Yass.  Jul. 17 '90  */
/*              Yass.  Jul.  6 '90  */
/*              Yass.  Jul.  5 '90  */
/*              Yass.  Jul.  4 '90  */
/*              Yass.  Jul.  3 '90  */
/*              Yass.  Jul.  2 '90  */
/*              Yass.  Jun. 29 '90  */
/*              Yass.  Jun. 28 '90  */
/*              Myama. ?            */
/*                                  */
/*    Numerical operations          */
/*                                  */
/************************************/


static char *RCSid="$Id: number.c,v 1.6 2014/10/28 02:22:55 komiya Exp $";

#include <math.h>
#include "scheme.h"


/***********************************/
/*                                 */
/*  Essential standard procedures  */
/*                                 */
/***********************************/

void Snumberp()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag  == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
        GETtag(obj.obj) == LTAG_FLOAT                                        )
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Scomplexp()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag  == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
        GETtag(obj.obj) == LTAG_FLOAT                                        )
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Srealp()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX)
        set_reg(LTAG_FALSE);
    else
     { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT                                       )
            set_reg(LTAG_T);
        else
            set_reg(LTAG_FALSE);
    }
}


void Srationalp()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETnum_tag(obj.obj) == LTAG_NUMBER1 || 
        GETtag(obj.obj) == LTAG_BIGNUM || GETtag(obj.obj) == LTAG_FRACTION)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sintegerp()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    double d, obj_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETnum_tag(obj.obj) == LTAG_NUMBER1 || GETtag(obj.obj) == LTAG_BIGNUM)
        set_reg(LTAG_T);
    else if (GETnum_tag(obj.obj) == LTAG_NUMBER2
	     || GETtag(obj.obj) == LTAG_FLOAT) { /* T.Komiya */
	d = obj_to_double(obj.obj);
#ifdef THINK_C
	if (0)			/* toriaezu */
#else
	if (rint(d) == d)
#endif
	    set_reg(LTAG_T);
	else
	    set_reg(LTAG_FALSE);
    } else
        set_reg(LTAG_FALSE);
}

void Sexactp()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
        GETtag(obj.obj) == LTAG_FLOAT                                       )
        set_reg(LTAG_FALSE);
    else{
        err_illegal_argument_type(obj.obj, "number");
	return;
    }
}

void S_exactp()  /*  By T.Komiya */
{ 
    SOBJ obj, real, imag;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag == LTAG_NUMBER1 || GETtag(obj.obj) == LTAG_BIGNUM
    	|| GETtag(obj.obj) == LTAG_FRACTION)
        set_reg(LTAG_T);
    else if (GETtag(obj.obj) == LTAG_COMPLEX) {
    	real.obj = ((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj;
    	imag.obj = ((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj;
    	if ((GETnum_tag(real.obj) == LTAG_NUMBER1 || GETtag(real.obj) == LTAG_BIGNUM
    		|| GETtag(real.obj) == LTAG_FRACTION)
    	    && (GETnum_tag(imag.obj) == LTAG_NUMBER1 || GETtag(imag.obj) == LTAG_BIGNUM
    	    || GETtag(imag.obj) == LTAG_FRACTION))
			set_reg(LTAG_T);
		else
			set_reg(LTAG_FALSE);
    } else if (tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || GETtag(obj.obj) == LTAG_FLOAT)
        set_reg(LTAG_FALSE);
    else{
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}


void Sinexactp()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
        GETtag(obj.obj) == LTAG_FLOAT                                       )
        set_reg(LTAG_T);
    else{
        err_illegal_argument_type(obj.obj, "number");
	return;
    }
}

void S_inexactp()  /*  By T.Komiya */
{ 
    SOBJ obj, real, imag;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag == LTAG_NUMBER1 || GETtag(obj.obj) == LTAG_BIGNUM
    	|| GETtag(obj.obj) == LTAG_FRACTION)
        set_reg(LTAG_FALSE);
    else if (GETtag(obj.obj) == LTAG_COMPLEX) {
    	real.obj = ((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj;
    	imag.obj = ((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj;
    	if ((GETnum_tag(real.obj) == LTAG_NUMBER1 || GETtag(real.obj) == LTAG_BIGNUM
    		|| GETtag(real.obj) == LTAG_FRACTION)
    	    && (GETnum_tag(imag.obj) == LTAG_NUMBER1 || GETtag(imag.obj) == LTAG_BIGNUM
    	    || GETtag(imag.obj) == LTAG_FRACTION))
			set_reg(LTAG_FALSE);
		else
			set_reg(LTAG_T);
    } else if (tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || GETtag(obj.obj) == LTAG_FLOAT)
        set_reg(LTAG_T);
    else{
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}

void Seqeq()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ obj1, obj2;
    int args, i, tag,
    cplx_flag = FALSE;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
#else
    obj1.obj = getarg(1);
#endif
    tag = GETnum_tag(obj1.obj);
    if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2 && tag != LTAG_NUMBER3 && 
        GETtag(obj1.obj) != LTAG_FLOAT                                       ){
        err_illegal_argument_type(obj1.obj, "number");
	return;
    }
    if (GETtag(obj1.obj) == LTAG_COMPLEX)
        cplx_flag = TRUE;
    args = getargnum();
    for (i = 2 ; i <= args ; i++) { 
#ifdef TOUCH_ARG
        obj2.obj = touch_obj(getarg(i));
#else
        obj2.obj = getarg(i);
#endif
        tag = GETnum_tag(obj2.obj);
        if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2
            && tag != LTAG_NUMBER3 && GETtag(obj2.obj) != LTAG_FLOAT){
            err_illegal_argument_type(obj2.obj, "number");
	    return ;
	}
        if (GETtag(obj2.obj) == LTAG_COMPLEX && cplx_flag) { 
/*          s_push(obj2.obj);		By N.Watanabe  94/04/25  */
            if (comp_cplx(obj1.obj, obj2.obj) == EQUAL)
                continue;
            else
             { 
/*              s_pop();		By N.Watanabe 94/04/25  */
                set_reg(LTAG_FALSE);

                for (i++; i <= args; i++) { /* T.Komiya */
#ifdef TOUCH_ARG
                    obj2.obj = touch_obj(getarg(i));
#else
                    obj2.obj = getarg(i);
#endif
                    tag = GETnum_tag(obj2.obj);
                    if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2
                        && tag != LTAG_NUMBER3
                        && GETtag(obj2.obj) != LTAG_FLOAT){
                        err_illegal_argument_type(obj2.obj, "number");
                        return ;
                    }
                }
                return;
            }
        }
        if (cplx_flag || GETtag(obj2.obj) == LTAG_COMPLEX) { 
            set_reg(LTAG_FALSE);
            for (i++; i <= args; i++) { /* T.Komiya */
#ifdef TOUCH_ARG
                obj2.obj = touch_obj(getarg(i));
#else
                obj2.obj = getarg(i);
#endif
                tag = GETnum_tag(obj2.obj);
                if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2
                    && tag != LTAG_NUMBER3
                    && GETtag(obj2.obj) != LTAG_FLOAT){
                    err_illegal_argument_type(obj2.obj, "number");
                    return ;
                }
            }
            return;
        }
/*      s_push(obj2.obj);	By N.Watanabe  */
        if (comp_obj(obj1.obj, obj2.obj, 0) & NEQ) {
/*          s_pop();		By N.Watanabe  */
            set_reg(LTAG_FALSE);
            for (i++; i <= args; i++) { /* T.Komiya */
#ifdef TOUCH_ARG
                obj2.obj = touch_obj(getarg(i));
#else
                obj2.obj = getarg(i);
#endif
                tag = GETnum_tag(obj2.obj);
                if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2
                    && tag != LTAG_NUMBER3
                    && GETtag(obj2.obj) != LTAG_FLOAT){
                    err_illegal_argument_type(obj2.obj, "number");
                    return ;
                }
            }
            return;
        }
/*        obj1.obj = s_pop();      T.Komiya */
#ifdef TOUCH_ARG                /* T.Komiya */
        obj1.obj = touch_obj(getarg(i));
#else
        obj1.obj = getarg(i);
#endif
    }
    set_reg(LTAG_T);
}


void Slessthan()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ obj1, obj2;
    int args, i, tag;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
#else
    obj1.obj = getarg(1);
#endif
    args = getargnum();
    for (i = 2 ; i <= args ; i++) { 
#ifdef TOUCH_ARG
        obj2.obj = touch_obj(getarg(i));
#else
        obj2.obj = getarg(i);
#endif
/*      s_push(obj2.obj);	By N.Watanabe 94/04/25  */
        if (comp_obj(obj1.obj, obj2.obj, 0) & GREATERE) { 
/*          s_pop();		By N.Watanabe 94/04/25  */
            set_reg(LTAG_FALSE);
            for (i++; i <= args; i++) { /* T.Komiya */
#ifdef TOUCH_ARG
                obj2.obj = touch_obj(getarg(i));
#else
                obj2.obj = getarg(i);
#endif
                tag = GETnum_tag(obj2.obj);
                if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2
                    && tag != LTAG_NUMBER3
                    && GETtag(obj2.obj) != LTAG_FLOAT) {
                    err_illegal_argument_type(obj2.obj, "number");
                    return ;
                }
            }
            return;
        } else
/*            obj1.obj = s_pop();  T.Komiya */
#ifdef TOUCH_ARG                /* T.Komiya */
        obj1.obj = touch_obj(getarg(i));
#else
        obj1.obj = getarg(i);
#endif
    }
    set_reg(LTAG_T);
}


void Sgreaterthan()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ obj1, obj2;
    int args, i, tag;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
#else
    obj1.obj = getarg(1);
#endif
    args = getargnum();
    for (i = 2 ; i <= args ; i++) { 
#ifdef TOUCH_ARG
        obj2.obj = touch_obj(getarg(i));
#else
        obj2.obj = getarg(i);
#endif
/*    	s_push(obj2.obj);	By N.Watanabe 94/04/25  */
        if (comp_obj(obj1.obj, obj2.obj, 0) & LESSE) { 
/*          s_pop();		By N.Watanabe 94/04/25  */
            set_reg(LTAG_FALSE);
            for (i++; i <= args; i++) { /* T.Komiya */
#ifdef TOUCH_ARG
                obj2.obj = touch_obj(getarg(i));
#else
                obj2.obj = getarg(i);
#endif
                tag = GETnum_tag(obj2.obj);
                if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2
                    && tag != LTAG_NUMBER3
                    && GETtag(obj2.obj) != LTAG_FLOAT) {
                    err_illegal_argument_type(obj2.obj, "number");
                    return ;
                }
            }
            return;
        } else
/*            obj1.obj = s_pop();  T.Komiya */
#ifdef TOUCH_ARG                /* T.Komiya */
        obj1.obj = touch_obj(getarg(i));
#else
        obj1.obj = getarg(i);
#endif

    }
    set_reg(LTAG_T);
}


void Slep()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ obj1, obj2;
    int args, i, tag;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
#else
    obj1.obj = getarg(1);
#endif
    args = getargnum();
    for (i = 2 ; i <= args ; i++) { 
#ifdef TOUCH_ARG
        obj2.obj = touch_obj(getarg(i));
#else
        obj2.obj = getarg(i);
#endif
/*        s_push(obj2.obj);	By N.Watanabe 94/04/25  */
        if (comp_obj(obj1.obj, obj2.obj, 0) & GREATERT) { 
/*            s_pop();		By N.Watanabe 94/04/25  */
            set_reg(LTAG_FALSE);
            for (i++; i <= args; i++) { /* T.Komiya */
#ifdef TOUCH_ARG
                obj2.obj = touch_obj(getarg(i));
#else
                obj2.obj = getarg(i);
#endif
                tag = GETnum_tag(obj2.obj);
                if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2
                    && tag != LTAG_NUMBER3
                    && GETtag(obj2.obj) != LTAG_FLOAT) {
                    err_illegal_argument_type(obj2.obj, "number");
                    return ;
                }
            }
            return;
        } else
/*            obj1.obj = s_pop();  T.Komiya */
#ifdef TOUCH_ARG                /* T.Komiya */
        obj1.obj = touch_obj(getarg(i));
#else
        obj1.obj = getarg(i);
#endif

    }
    set_reg(LTAG_T);
}


void Sgep()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ obj1, obj2;
    int args, i, tag;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
#else
    obj1.obj = getarg(1);
#endif
    args = getargnum();
    for (i = 2 ; i <= args ; i++) { 
#ifdef TOUCH_ARG
        obj2.obj = touch_obj(getarg(i));
#else
        obj2.obj = getarg(i);
#endif
/*        s_push(obj2.obj);	By N.Watanabe 94/04/25  */
        if (comp_obj(obj1.obj, obj2.obj, 0) & LESST) { 
/*            s_pop();		By N.Watanabe 94/04/25   */
            set_reg(LTAG_FALSE);
            for (i++; i <= args; i++) { /* T.Komiya */
#ifdef TOUCH_ARG
                obj2.obj = touch_obj(getarg(i));
#else
                obj2.obj = getarg(i);
#endif
                tag = GETnum_tag(obj2.obj);
                if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2
                    && tag != LTAG_NUMBER3
                    && GETtag(obj2.obj) != LTAG_FLOAT) {
                    err_illegal_argument_type(obj2.obj, "number");
                    return ;
                }
            }
            return;
        } else
/*            obj1.obj = s_pop();  T.Komiya */
#ifdef TOUCH_ARG                /* T.Komiya */
        obj1.obj = touch_obj(getarg(i));
#else
        obj1.obj = getarg(i);
#endif
    }
    set_reg(LTAG_T);
}


void Szerop()  /*  Yass. Sep. 17 '90  */
{ 
    SOBJ   obj;

    double  flt_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
        if (obj.obj == SCOBJ_0) {   
            set_reg(LTAG_T);
            break;
        }
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_COMPLEX   :
        set_reg(LTAG_FALSE);
        break;
    case LTAG_SFLOAT    :
        if (obj.obj == SCOBJ_SF0) { 
            set_reg(LTAG_T);
            break;
        }
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        set_reg(LTAG_FALSE);
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return ;
        break;
    }
}


void Spositivep()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;

    double  flt_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
        if (obj.obj == SCOBJ_0) {   
            set_reg(LTAG_FALSE);
            break;
        }
    case LTAG_FIXNUM1   :
        set_reg(LTAG_T);
        break;
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        set_reg(LTAG_FALSE);
        break;
    case LTAG_BIGNUM    :
        if (big_sign(obj.obj) > 0)
            set_reg(LTAG_T);
        else
            set_reg(LTAG_FALSE);
        break;
    case LTAG_FRACTION  :
        obj.obj = ((ENTITYP)ADDRESS(obj.obj))->frac.nume.obj;
        switch (GETtag(obj.obj)) { 
        case LTAG_FIXNUM  :
        case LTAG_FIXNUM1 :
            set_reg(LTAG_T);
            break;
        case LTAG_FIXNUM2 :
        case LTAG_FIXNUM3 :
            set_reg(LTAG_FALSE);
            break;
        case LTAG_BIGNUM  :
            if (big_sign(obj.obj) > 0)
                set_reg(LTAG_T);
            else
                set_reg(LTAG_FALSE);
            break;
        }
        break;
    case LTAG_SFLOAT    :
        if (obj.obj == SCOBJ_SF0) { 
            set_reg(LTAG_FALSE);
            break;
        }
    case LTAG_SFLOAT1   :
        set_reg(LTAG_T);
        break;
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
        set_reg(LTAG_FALSE);
        break;
    case LTAG_FLOAT     :
        if (flt_to_double(obj.obj) > 0.0)
            set_reg(LTAG_T);
        else
            set_reg(LTAG_FALSE);
        break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
}


void Snegativep()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;

    double  flt_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
        set_reg(LTAG_FALSE);
        break;
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        set_reg(LTAG_T);
        break;
    case LTAG_BIGNUM    :
        if (big_sign(obj.obj) < 0)
            set_reg(LTAG_T);
        else
            set_reg(LTAG_FALSE);
        break;
    case LTAG_FRACTION  :
        obj.obj = ((ENTITYP)ADDRESS(obj.obj))->frac.nume.obj;
        switch (GETtag(obj.obj)) { 
        case LTAG_FIXNUM  :
        case LTAG_FIXNUM1 :
            set_reg(LTAG_FALSE);
            break;
        case LTAG_FIXNUM2 :
        case LTAG_FIXNUM3 :
            set_reg(LTAG_T);
            break;
        case LTAG_BIGNUM  :
            if (big_sign(obj.obj) < 0)
                set_reg(LTAG_T);
            else
                set_reg(LTAG_FALSE);
            break;
        }
        break;
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
        set_reg(LTAG_FALSE);
        break;
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
        set_reg(LTAG_T);
        break;
    case LTAG_FLOAT     :
        if (flt_to_double(obj.obj) < 0.0)
            set_reg(LTAG_T);
        else
            set_reg(LTAG_FALSE);
        break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
}


void Soddp()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ obj;
    int tmp;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM  :
    case LTAG_FIXNUM1 :
    case LTAG_FIXNUM2 :
    case LTAG_FIXNUM3 :
/*        tmp = fix_to_int(obj.obj) % 2; */
        tmp = fix_to_int(obj.obj) & 1;         /* by T.Komiya */
        break;
    case LTAG_BIGNUM  :
/*        obj.obj = copy_big(obj.obj);
        div_int_big(obj.obj, 2, &tmp); */
        tmp = ((BIGNUM *)ADDRESS(obj.obj))->val & 1; /* by T.Komiya */
        break;
    default :
        err_illegal_argument_type(obj.obj, "integer");
	return ;
        break;
    }
    if (tmp == 1)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sevenp()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ obj;
    int tmp;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM  :
    case LTAG_FIXNUM1 :
    case LTAG_FIXNUM2 :
    case LTAG_FIXNUM3 :
/*        tmp = fix_to_int(obj.obj) % 2; */
        tmp = ~fix_to_int(obj.obj) & 1;         /* by T.Komiya */
        break;
    case LTAG_BIGNUM  :
/*        obj.obj = copy_big(obj.obj);
        div_int_big(obj.obj, 2, &tmp); */
        tmp = ~(((BIGNUM *)ADDRESS(obj.obj))->val) & 1; /* by T.Komiya */
        break;
    default :
        err_illegal_argument_type(obj.obj, "integer");
	return ;
        break;
    }
/*    if (tmp == 0) */
    if (tmp == 1)               /* by T.Komiya */
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Smin()  /*  T.Komiya */
{
    SOBJ obj;
    int args, i, x, result;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
    switch (GETtag(obj.obj)) {
#else
    obj.obj = getarg(1);
    switch (GETtag(obj.obj)) {
#endif
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
    	break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
    result = 1;
    args = getargnum();
    for (i = 2 ; i <= args ; i++) {
        x = i;
#ifdef TOUCH_ARG
        s_push(touch_obj(getarg(result)));
        obj.obj = touch_obj(getarg(x));
        if (comp_obj(s_pop(), obj.obj, 0) == GREATERT)
#else
        if (comp_obj(getarg(result), getarg(x), 0) == GREATERT)
#endif
            result = x;
    }
#ifdef TOUCH_ARG
    set_reg(touch_obj(getarg(result)));
#else
    set_reg(getarg(result));
#endif
}


void Smax()  /*  T.Komiya */
{ 
    SOBJ    obj;
    int args, i, x, result;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
    switch (GETtag(obj.obj)) {
#else
    obj.obj = getarg(1);
    switch (GETtag(obj.obj)) {
#endif
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
    	break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
    result = 1;
    args = getargnum();
    for (i = 2 ; i <= args ; i++) {
        x = i;
#ifdef TOUCH_ARG
        s_push(touch_obj(getarg(result)));
        obj.obj = touch_obj(getarg(x));
        if (comp_obj(s_pop(), obj.obj, 0) == LESST)
#else
        if (comp_obj(getarg(result), getarg(x), 0) == LESST)
#endif
            result = x;
    }
#ifdef TOUCH_ARG
    set_reg(touch_obj(getarg(result)));
#else
    set_reg(getarg(result));
#endif
}


void Sadd()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ result;
    int args, i;

    result.obj = SCOBJ_0;
    args = getargnum();
    for (i = 1 ; i <= args ; i++){
#ifdef TOUCH_ARG
        result.obj = add_obj(result.obj, touch_obj(getarg(i)));
#else
        result.obj = add_obj(result.obj, getarg(i));
#endif
	if (result.obj == NULL){
	    return ;
	}
    }
    set_reg(result.obj);
}


void Smul()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ result;
    int args, i;

    result.obj = SCOBJ_1;
    args = getargnum();
    for (i = 1 ; i <= args ; i++){
#ifdef TOUCH_ARG
        result.obj = mul_obj(result.obj, touch_obj(getarg(i)));
#else
        result.obj = mul_obj(result.obj, getarg(i));
#endif
	if (result.obj == NULL){
	    return;
	}
    }
    set_reg(result.obj);
}


void Ssub()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ result;
    int args, i;

#ifdef TOUCH_ARG
    result.obj = touch_obj(getarg(1));
#else
    result.obj = getarg(1);
#endif
    args = getargnum();
    if (args == 1){
        result.obj = minus_obj(result.obj);
	if (result.obj == NULL){
	    return;
	}
    }
    else
     { 
        for (i = 2 ; i <= args ; i++){
#ifdef TOUCH_ARG
            result.obj = sub_obj(result.obj, touch_obj(getarg(i)));
#else
            result.obj = sub_obj(result.obj, getarg(i));
#endif
	    if (result.obj == NULL){
		return;
	    }
	}
    }
    set_reg(result.obj);
}


void Sdiv()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ result;
    int args, i;

#ifdef TOUCH_ARG
    result.obj = touch_obj(getarg(1));
#else
    result.obj = getarg(1);
#endif
    args = getargnum();
    if (args == 1){
        result.obj = div_obj(SCOBJ_1, result.obj);
	if (result.obj == NULL){
	    return;
	}
    }
    else
     { 
        for (i = 2 ; i <= args ; i++){
#ifdef TOUCH_ARG
            result.obj = div_obj(result.obj, touch_obj(getarg(i)));
#else
            result.obj = div_obj(result.obj, getarg(i));
#endif
	    if (result.obj == NULL){
		return;
	    }
	}
    }
    set_reg(result.obj);
}


void Sabs()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
        set_reg(obj.obj);
        break;
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
        set_reg(minus_obj(obj.obj));
        break;
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_FLOAT     :
        if (obj_sign(obj.obj) < 0)
            set_reg(minus_obj(obj.obj));
        else
            set_reg(obj.obj);
        break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
}


void Squotient()  /* Yass. Jul. 6 '90  */
{
    int tmp ;    		/* By N.Watanabe 92/11/24 */

#ifdef TOUCH_ARG
    if ((tmp = quotient_obj(touch_obj(getarg(1)),
			    touch_obj(getarg(2)))) == NULL ) {
#else
    if ((tmp = quotient_obj(getarg(1), getarg(2))) == NULL ) {
#endif
	return ;		/* Error! */
    };
    set_reg(tmp);
}


void Sremainder()  /* Yass. Jul. 6 '90  */
{ 
    SOBJ tmp;

#ifdef TOUCH_ARG
    tmp.obj = quotient_obj(touch_obj(getarg(1)),
			   touch_obj(getarg(2)));
#else
    tmp.obj = quotient_obj(getarg(1), getarg(2));
#endif
#ifdef TOUCH_ARG
    tmp.obj = mul_obj(tmp.obj, touch_obj(getarg(2)));
#else
    tmp.obj = mul_obj(tmp.obj, getarg(2));
#endif
#ifdef TOUCH_ARG
    set_reg(sub_obj(touch_obj(getarg(1)), tmp.obj));
#else
    set_reg(sub_obj(getarg(1), tmp.obj));
#endif
}

/********
Smodulo() */ /* Yass. Sep. 4 '90  *//*
{ 
    SOBJ tmp;

#ifdef TOUCH_ARG
    tmp.obj = quotient_obj(touch_obj(getarg(1)), touch_obj(getarg(2)));
#else
    tmp.obj = quotient_obj(getarg(1), getarg(2));
#endif
#ifdef TOUCH_ARG
    if (touch_obj(getarg(1)) == SCOBJ_0)
#else
    if (getarg(1) == SCOBJ_0)
#endif
        set_reg(SCOBJ_0);
    else
     { 
#ifdef TOUCH_ARG
        tmp.obj = mul_obj(tmp.obj, touch_obj(getarg(2)));
#else
        tmp.obj = mul_obj(tmp.obj, getarg(2));
#endif
#ifdef TOUCH_ARG
        tmp.obj = sub_obj(touch_obj(getarg(1)), tmp.obj);
#else
        tmp.obj = sub_obj(getarg(1), tmp.obj);
#endif
#ifdef TOUCH_ARG
        if (obj_sign(touch_obj(getarg(1))) * obj_sign(touch_obj(getarg(2))) <0)
#else
        if (obj_sign(getarg(1)) * obj_sign(getarg(2)) < 0)
#endif
            set_reg(minus_obj(tmp.obj));
        else
            set_reg(tmp.obj);
    }
}
***********/

void Smodulo()  /* By T.Komiya */
{ 
    SOBJ tmp;

#ifdef TOUCH_ARG
    tmp.obj = quotient_obj(touch_obj(getarg(1)), touch_obj(getarg(2)));
#else
    tmp.obj = quotient_obj(getarg(1), getarg(2));
#endif
#ifdef TOUCH_ARG
    tmp.obj = mul_obj(tmp.obj, touch_obj(getarg(2)));
#else
    tmp.obj = mul_obj(tmp.obj, getarg(2));
#endif
#ifdef TOUCH_ARG
    tmp.obj = sub_obj(touch_obj(getarg(1)), tmp.obj);
#else
    tmp.obj = sub_obj(getarg(1), tmp.obj);
#endif

#ifdef TOUCH_ARG
    if (obj_sign(touch_obj(getarg(1))) < 0)
#else
    if (obj_sign(getarg(1)) < 0)
#endif
#ifdef TOUCH_ARG
        if (obj_sign(touch_obj(getarg(2))) < 0 || tmp.obj == SCOBJ_0)
#else
        if (obj_sign(getarg(2)) < 0 || tmp.obj == SCOBJ_0)
#endif
            set_reg(tmp.obj);
        else
#ifdef TOUCH_ARG
            set_reg(add_obj(touch_obj(getarg(2)), tmp.obj));
#else
            set_reg(add_obj(getarg(2), tmp.obj));
#endif
    else {
#ifdef TOUCH_ARG
        if (obj_sign(touch_obj(getarg(2))) < 0 && tmp.obj != SCOBJ_0)
#else
        if (obj_sign(getarg(2)) < 0 && tmp.obj != SCOBJ_0)
#endif
#ifdef TOUCH_ARG
            set_reg(add_obj(touch_obj(getarg(2)), tmp.obj));
#else
            set_reg(add_obj(getarg(2), tmp.obj));
#endif
        else
            set_reg(tmp.obj);
    }
}


void Sgcd()  /* Yass. Sep. 4 '90 */
{ 
    SOBJ result;
    int args, i;

    result.obj = SCOBJ_0;
    args = getargnum();
    for (i = 1 ; i <= args ; i++)
#ifdef TOUCH_ARG
        result.obj = gcd_obj(result.obj, touch_obj(getarg(i)));
#else
        result.obj = gcd_obj(result.obj, getarg(i));
#endif
    set_reg(result.obj);
}


void Slcm()  /* Yass. Sep. 4 '90 */
{ 
    SOBJ result;
    int args, i;

    result.obj = SCOBJ_1;
    args = getargnum();
    for (i = 1 ; i <= args ; i++){
#ifdef TOUCH_ARG
        result.obj = lcm_obj(result.obj, touch_obj(getarg(i)));
#else
        result.obj = lcm_obj(result.obj, getarg(i));
#endif
	if (result.obj == NULL){	/* By N.Watanabe 92/11/24 */
	    return ;			/* Error! */
	}
    }
    set_reg(result.obj);
}


void Sfloor()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ obj;
    double d;

    double  floor();
    double  obj_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
        set_reg(obj.obj);
        break;
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        d = floor(obj_to_double(obj.obj));
        if (d < (double)FIX_MIN || d > (double)FIX_MAX)
        	set_reg(double_to_big(d));
        else
	        set_reg(mk_fix((int)d));
        break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
}


void Sceiling()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ obj;
    double d;

    double  ceil();
    double  obj_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
        set_reg(obj.obj);
        break;
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        d = ceil(obj_to_double(obj.obj));
        if (d < (double)FIX_MIN || d > (double)FIX_MAX)
        	set_reg(double_to_big(d));
        else
	        set_reg(mk_fix((int)d));
        break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
}


void Struncate()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ obj;
    double d;

    double  obj_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
        set_reg(obj.obj);
        break;
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        d = obj_to_double(obj.obj);
        if (d < (double)FIX_MIN || d > (double)FIX_MAX)
        	set_reg(double_to_big(d));
        else
	        set_reg(mk_fix((int)d));
        break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
}


void Sround()
{
    SOBJ obj;
    double x;

    double  obj_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
        set_reg(obj.obj);
        break;
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        x = obj_to_double(obj.obj);
        if (x < (double)FIX_MIN || x > (double)FIX_MAX) {
            SOBJ b;
            double big_to_double();

            if (x < 0) {
                b.obj = double_to_big(x - (double)0.5);
                x -= big_to_double(b.obj);
                if (x == 0.5
                    && ((((BIGNUM *)ADDRESS(b.obj))->val & 1) == 1))
                    b.obj = add_obj(b.obj, SCOBJ_1);
            } else {
                b.obj = double_to_big(x + (double)0.5);
                x -= big_to_double(b.obj);
                if (x == -0.5
                    && ((((BIGNUM *)ADDRESS(b.obj))->val & 1) == 1))
                    b.obj = sub_obj(b.obj, SCOBJ_1);
            }
            set_reg(b.obj);
        } else {
            int i;
            double d;
            if (x < 0) {
                i = (int)(x - (double)0.5);
                x -= (double)i;
                if (x == 0.5 && ((i & 1) == 1))
                    i++;
            } else {
                i = (int)(x + (double)0.5);
                x -= (double)i;
                if (x == -0.5 && ((i & 1) == 1))
                    i--;
            }
            set_reg(mk_fix(i));
        }
        break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
        break;
    }
}


void Snumber_to_string()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ number, tmp;
    int args, tag, radix, length, oldtop;
    char    *p, prefix;

#ifdef TOUCH_ARG
    number.obj = touch_obj(getarg(1));
#else
    number.obj = getarg(1);
#endif
    tag = GETnum_tag(number.obj);
    if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2 && tag != LTAG_NUMBER3 && 
        GETtag(number.obj) != LTAG_FLOAT){
        err_illegal_argument_type(number.obj, "number");
	return ;
    }
    args = getargnum();
    if (args == 1)
        radix = DECIMAL;
    else if (args == 2) { 
#ifdef TOUCH_ARG
        if (GETnum_tag(touch_obj(getarg(2))) != LTAG_NUMBER1) {
#else
        if (GETnum_tag(getarg(2)) != LTAG_NUMBER1){
#endif
#ifdef TOUCH_ARG
            err_illegal_argument_type(touch_obj(getarg(2)), "2 or 8 or 10 or 16");
#else
            err_illegal_argument_type(getarg(2), "2 or 8 or 10 or 16");
#endif
	    return ;
	}
        else
         { 
#ifdef TOUCH_ARG
            radix = fix_to_int(touch_obj(getarg(2)));
#else
            radix = fix_to_int(getarg(2));
#endif
            if (radix != 2 && radix != 8 && radix != 10 && radix != 16){
#ifdef TOUCH_ARG
                err_illegal_argument_type(touch_obj(getarg(2)), "2 or 8 or 10 or 16");
#else
                err_illegal_argument_type(getarg(2), "2 or 8 or 10 or 16");
#endif
		return ;
	    }
        }
    } else{
        err_illegal_argument("Too many arguments.");
	return ;
    }
    oldtop = (int)top_val();
    push_digit(number.obj, radix);
    length = ((int)oldtop - (int)top_val()) / 4; /* modify for SUN4. Myama. 1990.10.8 */
/*    if (radix  != DECIMAL)
        length += 2; */
    if (length > STRLEN_MAX)
        bokkan("Too long length of string.");
    number.obj = mk_estr(ORDINARY_STRING, A_STRING, length);
    p = (char *)(ADDRESS(number.obj) + 12);
/*    if (radix != DECIMAL) { 
        *p = '#';
        p++;
        switch (radix) { 
        case BINARY :
            *p = 'b';
            break;
        case OCTAL  :
            *p = 'o';
            break;
        case HEX    :
            *p = 'x';
            break;
        default :
            err_system_error("in Snumber_to_string().");
	    return ;
        }
        p++;
    } */
    for (; length > 0 ; length--) { 
        tmp.obj = s_pop();
        *p = (char)(CH(tmp.ch));
        p++;
    }
    *p = '\0';
    set_reg(number.obj);
}


void Sstring_to_number()  /*  Yass. Sep. 14 '90  */
{ 
    SOBJ number;
    int radix, args, buf_len,
    size = 1,
    offset = 0;
    char    *str, *str_buf, *tmp, prefix;

#ifdef TOUCH_ARG
    number.obj = touch_obj(getarg(1));
#else
    number.obj = getarg(1);
#endif
    if (GETstr_tag(number.obj) != LTAG_STRING){
        err_illegal_argument_type(number.obj, "string");
	return ;
    }
    if ((args = getargnum()) == 1)
        radix = DECIMAL;
    else
     { 
#ifdef TOUCH_ARG
        if (GETnum_tag(touch_obj(getarg(2))) != LTAG_NUMBER1 ||
            ((radix = fix_to_int(touch_obj(getarg(2)))) != BINARY && 
	     radix != OCTAL && radix != DECIMAL && radix != HEX)) {
            err_illegal_argument_type(touch_obj(getarg(2)), "2 or 8 or 10 or 16");
#else
        if (GETnum_tag(getarg(2)) != LTAG_NUMBER1 || 
            ((radix = fix_to_int(getarg(2))) != BINARY && 
	     radix != OCTAL && radix != DECIMAL && radix != HEX)) {
            err_illegal_argument_type(getarg(2), "2 or 8 or 10 or 16");
#endif
	    return ;
	}
        if (args > 3){
            err_illegal_argument("Too many arguments.");
	    return ;
	}
    }
    if (GETtag(((STRING * )ADDRESS(number.obj))->head) == LTAG_BLOCK1)
        number.obj = ((STRING * )ADDRESS(number.obj))->str_len;
    buf_len = ((STRING * )ADDRESS(number.obj))->str_len + 1;
    if (((STRING * )ADDRESS(number.obj))->str_kind == K_STRING) { 
        size = 2;
        offset = 1;
        buf_len *= 2;
    }
    str = (char *)(ADDRESS(number.obj) + 12);
    if (*(str + offset) == '#') { 
        buf_len -= (size * 2);
        str += size;
        prefix = *(str + offset);
        str += size;
        switch (prefix) { 
        case 'i' :
        case 'e' :
            if (*(str + offset) == '#') { 
                buf_len -= (size * 2);
                str += size;
                prefix = *(str + offset);
                str += size;
                switch (prefix) { 
                case 'b' :
                    radix = BINARY;
                    break;
                case 'o' :
                    radix = OCTAL;
                    break;
                case 'd' :
                    radix = DECIMAL;
                    break;
                case 'x' :
                    radix = HEX;
                    break;
                default :
                    set_reg(LTAG_FALSE);
                    return;
                }
            }
            break;
        case 'b' :
            radix = BINARY;
            goto CON;
        case 'o' :
            radix = OCTAL;
            goto CON;
        case 'd' :
            radix = DECIMAL;
            goto CON;
        case 'x' :
            radix = HEX;

CON:

            if (*(str + offset) == '#') { 
                buf_len -= (size * 2);
                str += size;
                prefix = *(str + offset);
                str += size;
                switch (prefix) { 
                case 'i' :
                case 'e' :
                    break;
                default :
                    set_reg(LTAG_FALSE);
                    return;
                }
            }
        }
    }
    tmp = str_buf = (char *)malloc(buf_len);
    for (; buf_len > 0 ; buf_len--) { 
        *(tmp++) = (('A' <= *str && *str <= 'Z') ? (char)(*str - 'A' + 'a') : *str);
        str++;
    }
    set_reg(str_to_num(str_buf, size, radix));
    free(str_buf);              /* T.Komiya */
}


/*************************/
/*                       */
/*  Standard procedures  */
/*                       */
/*************************/

void Snumerator()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
        set_reg(obj.obj);
        break;
    case LTAG_FRACTION  :
        set_reg(((ENTITYP)ADDRESS(obj.obj))->frac.nume.obj);
        break;
    default :
        err_illegal_argument_type(obj.obj, "integer or rational");
	return ;
        break;
    }
}


void Sdenominator()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
        set_reg(SCOBJ_1);
        break;
    case LTAG_FRACTION  :
        set_reg(((ENTITYP)ADDRESS(obj.obj))->frac.deno.obj);
        break;
    default :
        err_illegal_argument_type(obj.obj, "integer or rational");
	return ;
        break;
    }
}


/*
Srationalize()
*/

void Sexp()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;
    double  real, imag;
    int tag;

    double  sin(double);
    double  cos(double);
    double  exp(double);
    double  obj_to_double(int);

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
        s_push(mk_flt(exp(real) * cos(imag)));    /*  new real part  */
        obj.obj = mk_flt(exp(real) * sin(imag));  /*  new imag part  */
        set_reg(mk_simple_complex(s_pop(), obj.obj));
    } else
     { 
        tag = GETnum_tag(obj.obj);
        if (tag ==LTAG_NUMBER1 || tag ==LTAG_NUMBER2 || tag ==LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT)
            set_reg(mk_flt(exp(obj_to_double(obj.obj))));
        else{
            err_illegal_argument_type(obj.obj, "number");
	    return;
	}
    }
}


void Slog()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;
    double  real, imag;
    int tag;

    double  log();
    double  obj_to_double();
    double  magnitude();
    double  angle();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
    } else
     { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT) { 
            real = obj_to_double(obj.obj);
            if (real == 0.0){
                err_illegal_argument("Zero is the logarithmic singularity.");
		return ;
	    }
            imag = 0.0;
        } else{
            err_illegal_argument_type(obj.obj, "number");
	    return ;
	}
    }
    s_push(mk_flt(log(magnitude(real, imag))));  /*  new real part  */
    obj.obj = mk_flt(angle(real, imag));         /*  new imag part  */
    set_reg(mk_simple_complex(s_pop(), obj.obj));
}


void Ssin()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;
    double  real, imag;
    int tag;

    double  obj_to_double();
    double  sin_real();
    double  sin_imag();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
        s_push(mk_flt(sin_real(real, imag)));    /*  new real part  */
        obj.obj = mk_flt(sin_imag(real, imag));  /*  new imag part  */
        set_reg(mk_simple_complex(s_pop(), obj.obj));
    } else { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT) { 
            real = obj_to_double(obj.obj);
        } else{
            err_illegal_argument_type(obj.obj, "number");
	    return ;
	}
        set_reg(mk_flt(sin_real(real, 0.0)));
    }
}


void Scos()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;
    double  real, imag;
    int tag;

    double  obj_to_double();
    double  cos_real();
    double  cos_imag();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
        s_push(mk_flt(cos_real(real, imag)));    /*  new real part  */
        obj.obj = mk_flt(cos_imag(real, imag));  /*  new imag part  */
        set_reg(mk_simple_complex(s_pop(), obj.obj));
    } else { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT) { 
            real = obj_to_double(obj.obj);
        } else{
            err_illegal_argument_type(obj.obj, "number");
	    return ;
	}
        set_reg(mk_flt(cos_real(real, 0.0)));
    }
}


void Stan()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;
    double  real, imag, tmp, s_real, c_real, s_imag, c_imag;
    int tag;

    double  obj_to_double();
    double  sin_real();
    double  sin_imag();
    double  cos_real();
    double  cos_imag();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
        s_real = sin_real(real, imag);
        s_imag = sin_imag(real, imag);
        c_real = cos_real(real, imag);
        c_imag = cos_imag(real, imag);
        tmp = c_real * c_real + c_imag * c_imag;
        if (tmp == 0.0){
            err_illegal_argument("Illegal argument for TAN.");
            return ;
        }
        real = (s_real * c_real + s_imag * c_imag) / tmp;
        imag = (c_real * s_imag - s_real * c_imag) / tmp;
        s_push(mk_flt(real));    /*  new real part  */
        obj.obj = mk_flt(imag);  /*  new imag part  */
        set_reg(mk_simple_complex(s_pop(), obj.obj));
    } else { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT) { 
            real = obj_to_double(obj.obj);
            s_real = sin_real(real, 0.0);
            c_real = cos_real(real, 0.0);
            if (c_real == 0.0){
                err_illegal_argument("Illegal argument for TAN.");
                return ;
            }
            real = s_real / c_real;
            set_reg(mk_flt(real));
        } else{
            err_illegal_argument_type(obj.obj, "number");
	    return;
	}
    }
}


void Sasin()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;
    double  a, d, real, imag, real_tmp1, imag_tmp1, real_tmp2, imag_tmp2;
    int tag;

    double  exp();
    double  log();
    double  asin();
    double  sin();
    double  cos();
    double  obj_to_double();
    double  magnitude();
    double  angle();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
    } else
     { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT) { 
            real = obj_to_double(obj.obj);
            if (-1.0 <= real && real <= 1.0) { 
                set_reg(mk_flt(asin(real)));
                return;
            }
            imag = 0.0;
        } else{
            err_illegal_argument_type(obj.obj, "number");
	    return ;
	}
    }
    real_tmp1 = imag * imag - real * real + 1.0;
    imag_tmp1 = -2.0 * real * imag;
    d = exp(log(magnitude(real_tmp1, imag_tmp1)) / 2.0);
    a = angle(real_tmp1, imag_tmp1);
    real_tmp2 = d * cos(a / 2.0) - imag;
    imag_tmp2 = d * sin(a / 2.0) + real;
    s_push(mk_flt(angle(real_tmp2, imag_tmp2)));
    obj.obj = mk_flt(-log(magnitude(real_tmp2, imag_tmp2)));
    set_reg(mk_simple_complex(s_pop(), obj.obj));
}


void Sacos()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;
    double  a, d, real, imag, real_tmp1, imag_tmp1, real_tmp2, imag_tmp2;
    int tag;

    double  exp();
    double  log();
    double  acos();
    double  sin();
    double  cos();
    double  obj_to_double();
    double  magnitude();
    double  angle();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
    } else
     { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT) { 
            real = obj_to_double(obj.obj);
            if (-1.0 <= real && real <= 1.0) { 
                set_reg(mk_flt(acos(real)));
                return;
            }
            imag = 0.0;
        } else{
            err_illegal_argument_type(obj.obj, "number");
	    return ;
	}
    }
    real_tmp1 = imag * imag - real * real + 1.0;
    imag_tmp1 = -2.0 * real * imag;
    d = exp(log(magnitude(real_tmp1, imag_tmp1)) / 2.0);
    a = angle(real_tmp1, imag_tmp1);
    real_tmp2 = d * cos(a / 2.0) - imag;
    imag_tmp2 = d * sin(a / 2.0) + real;
    s_push(mk_flt(3.141592653589793/2.0 - angle(real_tmp2, imag_tmp2)));
    obj.obj = mk_flt(log(magnitude(real_tmp2, imag_tmp2)));
    set_reg(mk_simple_complex(s_pop(), obj.obj));
}


void Satan()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj, real_obj, imag_obj;
    double  a, real, imag, real_tmp1, imag_tmp1, real_tmp2, imag_tmp2;
    int args, tag;

    double  log();
    double  sin();
    double  cos();
    double  obj_to_double();
    double  magnitude();
    double  angle();

    args = getargnum();
    if (args > 2){
        err_illegal_argument("Illegal number of arguments.");
	return;
    }
    if (args == 2) { 
#ifdef TOUCH_ARG
        real_obj.obj = touch_obj(getarg(2));
        imag_obj.obj = touch_obj(getarg(1));
#else
        real_obj.obj = getarg(2);
        imag_obj.obj = getarg(1);
#endif
        if (((tag = GETnum_tag(real_obj.obj)) == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || 
            (tag = GETtag(real_obj.obj)) == LTAG_BIGNUM || tag == LTAG_FRACTION     || 
            tag == LTAG_FLOAT                                                         ) && 
            ((tag = GETnum_tag(imag_obj.obj)) == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || 
            (tag = GETtag(imag_obj.obj)) == LTAG_BIGNUM || tag == LTAG_FRACTION     || 
            tag == LTAG_FLOAT                                                         )) { 
            real = obj_to_double(real_obj.obj);
            imag = obj_to_double(imag_obj.obj);
            set_reg(mk_flt(angle(real, imag)));
            return;
        } else{
            err_illegal_argument("Both arguments must be reals.");
	    return ;
	}
    }
#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
    } else
     { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT) { 
            real = obj_to_double(obj.obj);
            imag = 0.0;
        } else {
            err_illegal_argument_type(obj.obj, "number");
	    return ;
	}
    }
    if (real == 0.0 && (imag == 1.0 || imag == -1.0)) {
        err_illegal_argument("Illegal argument for ATAN.");
	return ;
    }
    real_tmp1 = real * real - imag * imag + 1.0;
    imag_tmp1 = 2.0 * real * imag;
    a = angle(real_tmp1, imag_tmp1);
    real_tmp2 = (1.0 - imag) * cos(-a / 2.0) - real * sin(-a / 2.0);
    imag_tmp2 = (1.0 - imag) * sin(-a / 2.0) + real * cos(-a / 2.0);
    if (imag == 0.0)
        set_reg(mk_flt(angle(real_tmp2, imag_tmp2)));
    else {
        s_push(mk_flt(angle(real_tmp2, imag_tmp2)));
        obj.obj = mk_flt(log(magnitude(real_tmp1, imag_tmp1)) / 2.0 - log(magnitude(real_tmp2, imag_tmp2)));
        set_reg(mk_simple_complex(s_pop(), obj.obj));
    }
}


void Ssqrt()  /*  Yass. Sep. 10 '90  */
{
    SOBJ   obj;
    double  real, imag;
    int tag;

    double  exp();
    double  log();
    double  sin();
    double  cos();
    double  obj_to_double();
    double  magnitude();
    double  angle();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX) { 
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
    } else
     { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3
            || GETtag(obj.obj) == LTAG_FLOAT) { 
            real = obj_to_double(obj.obj);
            if (real == 0.0)
                set_reg(obj.obj);
            else if (real > 0.0)  /* by T.Komiya */
                set_reg(mk_simple_complex(mk_flt(sqrt(real)), SCOBJ_SF0));
            else
                set_reg(mk_simple_complex(SCOBJ_SF0, mk_flt(sqrt(-real))));
            return;
        } else{
            err_illegal_argument_type(obj.obj, "number");
	    return ;
	}
    }
    s_push(mk_flt(exp(log(magnitude(real, imag)) / 2.0) * cos(angle(real, imag) / 2.0)));    /*  new real part  */
    obj.obj = mk_flt(exp(log(magnitude(real, imag)) / 2.0) * sin(angle(real, imag) / 2.0));  /*  new imag part  */
    set_reg(mk_simple_complex(s_pop(), obj.obj));
}


void Sexpt()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj1, obj2;
    double  real1, imag1, real2, imag2, tmp1, tmp2;
    int tag;

    double  exp();
    double  log();
    double  sin();
    double  cos();
    double  obj_to_double();
    double  magnitude();
    double  angle();

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    tag = GETnum_tag(obj1.obj);
    if (tag != LTAG_NUMBER1 && tag != LTAG_NUMBER2 && tag != LTAG_NUMBER3 && 
        GETtag(obj1.obj) != LTAG_FLOAT){
        err_illegal_argument_type(obj1.obj, "number");
	return ;
    }
    if (GETtag(obj2.obj) == LTAG_COMPLEX) { 
        real2 = obj_to_double(((ENTITYP)ADDRESS(obj2.obj))->cplx.real.obj);
        imag2 = obj_to_double(((ENTITYP)ADDRESS(obj2.obj))->cplx.imag.obj);
    } else
     { 
        tag = GETnum_tag(obj2.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj2.obj) == LTAG_FLOAT) { 
            real2 = obj_to_double(obj2.obj);
            if (real2 == 0.0) { 
                set_reg(SCOBJ_1);
                return;
            }
            imag2 = 0.0;
        } else{
            err_illegal_argument_type(obj2.obj, "number");
	    return;
	}
    }
    if (GETtag(obj1.obj) == LTAG_COMPLEX) { 
        real1 = obj_to_double(((ENTITYP)ADDRESS(obj1.obj))->cplx.real.obj);
        imag1 = obj_to_double(((ENTITYP)ADDRESS(obj1.obj))->cplx.imag.obj);
    } else
     { 
        real1 = obj_to_double(obj1.obj);
        if (real1 == 0.0) { 
            set_reg(SCOBJ_0);
            return;
        }
        imag1 = 0.0;
    }
    tmp1 = exp(real2 * log(magnitude(real1, imag1)) - imag2 * angle(real1, imag1));
    tmp2 = imag2 * log(magnitude(real1, imag1)) + real2 * angle(real1, imag1);
    s_push(mk_flt(tmp1 * cos(tmp2)));    /*  new real part  */
    obj1.obj = mk_flt(tmp1 * sin(tmp2));  /*  new imag part  */
    set_reg(mk_simple_complex(s_pop(), obj1.obj));
}


void Smake_rectangular()  /*  Yass. Sep. 4 '90  */
{ 
    SOBJ real_obj, imag_obj;
    int tag;

#ifdef TOUCH_ARG
    real_obj.obj = touch_obj(getarg(1));
    imag_obj.obj = touch_obj(getarg(2));
#else
    real_obj.obj = getarg(1);
    imag_obj.obj = getarg(2);
#endif
    if (((tag = GETnum_tag(real_obj.obj)) == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || 
        (tag = GETtag(real_obj.obj)) == LTAG_BIGNUM || tag == LTAG_FRACTION || 
        tag == LTAG_FLOAT                                                         ) && 
        ((tag = GETnum_tag(imag_obj.obj)) == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || 
        (tag = GETtag(imag_obj.obj)) == LTAG_BIGNUM || tag == LTAG_FRACTION || 
        tag == LTAG_FLOAT                                                         ))
        set_reg(mk_simple_complex(real_obj.obj, imag_obj.obj));
    else{
        err_illegal_argument("Both arguments must be reals.");
	return ;
    }
}


void Smake_polar()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ mag_obj, ang_obj, tmp_obj;
    int tag;

    double  sin();
    double  sqrt();
    double  obj_to_double();

#ifdef TOUCH_ARG
    mag_obj.obj = touch_obj(getarg(1));
    ang_obj.obj = touch_obj(getarg(2));
#else
    mag_obj.obj = getarg(1);
    ang_obj.obj = getarg(2);
#endif
    if (((tag = GETnum_tag(mag_obj.obj)) == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || 
        (tag = GETtag(mag_obj.obj)) == LTAG_BIGNUM || tag == LTAG_FRACTION || 
        tag == LTAG_FLOAT                                                        ) && 
        ((tag = GETnum_tag(ang_obj.obj)) == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || 
        (tag = GETtag(ang_obj.obj)) == LTAG_BIGNUM || tag == LTAG_FRACTION || 
        tag == LTAG_FLOAT                                                        )) { 
/*        s_push(mk_flt(obj_to_double(mag_obj.obj) * sqrt(1.0 - sin(obj_to_double(ang_obj.obj)))));  *//*  new real part  */
        s_push(mk_flt(obj_to_double(mag_obj.obj) * cos(obj_to_double(ang_obj.obj))));  /*  new real part  */
#ifdef TOUCH_ARG
        tmp_obj.obj = mk_flt(obj_to_double(touch_obj(getarg(1))) * sin(obj_to_double(getarg(2))));
#else
        tmp_obj.obj = mk_flt(obj_to_double(getarg(1)) * sin(obj_to_double(getarg(2))));
#endif
        /*  new imag part  */
        set_reg(mk_simple_complex(s_pop(), tmp_obj.obj));
    } else{
        err_illegal_argument("Both arguments must be reals.");
	return ;
    }
}


void Sreal_part()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_COMPLEX)
        set_reg(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
    else
     { 
        tag = GETnum_tag(obj.obj);
        if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
            GETtag(obj.obj) == LTAG_FLOAT                                       )
            set_reg(obj.obj);
        else{
            err_illegal_argument_type(obj.obj, "number");
	    return ;
	}
    }
}


void Simag_part()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        set_reg(SCOBJ_0);
        break;
    case LTAG_COMPLEX   :
        set_reg(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return;
        break;
    }
}


void Smagnitude()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ obj;

    double  obj_to_double();
    double  magnitude();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        if (obj_sign(obj.obj) < 0)
            obj.obj = minus_obj(obj.obj);
        set_reg(obj.obj);
        break;
    case LTAG_COMPLEX   :
        set_reg(mk_flt(magnitude(obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj),
            obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj))));
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return;
        break;
    }
}


void Sangle()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ   obj;
    double  real, imag;

    double  obj_to_double();
    double  angle();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        real = obj_to_double(obj.obj);
        if (real == 0.0){
            err_illegal_argument("Illegal argument for ANGLE.");
	    return ;
	} else if (real > 0) {	/* T.Komiya */
	    set_reg(SCOBJ_0);
	    return;
	}
        imag = 0.0;
        break;
    case LTAG_COMPLEX   :
        real = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj);
        imag = obj_to_double(((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj);
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return ;
        break;
    }
    set_reg(mk_flt(angle(real, imag)));
}

void Sexact_to_inexact()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
        GETtag(obj.obj) == LTAG_FLOAT                                       )
        set_reg(obj.obj);
    else{
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}

void S_exact_to_inexact()  /* by T.Komiya */
{ 
    SOBJ obj, real, imag;
    int tag;
    double obj_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || GETtag(obj.obj) == LTAG_BIGNUM
    	|| GETtag(obj.obj) == LTAG_FRACTION)
    	set_reg(mk_flt(obj_to_double(obj.obj)));
    else if (GETtag(obj.obj) == LTAG_COMPLEX) {
    	real.obj = ((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj;
    	imag.obj = ((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj;
    	set_reg(mk_cplx(mk_flt(obj_to_double(real.obj)), mk_flt(obj_to_double(imag.obj))));
    } else if (GETtag(obj.obj) == LTAG_FLOAT)
    	set_reg(obj.obj);
    else{
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}

void Sinexact_to_exact()  /*  Yass. Aug. 21 '90  */
{ 
    SOBJ obj;
    int tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag == LTAG_NUMBER1 || tag == LTAG_NUMBER2 || tag == LTAG_NUMBER3 || 
        GETtag(obj.obj) == LTAG_FLOAT)
        set_reg(obj.obj);
    else{
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}

void S_inexact_to_exact()  /* by T.Komiya */
{ 
    SOBJ obj, real, imag;
    int tag;
    double obj_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    tag = GETnum_tag(obj.obj);
    if (tag == LTAG_NUMBER1 || GETtag(obj.obj) == LTAG_BIGNUM
    	|| GETtag(obj.obj) == LTAG_FRACTION)
    	set_reg(obj.obj);
    else if (tag == LTAG_NUMBER2 || GETtag(obj.obj) == LTAG_FLOAT)
    	set_reg(double_to_rational(obj_to_double(obj.obj)));
    else if (GETtag(obj.obj) == LTAG_COMPLEX) {
    	real.obj = ((ENTITYP)ADDRESS(obj.obj))->cplx.real.obj;
    	imag.obj = ((ENTITYP)ADDRESS(obj.obj))->cplx.imag.obj;
    	if (GETnum_tag(real.obj) == LTAG_NUMBER2 || GETtag(real.obj) == LTAG_FLOAT) {
    		s_push(imag.obj);
    		real.obj = double_to_rational(obj_to_double(real.obj));
    		imag.obj = s_pop();
    	}
    	if (GETnum_tag(imag.obj) == LTAG_NUMBER2 || GETtag(imag.obj) == LTAG_FLOAT) {
    		s_push(real.obj);
    		imag.obj = double_to_rational(obj_to_double(imag.obj));
    		real.obj = s_pop();
    	}
    	set_reg(mk_cplx(real.obj, imag.obj));
    } else{
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}


/*************************/
/*                       */
/*  Original procedures  */
/*                       */
/*************************/

void Sadd1()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_COMPLEX   :
        set_reg(add_obj(obj.obj, SCOBJ_1));
        break;
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        set_reg(add_obj(obj.obj, mk_flt(1.0)));
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}



void Ssub1()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_COMPLEX   :
        set_reg(sub_obj(obj.obj, SCOBJ_1));
        break;
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        set_reg(sub_obj(obj.obj, mk_flt(1.0)));
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}


void Sadd2()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_COMPLEX   :
        set_reg(add_obj(obj.obj, SCOBJ_2));
        break;
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        set_reg(add_obj(obj.obj, mk_flt(2.0)));
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}


void Ssub2()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_COMPLEX   :
        set_reg(sub_obj(obj.obj, SCOBJ_2));
        break;
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        set_reg(sub_obj(obj.obj, mk_flt(2.0)));
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return;
    }
}


void Smul2()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_COMPLEX   :
        set_reg(mul_obj(obj.obj, SCOBJ_2));
        break;
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        set_reg(mul_obj(obj.obj, mk_flt(2.0)));
        break;
    default :
        err_illegal_argument_type(obj.obj, "number");
	return ;
    }
}


void Srational_to_real()  /*  Yass. Sep. 10 '90  */
{ 
    SOBJ obj;

    double  obj_to_double();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
        set_reg(mk_flt(obj_to_double(obj.obj)));
        break;
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        set_reg(obj.obj);
        break;
    default :
        err_illegal_argument_type(obj.obj, "real");
	return ;
    }
}


void Sfixnump()       /* by T.Komiya */
{
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    switch (GETtag(obj.obj)) {
    case LTAG_FIXNUM  :
    case LTAG_FIXNUM1 :
    case LTAG_FIXNUM2 :
    case LTAG_FIXNUM3 :
        set_reg(LTAG_T);
        break;
    default :
        set_reg(LTAG_FALSE);
    }
}
