/*
 * numbersub.c - 
 */

/*
 * $Id: numbersub.c,v 1.6 2014/10/28 02:22:55 komiya Exp $
 */

/************************************/
/*                                  */
/*  File Name : numbersub.c         */
/*  Update    : Yass.  Sep. 11 '90  */
/*              Yass.  Sep. 10 '90  */
/*                                  */
/*    Numerical Subroutines         */
/*                                  */
/************************************/

static char *RCSid="$Id: numbersub.c,v 1.6 2014/10/28 02:22:55 komiya Exp $";

#include <math.h>
#include "scheme.h"

#ifdef THINK_C
int int_q_r(int, int, int *);
#endif

/*  transration : scheme to c  */


#define MINUS_MASK  0xfc000000  /*  Yass. Jul. 17 '90  */

int fix_to_int(obj)  /*  Yass. Jul. 17 '90  */
int obj;
{
    if (SIGN_BIT & obj)
        return((IMMNUM(obj) >> 2) | MINUS_MASK);
    else
        return(IMMNUM(obj) >> 2 );
}

#define LSFLT_SIGN(obj)		(0x08000000 & (unsigned)(obj))
#define LSFLT_EXP(obj)		(0x07fc0000 & (unsigned)(obj))
#define LSFLT_MANT(obj)		(0x0003fffc & (unsigned)(obj))

double  flt_to_double(obj)  /*  Yass. Sep. 7 '90  */
int obj;
{ 
    SOBJ    sobj;
    unsigned sign, exp, mant;
    FLT_TMP val;

    if (GETtag(obj) == LTAG_FLOAT)
#ifdef EIGHT_BYTE_ALIGNMENT_DOUBLE /* T.Komiya */
    {
	unaligned_double tmp;

	tmp.b = ((ENTITYP)ADDRESS(obj))->flt.val.b; 
	return(tmp.f);
    }
#else
        return(((ENTITYP)ADDRESS(obj))->flt.val);
#endif
    else
     { 
        sobj.obj = obj;
        sign = LSFLT_SIGN(sobj.sflt);
        exp  = LSFLT_EXP(sobj.sflt);
        mant = LSFLT_MANT(sobj.sflt);
        if (sign == 0 && exp == 0 && mant == 0)
            return(0.0);
        else
         { 
            if (exp & 0x4000000)
                exp = (exp & 0x3fc0000) | 0x10000000;
            else
                exp = (exp | 0xc000000);
            val.i.h = (unsigned)(sign << 4) | (unsigned)(exp << 2)
                                            | (unsigned)(mant << 2);
            val.i.l = 0;
            return(val.d);
        }
    }
}


double  big_to_double(obj)  /*  Yass. Sep. 4 '90  */
int obj;
{ 
    double  val = 0.0,
    weight = 1.0;

    for (; obj != LTAG_NIL ; obj = ((BIGNUM * )ADDRESS(obj))->next.obj) { 
        val += weight * (double)(((BIGNUM * )ADDRESS(obj))->val);
        weight *= 2.147483648e9;
    }
    return(val);
}

int double_to_big(val)  /* by T.Komiya */
double val;
{
	SOBJ obj, tmp;
	int i, e, val_slot;
	FLT_TMP d;
	
	d.d = val;
	e = (FLT_EXP(d) - 1023) - 52;
	if (e > 0) {
		s_push(mk_bign(0x200000 | (FLT_MANT_M(d) << 1)
                                        | (FLT_MANT_H(d) << 5)
                               | ((FLT_MANT_L(d) & ~INT_MASK) ? 1 : 0)));
		obj.obj = mk_bign(FLT_MANT_L(d) & INT_MASK);
	    ((ENTITYP)ADDRESS(obj.obj))->bnum.next.obj = s_pop();
	    s_push(obj.obj);
    	s_push(mk_bign(1 << (e % 31)));
    	for (i = e; i >= 31; i -= 31) {
    		tmp.obj = mk_bign(0);
    		((ENTITYP)ADDRESS(tmp.obj))->bnum.next.obj = s_pop();
    		s_push(tmp.obj);
    	}
    	tmp.obj = s_pop();
	   	obj.obj = mul_obj(s_pop(), tmp.obj);
	} else if (e >= -52) {
		val_slot = 0x200000 | (FLT_MANT_M(d) << 1)
                                    | (FLT_MANT_H(d) << 5)
			            | ((FLT_MANT_L(d) & ~INT_MASK) ? 1 : 0);
		s_push(mk_bign(val_slot >> -e));
		if ((i = 31 + e) >= 0)
			obj.obj = mk_bign(((FLT_MANT_L(d) & INT_MASK) >> -e)
                                          | ((val_slot << i) & INT_MASK));
		else
			obj.obj = mk_bign(((FLT_MANT_L(d) & INT_MASK) >> -e)
                                          | (val_slot >> -i));
	    ((ENTITYP)ADDRESS(obj.obj))->bnum.next.obj = s_pop();
	} else			    
		return(SCOBJ_1);
	if (FLT_SIGN(d))
		obj.obj = complement_big(obj.obj);
	normalize_big(obj.obj);
	return(obj.obj);
}

double  obj_to_double(obj)  /*  Yass. Aug. 29 '90  */
int obj;
{
    switch (GETtag(obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        return((double)fix_to_int(obj));
    case LTAG_BIGNUM    :
        return(big_to_double(obj));
    case LTAG_FRACTION  :
        return(obj_to_double(((ENTITYP)ADDRESS(obj))->frac.nume.obj) / 
            obj_to_double(((ENTITYP)ADDRESS(obj))->frac.deno.obj));
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        return(flt_to_double(obj));
    default :
        bokkan("INTERNAL ERROR = Arguments must be number except complex.");
    }
}


/*  transration : scheme to scheme  */


int fix_to_big(obj)  /*  Yass. Aug. 27 '90  */
int obj;
{
    return(mk_bign(fix_to_int(obj)));
}

/*
int mk_simple_integer(obj)  *//*  Yass. Sep. 3 '90  *//*
int obj;
{ 
    double  val;

    val = big_to_double(obj);
    if (val < FIX_MIN || val > FIX_MAX)
        return(obj);
    else
        return(mk_fix((int)val));
}
*/

int mk_simple_integer(obj)  /*  by T.Komiya */
int obj;
{ 
    double  val;
    BIGNUM  *big;

    normalize_big(obj);
    big = (BIGNUM *)ADDRESS(obj);
    if ((big->next.obj == LTAG_NIL)
        && ((big->val >= 0) ? (big->val <= FIX_MAX)
                            : (big->val >= FIX_MIN)))
        return(mk_fix((int)big->val));
    else
        return(obj);
}


int mk_simple_rational(nume, deno)  /*  Yass. Aug. 31 '90  */
int nume, deno;
{ 
    SOBJ gcd, dummy;

    if (obj_sign(deno) < 0)    /*  denomerator < 0  */ { 
        nume = minus_obj(nume);
        deno = minus_obj(deno);
    }
    if (deno == SCOBJ_0){     /*  @ / 0  */
        err_division_by_zero();  /*  bokkan("0 divide.");  */
	return NULL;
    }
    if (deno == SCOBJ_1)     /*  @ / 1  */
        return(nume);
    if (nume == SCOBJ_0)     /*  0 / @  */
        return(nume);

    s_push(nume);
    s_push(deno);
    gcd.obj = gcd_obj(nume, deno);
    deno = s_pop();
    s_push(gcd.obj);
    deno = int_q_r(deno, gcd.obj, (int *)&dummy);
    gcd.obj = s_pop();
    nume = s_pop();
    s_push(deno);
    nume = int_q_r(nume, gcd.obj, (int *)&dummy);
    deno = s_pop();

    if (deno == SCOBJ_1)     /*  @ / 1  */
        return(nume);
    if (nume == SCOBJ_0)     /*  0 / @  */
        return(nume);
    return(mk_frac(nume, deno));
}


int mk_simple_complex(real, imag)  /*  Yass. Sep. 11 '90  */
int real, imag;
{
    if (imag == SCOBJ_0 || imag == SCOBJ_SF0)
        return(real);
    else
        return(mk_cplx(real, imag));
}


/*  signum  */


int obj_sign(obj)  /*  Yass. Sep. 11 '90  */
int obj;
{
    switch (GETtag(obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
        return(1);
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        return(-1);
    case LTAG_BIGNUM    :
        return(big_sign(obj));
    case LTAG_FRACTION  :
        return(obj_sign(((ENTITYP)ADDRESS(obj))->frac.nume.obj));
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
        return(1);
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
        return(-1);
    case LTAG_FLOAT     :
        return((flt_to_double(obj) < 0.0) ? -1 : 1);
    default :
        bokkan("INTERNAL ERROR = arguments must be number except complex.");
    }
}


/*  copy  */


int copy_obj(obj)  /*  Yass. Aug. 29 '90  */
int obj;
{ 
    SOBJ obj2;

    switch (GETtag(obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        return(obj);
    case LTAG_BIGNUM    :
        return(copy_big(obj));
    case LTAG_FRACTION  :
        s_push(((ENTITYP)ADDRESS(obj))->frac.deno.obj);
        obj = copy_obj(((ENTITYP)ADDRESS(obj))->frac.deno.obj);
        obj2.obj = s_pop();
        s_push(obj);
        obj2.obj = copy_obj(obj2.obj);
        return(mk_frac(s_pop(), obj2.obj));
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
        return(obj);
    case LTAG_FLOAT     :
        return(mk_flt(flt_to_double(obj)));
    case LTAG_COMPLEX   :
        s_push(((ENTITYP)ADDRESS(obj))->cplx.imag.obj);
        obj = copy_obj(((ENTITYP)ADDRESS(obj))->cplx.real.obj);
        obj2.obj = s_pop();
        s_push(obj);
        obj2.obj = copy_obj(obj2.obj);
        return(mk_cplx(s_pop(), obj2.obj));
    default :
        bokkan("INTERNAL ERROR  = Arguments must be number.");
    }
}


/*  negation  */


int minus_obj(obj)  /*  Yass. Aug. 29 '90  */
int obj;
{ 
    SOBJ obj2;

    switch (GETtag(obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        return(mk_fix(-fix_to_int(obj)));
    case LTAG_BIGNUM    :
    {
        BIGNUM *big;

        big = (BIGNUM *)ADDRESS(obj);
        if ((big->next.obj == LTAG_NIL) && (big->val == (FIX_MAX + 1)))
            return(mk_fix(FIX_MIN));
        else
            return(minus_big(obj));
    }
    case LTAG_FRACTION  :       /* by T.Komiya */
/*
        s_push(((ENTITYP)ADDRESS(obj))->frac.deno.obj);
        obj = copy_obj(((ENTITYP)ADDRESS(obj))->frac.deno.obj);
        obj2.obj = s_pop();
        s_push(obj);
        obj2.obj = minus_obj(obj2.obj);
        return(mk_frac(s_pop(), obj2.obj));
*/
        s_push(((ENTITYP)ADDRESS(obj))->frac.deno.obj);
        obj = copy_obj(((ENTITYP)ADDRESS(obj))->frac.nume.obj);
        obj = minus_obj(obj);
        return(mk_frac(obj, s_pop()));
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        return(mk_flt(-flt_to_double(obj)));
    case LTAG_COMPLEX   :
        s_push(((ENTITYP)ADDRESS(obj))->cplx.imag.obj);
        obj = minus_obj(((ENTITYP)ADDRESS(obj))->cplx.real.obj);
        obj2.obj = s_pop();
        s_push(obj);
        obj2.obj = minus_obj(obj2.obj);
        return(mk_cplx(s_pop(), obj2.obj));
    default :
        bokkan("INTERNAL ERROR = Arguments must be number.");
    }
}


/*  compare  */


int comp_obj(obj1, obj2, inlinedbc)  /*  Yass. Aug. 29 '90  */
int obj1, obj2, inlinedbc;
{ 
    SOBJ   tmp;
    int i_val1, i_val2;
    double  r_val1, r_val2;

    switch (GETtag(obj1)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
            if ((i_val1 = fix_to_int(obj1)) < (i_val2 = fix_to_int(obj2)))
                return(LESST);
            if (i_val1 == i_val2)
                return(EQUAL);
            if (i_val1 > i_val2)
                return(GREATERT);
        case LTAG_BIGNUM    :
            if (big_sign(obj2) < 0)
                return(GREATERT);
            else
                return(LESST);
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            obj1 = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            return(comp_obj(obj1, s_pop(), inlinedbc));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            if ((r_val1 = (double)fix_to_int(obj1)) < (r_val2 = flt_to_double(obj2)))
                return(LESST);
            if (r_val1 == r_val2)
                return(EQUAL);
            if (r_val1 > r_val2)
                return(GREATERT);
        default :
            if (inlinedbc) {
                reg_reg = obj2;
                error_invalid_arg1("...");
            } else
                err_illegal_argument_type(obj2, "real");
	    return 0;           /* never reach here */
        }
    case LTAG_BIGNUM    :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
            if (big_sign(obj1) < 0)
                return(LESST);
            else
                return(GREATERT);
        case LTAG_BIGNUM    :
            return(big_compare(obj1, obj2));
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            obj1 = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            return(comp_obj(obj1, s_pop(), inlinedbc));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            if ((r_val1 = big_to_double(obj1)) < (r_val2 = flt_to_double(obj2)))
                return(LESST);
            if (r_val1 == r_val2)
                return(EQUAL);
            if (r_val1 > r_val2)
                return(GREATERT);
            if (isnan(r_val1))
                obj2 = obj1;
        default :
            if (inlinedbc) {
                reg_reg = obj2;
                error_invalid_arg1("...");
            } else
                err_illegal_argument_type(obj2, "real");
	    return 0;           /* never reach here */
        }
    case LTAG_FRACTION  :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
            s_push(((ENTITYP)ADDRESS(obj1))->frac.nume.obj);
            obj2 = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.deno.obj, obj2);
            return(comp_obj(s_pop(), obj2, inlinedbc));
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            s_push(((ENTITYP)ADDRESS(obj1))->frac.deno.obj);
            obj1 = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.nume.obj,
                ((ENTITYP)ADDRESS(obj2))->frac.deno.obj );
            tmp.obj = s_pop();
            obj2 = s_pop();
            s_push(obj1);
            obj2 = mul_obj(obj2, tmp.obj);
            return(comp_obj(s_pop(), obj2, inlinedbc));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            if ((r_val1 = obj_to_double(obj1)) < (r_val2 = flt_to_double(obj2)))
                return(LESST);
            if (r_val1 == r_val2)
                return(EQUAL);
            if (r_val1 > r_val2)
                return(GREATERT);
            if (isnan(r_val1))
                obj2 = obj1;
        default :
            if (inlinedbc) {
                reg_reg = obj2;
                error_invalid_arg1("...");
            } else
                err_illegal_argument_type(obj2, "number");
	    return 0;           /* never reach here */
        }
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            if ((r_val1 = flt_to_double(obj1)) < (r_val2 = obj_to_double(obj2)))
                return(LESST);
            if (r_val1 == r_val2)
                return(EQUAL);
            if (r_val1 > r_val2)
                return(GREATERT);
            if (isnan(r_val1))
                obj2 = obj1;
        default :
            if (inlinedbc) {
                reg_reg = obj2;
                error_invalid_arg1("...");
            } else
                err_illegal_argument_type(obj2, "number");
	    return 0;           /* never reach here */
        }
    default :
        err_illegal_argument_type(obj1, "real");
	return 0;               /* never reach here */
    }
}


int comp_cplx(obj1, obj2)  /*  Yass. Aug. 29 '90  */
int obj1, obj2;
{ 
    int result;

    s_push(obj1);  
    s_push(obj2);
    result = comp_obj(((ENTITYP)ADDRESS(obj1))->cplx.real.obj,
        ((ENTITYP)ADDRESS(obj2))->cplx.real.obj, 0);
    obj2 = s_pop();  
    obj1 = s_pop();
    result &= comp_obj(((ENTITYP)ADDRESS(obj1))->cplx.imag.obj,
        ((ENTITYP)ADDRESS(obj2))->cplx.imag.obj, 0);
    if (result == EQUAL)
        return(EQUAL);
    else
        return(NEQ);
}


/*  add , sub , mul , div  */


int add_obj(obj1, obj2)  /*  Yass. Sep. 17 '90  */
int obj1, obj2;
{ 
    SOBJ tmp;
    int i_val;

    switch (GETtag(obj1)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
            i_val = fix_to_int(obj1);
            i_val += fix_to_int(obj2);
            if (FIX_MIN <= i_val && i_val <= FIX_MAX)
                return(mk_fix(i_val));
            else
                return(mk_bign(i_val));
        case LTAG_BIGNUM    :
            i_val = fix_to_int(obj1);
            obj2 = copy_big(obj2);
            return(mk_simple_integer(add_int_big(obj2, i_val)));
        case LTAG_FRACTION  :
            s_push(obj2);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = add_obj(tmp.obj, ((ENTITYP)ADDRESS(getsvt(0)))->frac.nume.obj);
            return(mk_frac(tmp.obj, ((ENTITYP)ADDRESS(s_pop()))->frac.deno.obj));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt((double)fix_to_int(obj1) + flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            tmp.obj = add_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            return(mk_cplx(tmp.obj, s_pop()));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_BIGNUM    :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
            i_val = fix_to_int(obj2);
            obj1 = copy_big(obj1);
            return(mk_simple_integer(add_int_big(obj1, i_val)));
        case LTAG_BIGNUM    :
            return(mk_simple_integer(add_big_big(obj1, obj2)));
        case LTAG_FRACTION  :
            s_push(obj2);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = add_obj(tmp.obj, ((ENTITYP)ADDRESS(getsvt(0)))->frac.nume.obj);
            return(mk_frac(tmp.obj, ((ENTITYP)ADDRESS(s_pop()))->frac.deno.obj));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(big_to_double(obj1) + flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            tmp.obj = add_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            return(mk_cplx(tmp.obj, s_pop()));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_FRACTION  :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
            s_push(obj1);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.deno.obj, obj2);
            tmp.obj = add_obj(((ENTITYP)ADDRESS(getsvt(0)))->frac.nume.obj, tmp.obj);
            return(mk_frac(tmp.obj, ((ENTITYP)ADDRESS(s_pop()))->frac.deno.obj));
        case LTAG_FRACTION  :
            s_push(obj1);
            s_push(obj2);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.deno.obj,
                ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            obj2 = s_pop();
            obj1 = s_pop();
            s_push(tmp.obj);
            s_push(((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            s_push(((ENTITYP)ADDRESS(obj1))->frac.deno.obj);
            obj1 = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.nume.obj,
                ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = s_pop();
            obj2 = s_pop();
            s_push(obj1);
            obj2 = mul_obj(obj2, tmp.obj);
            tmp.obj = add_obj(s_pop(), obj2);
            return(mk_simple_rational(tmp.obj, s_pop()));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(obj_to_double(obj1) + flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            tmp.obj = add_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            return(mk_cplx(tmp.obj, s_pop()));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(flt_to_double(obj1) + obj_to_double(obj2)));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            tmp.obj = add_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            return(mk_cplx(tmp.obj, s_pop()));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_COMPLEX   :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            s_push(((ENTITYP)ADDRESS(obj1))->cplx.imag.obj);
            tmp.obj = add_obj(((ENTITYP)ADDRESS(obj1))->cplx.real.obj, obj2);
            return(mk_cplx(tmp.obj, s_pop()));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj1))->cplx.imag.obj);
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            tmp.obj = add_obj(((ENTITYP)ADDRESS(obj1))->cplx.real.obj,
                ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            obj2 = s_pop();
            obj1 = s_pop();
            s_push(tmp.obj);
            tmp.obj = add_obj(obj1, obj2);
            return(mk_simple_complex(s_pop(), tmp.obj));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    default :
        err_illegal_argument_type(obj1, "number");
	return NULL;
    }
}


int sub_obj(obj1, obj2)  /*  Yass. Sep. 17 '90  */
int obj1, obj2;
{ 
    SOBJ tmp;
    int i_val;

    switch (GETtag(obj1)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
            i_val = fix_to_int(obj1);
            i_val -= fix_to_int(obj2);
            if (FIX_MIN <= i_val && i_val <= FIX_MAX)
                return(mk_fix(i_val));
            else
                return(mk_bign(i_val));
        case LTAG_BIGNUM    :
            i_val = fix_to_int(obj1);
            obj2 = minus_big(obj2);
            return(mk_simple_integer(add_int_big(obj2, i_val)));
        case LTAG_FRACTION  :
            s_push(obj2);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = sub_obj(tmp.obj, ((ENTITYP)ADDRESS(getsvt(0)))->frac.nume.obj);
            return(mk_frac(tmp.obj, ((ENTITYP)ADDRESS(s_pop()))->frac.deno.obj));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt((double)fix_to_int(obj1) - flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            tmp.obj = minus_obj(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            s_push(tmp.obj);
            tmp.obj = sub_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            return(mk_cplx(tmp.obj, s_pop()));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_BIGNUM    :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
            i_val = fix_to_int(obj2);
            obj1 = copy_big(obj1);
            return(mk_simple_integer(sub_int_big(obj1, i_val)));
        case LTAG_BIGNUM    :
            return(mk_simple_integer(sub_big_big(obj1, obj2)));
        case LTAG_FRACTION  :
            s_push(obj2);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = sub_obj(tmp.obj, ((ENTITYP)ADDRESS(getsvt(0)))->frac.nume.obj);
            return(mk_frac(tmp.obj, ((ENTITYP)ADDRESS(s_pop()))->frac.deno.obj));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(big_to_double(obj1) - flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            tmp.obj = minus_obj(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            s_push(tmp.obj);
            tmp.obj = sub_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            return(mk_cplx(tmp.obj, s_pop()));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_FRACTION  :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
            s_push(obj1);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.deno.obj, obj2);
            tmp.obj = sub_obj(((ENTITYP)ADDRESS(getsvt(0)))->frac.nume.obj, tmp.obj);
            return(mk_frac(tmp.obj, ((ENTITYP)ADDRESS(s_pop()))->frac.deno.obj));
        case LTAG_FRACTION  :
            s_push(obj1);
            s_push(obj2);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.deno.obj,
                ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            obj2 = s_pop();
            obj1 = s_pop();
            s_push(tmp.obj);
            s_push(((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            s_push(((ENTITYP)ADDRESS(obj1))->frac.deno.obj);
            obj1 = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.nume.obj,
                ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = s_pop();
            obj2 = s_pop();
            s_push(obj1);
            obj2 = mul_obj(obj2, tmp.obj);
            tmp.obj = sub_obj(s_pop(), obj2);
            return(mk_simple_rational(tmp.obj, s_pop()));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(obj_to_double(obj1) - flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            tmp.obj = minus_obj(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            s_push(tmp.obj);
            tmp.obj = sub_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            return(mk_cplx(tmp.obj, s_pop()));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(flt_to_double(obj1) - obj_to_double(obj2)));
        case LTAG_COMPLEX   :
            tmp.obj = minus_obj(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            s_push(tmp.obj);
            tmp.obj = sub_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            return(mk_cplx(tmp.obj, s_pop()));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_COMPLEX   :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            s_push(((ENTITYP)ADDRESS(obj1))->cplx.imag.obj);
            tmp.obj = sub_obj(((ENTITYP)ADDRESS(obj1))->cplx.real.obj, obj2);
            return(mk_cplx(tmp.obj, s_pop()));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj1))->cplx.imag.obj);
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            tmp.obj = sub_obj(((ENTITYP)ADDRESS(obj1))->cplx.real.obj,
                ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            obj2 = s_pop();
            obj1 = s_pop();
            s_push(tmp.obj);
            tmp.obj = sub_obj(obj1, obj2);
            return(mk_simple_complex(s_pop(), tmp.obj));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    default :
        err_illegal_argument_type(obj1, "number");
	return NULL;
    }
}


int mul_obj(obj1, obj2)  /*  Yass. Sep. 17 '90  */
int obj1, obj2;
{ 
    SOBJ   tmp;
    int i_val;
    double  r_val;

    switch (GETtag(obj1)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
            i_val = fix_to_int(obj2);
            r_val = (double)i_val;
            r_val *= (double)fix_to_int(obj1);
            if ((double)FIX_MIN <= r_val && r_val <= (double)FIX_MAX)
                return(mk_fix(i_val * fix_to_int(obj1)));
            if ((double)INTEGER_MIN <= r_val && r_val <= (double)INTEGER_MAX)
                return(mk_bign(i_val * fix_to_int(obj1)));
            obj1 = fix_to_big(obj1);
            return(mk_simple_integer(mul_int_big(obj1, i_val)));
        case LTAG_BIGNUM    :
            i_val = fix_to_int(obj1);
            obj2 = copy_big(obj2);
            return(mk_simple_integer(mul_int_big(obj2, i_val)));
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            return(mk_simple_rational(tmp.obj, s_pop()));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt((double)fix_to_int(obj1) * flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            s_push(obj1);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            obj1 = s_pop();
            obj2 = s_pop();
            s_push(tmp.obj);
            tmp.obj = mul_obj(obj1, obj2);
            return(mk_simple_complex(s_pop(), tmp.obj));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_BIGNUM    :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
            i_val = fix_to_int(obj2);
            obj1 = copy_big(obj1);
            return(mk_simple_integer(mul_int_big(obj1, i_val)));
        case LTAG_BIGNUM    :
            return(mk_simple_integer(mul_big_big(obj1, obj2)));
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            return(mk_simple_rational(tmp.obj, s_pop()));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(big_to_double(obj1) * flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            s_push(obj1);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            obj1 = s_pop();
            obj2 = s_pop();
            s_push(tmp.obj);
            tmp.obj = mul_obj(obj1, obj2);
            return(mk_cplx(s_pop(), tmp.obj));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_FRACTION  :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
            s_push(((ENTITYP)ADDRESS(obj1))->frac.deno.obj);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.nume.obj, obj2);
            return(mk_simple_rational(tmp.obj, s_pop()));
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj1))->frac.deno.obj);
            s_push(((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.nume.obj,
                ((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            obj2 = s_pop();
            obj1 = s_pop();
            s_push(tmp.obj);
            tmp.obj = mul_obj(obj1, obj2);
            return(mk_simple_rational(s_pop(), tmp.obj));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(obj_to_double(obj1) * flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            s_push(obj1);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            obj1 = s_pop();
            obj2 = s_pop();
            s_push(tmp.obj);
            tmp.obj = mul_obj(obj1, obj2);
            return(mk_cplx(s_pop(), tmp.obj));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            return(mk_flt(flt_to_double(obj1) * obj_to_double(obj2)));
        case LTAG_COMPLEX   :
            s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);
            s_push(obj1);
            tmp.obj = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            obj1 = s_pop();
            obj2 = s_pop();
            s_push(tmp.obj);
            tmp.obj = mul_obj(obj1, obj2);
            return(mk_simple_complex(s_pop(), tmp.obj));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    case LTAG_COMPLEX   :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            s_push(((ENTITYP)ADDRESS(obj1))->cplx.imag.obj);
            s_push(obj2);
            tmp.obj = mul_obj(obj2, ((ENTITYP)ADDRESS(obj1))->cplx.real.obj);
            obj2 = s_pop();
            obj1 = s_pop();
            s_push(tmp.obj);
            tmp.obj = mul_obj(obj1, obj2);
            return(mk_simple_complex(s_pop(), tmp.obj));
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj1))->cplx.imag.obj);
            s_push(obj2);
            tmp.obj = mul_obj(obj2, ((ENTITYP)ADDRESS(obj1))->cplx.real.obj);
            obj2 = s_pop();
            obj1 = s_pop();
            s_push(tmp.obj);
            tmp.obj = mul_obj(obj1, obj2);
            return(mk_cplx(s_pop(), tmp.obj));
        case LTAG_COMPLEX   :
            s_push(obj1);
            s_push(obj2);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->cplx.real.obj,
                ((ENTITYP)ADDRESS(obj2))->cplx.real.obj);
            s_push(tmp.obj);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(getsvt(2)))->cplx.imag.obj,
                ((ENTITYP)ADDRESS(getsvt(1)))->cplx.imag.obj);
            tmp.obj = sub_obj(s_pop(), tmp.obj);
            s_push(tmp.obj);
	    {
		unsigned tmp, tmp1, tmp2;

		tmp1 = getsvt(1);
		tmp2 = getsvt(2);
                tmp = mul_obj(((ENTITYP)ADDRESS(tmp2))->cplx.real.obj,
			       ((ENTITYP)ADDRESS(tmp1))->cplx.imag.obj);
		s_push(tmp);
	    }
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(getsvt(3)))->cplx.imag.obj,
                ((ENTITYP)ADDRESS(getsvt(2)))->cplx.real.obj);
            tmp.obj = add_obj(s_pop(), tmp.obj);
            obj1 = s_pop();
            addtop(2);
            return(mk_simple_complex(obj1, tmp.obj));
        default :
            err_illegal_argument_type(obj2, "number");
	    return NULL;
        }
    default :
        err_illegal_argument_type(obj1, "number");
	return NULL;
    }
}


int div_complex(obj1, obj2)  /*  Yass. Aug. 30 '90  */
int obj1, obj2;
{ 
    SOBJ tmp;
    int tmp2;
    unsigned tmp3;

    /*  (a + bi)/(c + di)  */
    if (GETtag(obj1) == LTAG_COMPLEX) { 
        s_push(((ENTITYP)ADDRESS(obj1))->cplx.real.obj);  /*  push a  */
        s_push(((ENTITYP)ADDRESS(obj1))->cplx.imag.obj);  /*  push b  */
    } else
     { 
        s_push(obj1);                                     /*  push a  */
        s_push(SCOBJ_0);                                  /*  push b  */
    }
    if (GETtag(obj2) == LTAG_COMPLEX) { 
        s_push(((ENTITYP)ADDRESS(obj2))->cplx.real.obj);  /*  push c  */
        s_push(((ENTITYP)ADDRESS(obj2))->cplx.imag.obj);  /*  push d  */
    } else
     { 
        s_push(obj2);                                     /*  push c  */
        s_push(SCOBJ_0);                                  /*  push d  */
    }

    tmp.obj = getsvt(0);
    tmp3 = mul_obj(tmp.obj, tmp.obj);      /*  c ** 2  */
    s_push(tmp3);
    tmp.obj = mul_obj(getsvt(2), getsvt(2));    /*  d ** 2  */
    tmp2 = s_pop();
    tmp3 = add_obj(tmp.obj, tmp2);          /*  push c ** 2 + d ** 2  */
    s_push(tmp3);
    tmp.obj = getsvt(2);
    tmp2 = getsvt(4);
    tmp3 = mul_obj(tmp2, tmp.obj);      /*  a * c  */
    s_push(tmp3);
    tmp.obj = mul_obj(getsvt(4), getsvt(2));    /*  b * d  */
    tmp2 = s_pop();
    tmp3 = add_obj(tmp2, tmp.obj);          /*  push a * c + b * d  */
    s_push(tmp3);
    tmp.obj = getsvt(2);
    tmp2 = getsvt(5);
    tmp3 = mul_obj(tmp2, tmp.obj);      /*  a * d  */
    s_push(tmp3);
    tmp.obj = mul_obj(getsvt(5), getsvt(4));    /*  b * c  */
    tmp.obj = sub_obj(tmp.obj, s_pop());        /*  b * c - a * d  */
    tmp.obj = div_obj(tmp.obj, getsvt(1));      /*   b * c - a * d   */
    /*  ---------------  new imag part  */
    /*  c ** 2 + d ** 2  */
    obj1 = s_pop();                             /*  pop a * c + b * d  */
    s_push(tmp.obj);                            /*  push new imag part  */
    obj1 = div_obj(obj1, getsvt(1));            /*   a * c + b * d   */
    /*  ---------------  new real part  */
    /*  c ** 2 + d ** 2  */
    obj2 = s_pop();                             /*  pop new imag part  */
    addtop(5);
    return(mk_simple_complex(obj1, obj2));
}


int div_obj(obj1, obj2)  /* Yass. Aug. 30 '90  */
int obj1, obj2;
{ 
    SOBJ   tmp;
    double  r_val;

    switch (GETtag(obj1)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_BIGNUM    :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
            return(mk_simple_rational(obj1, obj2));
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            obj1 = mul_obj(obj1, ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            return(mk_simple_rational(obj1, s_pop()));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            r_val = flt_to_double(obj2);
            if (r_val == 0.0){
                err_division_by_zero(); /*  bokkan("0 divide."); */
		return NULL;
	    }
            if (obj1 == SCOBJ_0)  /*  for obj1 is fixnum  */
                return(obj1);
            else
                return(mk_flt(obj_to_double(obj1) / r_val));
        case LTAG_COMPLEX   :
            return(div_complex(obj1, obj2));
        default :
            err_illegal_argument_type(obj2, "number"); 
	               /* bokkan("Argument must be number."); */
	    return NULL;
        }
    case LTAG_FRACTION  :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
            s_push(((ENTITYP)ADDRESS(obj1))->frac.nume.obj);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.deno.obj, obj2);
            return(mk_simple_rational(s_pop(), tmp.obj));
        case LTAG_FRACTION  :
            s_push(((ENTITYP)ADDRESS(obj1))->frac.deno.obj);
            s_push(((ENTITYP)ADDRESS(obj2))->frac.nume.obj);
            tmp.obj = mul_obj(((ENTITYP)ADDRESS(obj1))->frac.nume.obj,
                ((ENTITYP)ADDRESS(obj2))->frac.deno.obj);
            obj2 = s_pop();
            obj1 = s_pop();
            s_push(tmp.obj);
            tmp.obj = mul_obj(obj1, obj2);
            return(mk_simple_rational(s_pop(), tmp.obj));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            r_val = flt_to_double(obj2);
            if (r_val == 0.0){
		err_division_by_zero();  /*  bokkan("0 divide.");  */
		return NULL;
	    }
            return(mk_flt(obj_to_double(obj1) / r_val));
        case LTAG_COMPLEX   :
            return(div_complex(obj1, obj2));
        default :
            err_illegal_argument_type(obj2, "number"); 
                       /* bokkan("Argument must be number."); */
	    return NULL;
        }
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
    case LTAG_FLOAT     :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
            if (fix_to_int(obj2) == 0){
		err_division_by_zero();  /*  bokkan("0 divide.");  */
		return NULL;
	    }
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
            return(mk_flt(flt_to_double(obj1) / obj_to_double(obj2)));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            if (flt_to_double(obj2) == 0.0){
		err_division_by_zero();  /*  bokkan("0 divide.");  */
		return NULL;
	    }
            return(mk_flt(flt_to_double(obj1) / flt_to_double(obj2)));
        case LTAG_COMPLEX   :
            return(div_complex(obj1, obj2));
        default :
            err_illegal_argument_type(obj2, "number"); 
	              /*  bokkan("Argument must be number."); */
	    return NULL;
        }
    case LTAG_COMPLEX   :
        switch (GETtag(obj2)) { 
        case LTAG_FIXNUM    :
        case LTAG_FIXNUM1   :
            if (fix_to_int(obj2) == 0){
		err_division_by_zero();  /*  bokkan("0 divide.");  */
		return NULL;
	    }
            return(div_complex(obj1, obj2));
        case LTAG_FIXNUM2   :
        case LTAG_FIXNUM3   :
        case LTAG_BIGNUM    :
        case LTAG_FRACTION  :
            return(div_complex(obj1, obj2));
        case LTAG_SFLOAT    :
        case LTAG_SFLOAT1   :
        case LTAG_SFLOAT2   :
        case LTAG_SFLOAT3   :
        case LTAG_FLOAT     :
            if (flt_to_double(obj2) == 0.0){
		err_division_by_zero();  /*  bokkan("0 divide.");  */
		return NULL;
	    }
            return(div_complex(obj1, obj2));
        case LTAG_COMPLEX   :
            return(div_complex(obj1, obj2));
        default :
	err_illegal_argument_type(obj2, "number"); 
                  /*  bokkan("Argument must be number."); */
	return NULL;
        }
    default :
	err_illegal_argument_type(obj1, "number");
                  /*  bokkan("Argument must be number."); */
	return NULL;
    }
}


int gcd_obj(x, y)  /*  Yass. Sep. 3 '90  */
int x,  /*  any object  */
y;  /*  any object  */
{ 
    SOBJ tmp;
    int i, j, k;

    if ((GETnum_tag(x) != LTAG_NUMBER1 && GETtag(x) != LTAG_BIGNUM)){
        err_illegal_argument_type(x, "integer");
	return NULL;
    }
    if ((GETnum_tag(y) != LTAG_NUMBER1 && GETtag(y) != LTAG_BIGNUM)){
        err_illegal_argument_type(y, "integer");
	return NULL;
    }
    s_push(y);
    if (obj_sign(x) < 0)
        x = minus_obj(x);
    y = s_pop();
    s_push(x);
    if (obj_sign(y) < 0)
        y = minus_obj(y);
    x = s_pop();

    while (1) { 
        if (GETnum_tag(x) == LTAG_NUMBER1 && GETnum_tag(y) == LTAG_NUMBER1) { 
            i = fix_to_int(x);
            j = fix_to_int(y);
            while (1) { 
                if (i < j) { 
                    k = i;  
                    i = j;  
                    j = k;
                }
                if (j == 0)
                    return(mk_fix(i));
                k = i % j;
                i = j;
                j = k;
            }
        }
        s_push(x);
        s_push(y);
        if (comp_obj(x, y, 0) == LESST) { 
            y = s_pop();
            x = s_pop();
            tmp.obj = x;
            x = y;
            y = tmp.obj;
        } else
         { 
            y = s_pop();
            x = s_pop();
        }
        if (GETnum_tag(y) == LTAG_NUMBER1 && y == SCOBJ_0)
            return(x);
        s_push(y);
        int_q_r(x, y, (int *)&(tmp.obj));
        x = s_pop();
        y = tmp.obj;
    }
}

/***********
int lcm_obj(obj1, obj2)  *//* Yass. Aug. 31 '90 */
/* int obj1, */ /*  any object  */
/* obj2;  */ /*  any object  *//*
{ 
    SOBJ tmp;

    if ((GETnum_tag(obj1) != LTAG_NUMBER1 && GETtag(obj1) != LTAG_BIGNUM)){
        err_illegal_argument_type(obj1, "integer");
	return NULL;
    }
    if ((GETnum_tag(obj2) != LTAG_NUMBER1 && GETtag(obj2) != LTAG_BIGNUM)){
        err_illegal_argument_type(obj2, "integer");
	return NULL;
    }
    tmp.obj = mul_obj(obj1, obj2);
    s_push(tmp.obj);
    tmp.obj = gcd_obj(obj1, obj2);
    return(div_obj(s_pop(), tmp.obj));
}
**************/

int lcm_obj(obj1, obj2)  /* By T.Komiya */
                         /* Error check by N.Watanabe 92/11/24 */
int obj1,  /*  any object  */
obj2;  /*  any object  */
{ 
    SOBJ tmp;

    if ((GETnum_tag(obj1) != LTAG_NUMBER1 && GETtag(obj1) != LTAG_BIGNUM)){
        err_illegal_argument_type(obj1, "integer");
	return NULL;
    }
    if ((GETnum_tag(obj2) != LTAG_NUMBER1 && GETtag(obj2) != LTAG_BIGNUM)){
        err_illegal_argument_type(obj2, "integer");
	return NULL;
    }
    tmp.obj = mul_obj(obj1, obj2);
    switch (GETtag(tmp.obj)) { 
    case LTAG_FIXNUM    :
    case LTAG_FIXNUM1   :
    case LTAG_SFLOAT    :
    case LTAG_SFLOAT1   :
        break;
    case LTAG_FIXNUM2   :
    case LTAG_FIXNUM3   :
    case LTAG_SFLOAT2   :
    case LTAG_SFLOAT3   :
        tmp.obj = minus_obj(tmp.obj);
        break;
    case LTAG_BIGNUM    :
    case LTAG_FRACTION  :
    case LTAG_FLOAT     :
        if (obj_sign(tmp.obj) < 0)
            tmp.obj = minus_obj(tmp.obj);
        break;
    default :
        err_illegal_argument("Argument must be a real.");
	return NULL;
        break;
    }
    s_push(tmp.obj);
    tmp.obj = gcd_obj(obj1, obj2);
    return(div_obj(s_pop(), tmp.obj));
}


int int_q_r(x, y, rp)  /*  Yass. Sep. 3 '90  */
int x,    /*  any fixnum or any bignum  */
y,    /*  any fixnum or any bignum  */
*rp;  /*  returned value, any fixnum or any bignum  */
{ 
    int tagx, tagy,
    i, j, q, r;

    tagx = GETnum_tag(x);
    tagy = GETnum_tag(y);

    if (tagx == LTAG_NUMBER1) { 
        if (tagy == LTAG_NUMBER1) { 
            if (y == SCOBJ_0){
		err_division_by_zero();  /*  bokkan("0 divide.");  */
		return NULL;
	    }
            i = fix_to_int(x);
            j = fix_to_int(y);
            *rp = mk_fix(i % j);
            return(mk_fix(i / j));
        } else
         { 
            *rp = x;
            return(SCOBJ_0);
        }
    } else
     { 
        if (tagy == LTAG_NUMBER1) { 
            if (y == SCOBJ_0){
		err_division_by_zero();  /*  bokkan("0 divide.");  */
		return NULL;
	    }
            s_push(y);
            if ((i = big_sign(x)) < 0)
                x = minus_big(x);
            else
                x = copy_big(x);
            y = s_pop();
            if ((q = fix_to_int(y)) < 0) { 
                q = -q;
                j = -i;
            } else
                j = i;
            x = div_int_big(x, q, &r);
            if (j < 0)
                x = complement_big(x);
            *rp = mk_fix(i < 0 ? -r : r);
            return(mk_simple_integer(x));
        } else
         { 
            if ((i = big_sign(x)) < 0) { 
                s_push(y);
                x = minus_big(x);
                y = s_pop();
            }
            if (big_sign(y) < 0) { 
                s_push(x);
                y = minus_big(y);
                x = s_pop();
                j = -i;
            } else
                j = i;
            x = big_q_r(x, y, rp);
            if (j < 0) { 
                s_push(*rp);
                x = complement_big(x);
                *rp = s_pop();
            }
            if (i < 0) { 
                s_push(x);
                *rp = complement_big(*rp);
                x = s_pop();
            }
            normalize_big(x);
            normalize_big(*rp);
            *rp = mk_simple_integer(*rp);
            return(mk_simple_integer(x));
        }
    }
}


int quotient_obj(obj1, obj2)  /* Yass. Aug. 31 '90  */
                         /* Error check by N.Watanabe 92/11/24 */
int obj1,  /*  any object  */
obj2;  /*  any object  */
{ 
    SOBJ dummy;

    if ((GETnum_tag(obj1) != LTAG_NUMBER1 && GETtag(obj1) != LTAG_BIGNUM)){
        err_illegal_argument_type(obj1, "integer");
	return NULL;
    }
    if ((GETnum_tag(obj2) != LTAG_NUMBER1 && GETtag(obj2) != LTAG_BIGNUM)){
        err_illegal_argument_type(obj2, "integer");
	return NULL;
    }
    return(int_q_r(obj1, obj2, &(dummy.obj)));
}


#define  PAI  3.14159265359  /*  Yass. Jul. 5 '90  */

double  magnitude(real, imag)  /*  Yass. Jul. 5 '90  */
double  real, imag;
{
    return(sqrt(real * real + imag * imag));
}

/**********
double  angle(real, imag)  *//*  Yass. Jul. 5 '90  *//*
double  real, imag;
{ 
    double  tmp;

    tmp = real * real + imag * imag;
    if (tmp == 0.0){
        err_system_error("in angle().");
	return NULL;
    }
    tmp = asin(imag / sqrt(tmp));
    if (tmp == 0.0 && real < 0.0)
        tmp = PAI;
    return(tmp);
}
***********/

double  angle(real, imag)  /*  By T.Komiya */
double  real, imag;
{ 
    double  tmp;

    return(atan2(imag, real));
}


double  sin_real(real, imag)  /*  Yass. Jul. 5 '90  */
double  real, imag;
{
    return((sin(real) * exp(-imag) - sin(-real) * exp(imag)) / 2.0);
}


double  sin_imag(real, imag)  /*  Yass. Jul. 5 '90  */
double  real, imag;
{
    return((cos(-real) * exp(imag) - cos(real) * exp(-imag)) / 2.0);
}


double  cos_real(real, imag)  /*  Yass. Jul. 5 '90  */
double  real, imag;
{
    return((cos(real) * exp(-imag) + cos(-real) * exp(imag)) / 2.0);
}


double  cos_imag(real, imag)  /*  Yass. Jul. 5 '90  */
double  real, imag;
{
    return((sin(real) * exp(-imag) + sin(-real) * exp(imag)) / 2.0);
}


push_digit(number, radix)
int number, radix;
{ 
    int val_i;
    double  val_r;

    switch (GETtag(number)) { 
    case LTAG_FIXNUM   :
    case LTAG_FIXNUM1  :
    case LTAG_FIXNUM2  :
    case LTAG_FIXNUM3  :
        push_fix(number, radix);
        break;
    case LTAG_BIGNUM   :
        push_big(number, radix);
        break;
    case LTAG_FRACTION :
        push_digit(((ENTITYP)ADDRESS(number))->frac.deno.obj, radix);
        s_push(mk_ch('\0', '/'));
        push_digit(((ENTITYP)ADDRESS(number))->frac.nume.obj, radix);
        break;
    case LTAG_SFLOAT   :
    case LTAG_SFLOAT1  :
    case LTAG_SFLOAT2  :
    case LTAG_SFLOAT3  :
    case LTAG_FLOAT    :
        push_flt(number, 10);   /* by T.Komiya */
        break;
    case LTAG_COMPLEX  :
        s_push(mk_ch('\0', 'i'));
        push_digit(((ENTITYP)ADDRESS(number))->cplx.imag.obj, radix);
        if (obj_sign(((ENTITYP)ADDRESS(number))->cplx.imag.obj) >= 0)
            s_push(mk_ch('\0', '+'));
        push_digit(((ENTITYP)ADDRESS(number))->cplx.real.obj, radix);
        break;
    default :
        bokkan("INTERNAL ERROR(push_digit()).");
    }
}


push_fix(number, radix)
int number, radix;
{ 
    char    digit_buf[33];
    int sign = 1,
    val, len, i;

    val = fix_to_int(number);
    if (val < 0) { 
        sign = -1;
        val = -val;
    }
    switch (radix) { 
    case BINARY  :
        for (i = 0 ; i < 32 ; i++) { 
            if (val & 0x80000000)
                break;
            val <<= 1;
        }
        if (i == 32) { 
            digit_buf[0] = '0';
            digit_buf[1] = '\0';
        } else
         { 
            len = 0;
            for (; i < 32 ; i++) { 
                digit_buf[len] = (val & 0x80000000 ? '1' : '0');
                len++;
                val <<= 1;
            }
            digit_buf[len] = '\0';
        }
        break;
    case OCTAL   :
        sprintf(digit_buf, "%o", val);
        break;
    case DECIMAL :
        sprintf(digit_buf, "%d", val);
        break;
    case HEX     :
        sprintf(digit_buf, "%X", val);
        break;
    default :
        bokkan("INTERNAL ERROR(push_fix()).");
    }
    len = strlen(digit_buf);  /*  digit length  */
    len--;
    for (; len >= 0 ; len--)
        s_push(mk_ch('\0', digit_buf[len]));
    if (sign < 0)
        s_push(mk_ch('\0', '-'));
}


push_big(number, radix)
int number, radix;
{ 
    SOBJ tmp;
    char    ch;
    int extended2 = 0,  /* modify for SUN4. Myama. */
    extended_back,
    len = 0,
    r = 0,
    sign, j, digit, number2;

    sign = big_sign(number);
    number2 = copy_big(number);    /* by T.Komiya */
    if (sign < 0)
        extended2 = extended_back = complement_big2(number2, extended2);
    while (!big_zerop(number2) || extended2 != 0) { 
        div_int_big2(number2, radix, &extended2, &r);
        if (r < 10)
            s_push(mk_ch('\0', (char)(r + '0')));
        else
            s_push(mk_ch('\0', (char)(r - 10 + 'A')));
        len++;
    }
    for (j = 0 ; j < len ; j++) { 
        tmp.obj = getsvt(j);
        ch = (char)(CH(tmp.ch));
        if ('0' <= ch && ch <= '9')
            digit = (int)(ch - '0');
        else
            digit = (int)(ch - 'A' + 10);
        mul_int_big2(number2, radix);
        add_int_big2(number2, digit);
    }
    if (sign < 0) { 
        s_push(mk_ch('\0', '-'));
        complement_big2(number2, extended_back);
    }
}


push_flt(number, radix)
int number, radix;
{
    char digit_buf[30];
    double  val;
    int len, sign = 1;

    double  flt_to_double();

    val = flt_to_double(number);
    if (val < 0) { 
        sign = -1;
        val = -val;
    }
    switch (radix) { 
    case BINARY  :
        break;
    case OCTAL   :
        break;
    case DECIMAL :
    	sprintf(digit_buf, "%.14g", val);    /* by T.Komiya */
        break;
    case HEX     :
        break;
    default :
        bokkan("INTERNAL ERROR(push_flt()).");
    }
    len = strlen(digit_buf);
    len--;
    for (; len >= 0; len--)
        s_push(mk_ch('\0', digit_buf[len]));
    if (sign < 0)
        s_push(mk_ch('\0', '-'));    
}


int double_to_rational(val)  /* by T.Komiya */
    double val;
{ 
    SOBJ obj, tmp;
    int i, e;
    FLT_TMP d;

    d.d = val;
    if (d.d == 0.0)
    	return(SCOBJ_0);
    s_push(mk_bign(0x200000 | (FLT_MANT_M(d) << 1) | (FLT_MANT_H(d) << 5)
                   | ((FLT_MANT_L(d) & ~INT_MASK) ? 1 : 0)));
    obj.obj = mk_bign(FLT_MANT_L(d) & INT_MASK);
    ((ENTITYP)ADDRESS(obj.obj))->bnum.next.obj = s_pop();
    s_push(obj.obj);
    if ((e = FLT_EXP(d) - 1023) > 0) {
    	s_push(mk_bign(1 << (e % 31)));
    	for (i = e; i >= 31; i -= 31) {
            tmp.obj = mk_bign(0);
            ((ENTITYP)ADDRESS(tmp.obj))->bnum.next.obj = s_pop();
            s_push(tmp.obj);
    	}
    	tmp.obj = s_pop();
        obj.obj = mul_obj(s_pop(), tmp.obj);
        s_push(obj.obj);
        s_push(mk_bign(0x200000));
        tmp.obj = mk_bign(0);
        ((ENTITYP)ADDRESS(tmp.obj))->bnum.next.obj = s_pop();
    } else if (e < 0) {
    	s_push(mk_bign(1 << (-e % 31)));
    	for (i = -e; i >= 31; i -= 31) {
            tmp.obj = mk_bign(0);
            ((ENTITYP)ADDRESS(tmp.obj))->bnum.next.obj = s_pop();
            s_push(tmp.obj);
    	}
        s_push(mk_bign(0x200000));
        tmp.obj = mk_bign(0);
    	((ENTITYP)ADDRESS(tmp.obj))->bnum.next.obj = s_pop();
        tmp.obj = mul_obj(tmp.obj, s_pop());
    } else {
        s_push(mk_bign(0x200000));
        tmp.obj = mk_bign(0);
        ((ENTITYP)ADDRESS(tmp.obj))->bnum.next.obj = s_pop();
    }
    obj.obj = s_pop();
    if (FLT_SIGN(d))
        return(complement_big(mk_simple_rational(obj.obj, tmp.obj)));
    else
        return(mk_simple_rational(obj.obj, tmp.obj));
}
