/*
 * other.c - 
 */

/*
 * $Id: other.c,v 1.8 2014/10/28 02:22:55 komiya Exp $
 */

static char *RCSid="$Id: other.c,v 1.8 2014/10/28 02:22:55 komiya Exp $";

#include <signal.h>
#include "scheme.h"

#ifdef TK
#include <errno.h>
#include <tcl.h>
#include <tk.h>
#endif

#ifndef THINK_C
#include <sys/types.h>
#include <sys/wait.h>
#endif

#include <string.h>
#include <ctype.h>

#include <time.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <sys/resource.h>
#include <sys/param.h>

#ifdef SUNSOL2
#include <alloca.h>
#endif

#ifdef LUNA
#include <sys/times.h>
#endif

#ifdef HP
#include <sys/times.h>
#endif

#ifdef HAVE_LIBREADLINE
#include <readline/readline.h>
#include <readline/history.h>
#endif

#ifdef unix
#include <pwd.h>
#endif

FILE *debug_stream;
extern int  bcitraceflag;

char *strobj_to_str(int);

#ifdef TK
extern Tcl_Interp *interp;
#define BUFFER_SIZE 512
char buffer[BUFFER_SIZE];
int bufidx, count, filled, ungetted, previous_char, Tk_initialized;
#endif

void Smacrofun()
{ 
    int arg;
    unsigned function;

#ifdef TOUCH_ARG
    arg = touch_obj(getarg(1));
#else
    arg = getarg(1);
#endif
    if (GETsym_tag(arg) != LTAG_SYMBOL){
        err_illegal_argument_type(arg, "symbol");
	return;
    }
    function = *(((unsigned *)ADDRESS(arg)) + 1);

/*  by T.Komiya
    switch (GETtag(function)) {
    case LTAG_MBCLOSURE :
        set_reg(LTAG_BCLOSURE | (unsigned)ADDRESS(function));
	break; 
    case LTAG_MSFUNCTION :
        set_reg(LTAG_SFUNCTION | (unsigned)ADDRESS(function));
	break;
    default :
        set_reg(LTAG_FALSE);
    }
*/
    if (GETmacro_tag(function) == LTAG_MACRO)
        set_reg(function);
    else
        set_reg(LTAG_FALSE);
}


#ifdef HP

void Sgettime()
{
    struct tms buffer;
    unsigned obj;
    int s, us;

    times(&buffer);
    s = (int)(buffer.tms_stime / CLK_TCK);
    us = (int)(((double)buffer.tms_stime / (double)CLK_TCK - (double)s) * 1000000.0);
    obj= mkcons(mk_fix(s), mk_fix(us));
    s_push(obj);
    s = (int)(buffer.tms_utime / CLK_TCK);
    us = (int)(((double)buffer.tms_utime / (double)CLK_TCK - (double)s) * 1000000.0);
    obj = mkcons(mk_fix(s), mk_fix(us));
    s_push(obj);
    obj = mkcons(LTAG_NIL, LTAG_NIL);
    *((unsigned *)ADDRESS(obj)) = s_pop();
    *(((unsigned *)ADDRESS(obj)) + 1) = s_pop();
    set_reg(obj);
}

#elif THINK_C

void Sgettime()
{
    unsigned obj;

    obj = mkcons(SCOBJ_0, SCOBJ_0);
    s_push(obj);
    obj = mkcons(SCOBJ_0, SCOBJ_0);
    s_push(obj);
    obj = mkcons(LTAG_NIL, LTAG_NIL);
    *((unsigned *)ADDRESS(obj)) = s_pop();
    *(((unsigned *)ADDRESS(obj)) + 1) = s_pop();
    set_reg(obj);
}

#else

void Sgettime()
{    
    struct rusage rusage;
    unsigned obj;
     
    getrusage(RUSAGE_SELF, &rusage);
    obj= mkcons(mk_fix((int)rusage.ru_stime.tv_sec),
                mk_fix((int)rusage.ru_stime.tv_usec));
    s_push(obj);
    obj = mkcons(mk_fix((int)rusage.ru_utime.tv_sec),
                 mk_fix((int)rusage.ru_utime.tv_usec));
    s_push(obj);
    obj = mkcons(LTAG_NIL, LTAG_NIL);
    *((unsigned *)ADDRESS(obj)) = s_pop();
    *(((unsigned *)ADDRESS(obj)) + 1) = s_pop();
    set_reg(obj);
}

#endif


void Sget_time()
{
#ifndef THINK_C
    struct timeb t;
#endif
    struct tm *st;
    time_t tt;
    SOBJP result;

#ifdef THINK_C
    tt = time((time_t * )0);
#else
    ftime(&t);
#endif

#ifdef THINK_C
    st = localtime(&tt);
#else
    st = localtime(&(t.time));
#endif
    result = (SOBJP)mk_evecp(4);
    (result + 1)->obj = mk_fix((int)st->tm_hour);
    (result + 2)->obj = mk_fix((int)st->tm_min);
    (result + 3)->obj = mk_fix((int)st->tm_sec);
#ifdef THINK_C
    (result + 4)->obj = SCOBJ_0;
#else
    (result + 4)->obj = mk_fix((int)(t.millitm / 10));
#endif
    set_reg(LTAG_VECTOR | SSERDDA(result));
}


void Sget_date()
{
    struct tm *st;
    time_t tt;
    SOBJP result;

    tt = time((time_t * )0);
    st = localtime(&tt);
    result = (SOBJP)mk_evecp(4);
    (result + 1)->obj = ((1900 + st->tm_year) << 2) | LTAG_FIXNUM;
    (result + 2)->obj = ((1 + st->tm_mon) << 2) | LTAG_FIXNUM;
    (result + 3)->obj = (st->tm_mday << 2) | LTAG_FIXNUM;
    (result + 4)->obj = (st->tm_wday << 2) | LTAG_FIXNUM;
    set_reg(LTAG_VECTOR | SSERDDA(result));
}


void Sgetenv()
{
    SOBJ arg, str;
    char    *s, *t, *getenv();
    int length;

#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(1));
#else
    arg.obj = getarg(1);
#endif
    if (GETstr_tag(arg.obj) != LTAG_STRING){
        err_illegal_argument_type (arg.obj, "string");
	return;
    }
    if ((s = getenv(strobj_to_str(arg.obj))) != (char *)NULL)
        length = strlen(s);
    else
        length = 0;
    str.obj = mk_estr(ORDINARY_STRING, A_STRING, length);
    t = (char *)(ADDRESS(str.obj) + 12);
    for ( ; length > 0; length--)
        *t++ = *s++;
    *t = '\0';
    set_reg(str.obj);
}

#if (defined(THINK_C) || defined(LUNA))
int putenv(str)
char *str;
{
    return((int)NULL);
}
#endif

void Ssetenv()
{
    SOBJ arg;

#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(1));
#else
    arg.obj = getarg(1);
#endif
    if (GETstr_tag(arg.obj) != LTAG_STRING){
        err_illegal_argument_type (arg.obj, "string");
	return ;
    }
    if (putenv(strobj_to_str(arg.obj)))
        set_reg(LTAG_FALSE);
    else
        set_reg(LTAG_T);
}

#ifdef TK
void Sexectcl()
{
    SOBJ arg;
    char *s;

#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(1));
#else
    arg.obj = getarg(1);
#endif
    if (GETstr_tag(arg.obj) != LTAG_STRING){
        err_illegal_argument_type (arg.obj, "string");
	return;
    }

    s = strdup(strobj_to_str(arg.obj));
    Tcl_Eval(interp, s);
    free(s);                    /* ***** */

    arg.obj = mk_str(ORDINARY_STRING, A_STRING,
                     strlen(interp->result), interp->result);

    set_reg(arg.obj);
}

#ifndef __CYGWIN32__

void Sdelete_filehandler()
{
    SOBJ arg;
    int fd;

#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(1));
#else
    arg.obj = getarg(1);
#endif
    if (GETtag(arg.obj) != LTAG_PORT)
        err_illegal_argument_type (arg.obj, "port");

    fd = fileno(((PORT *)ADDRESS(arg.obj))->fp);
    Tcl_DeleteFileHandler(fd);
    set_reg(LTAG_T);
}

struct file_fun_arg {
    int fd;
    char *fname;
};

void Screate_filehandler()
{
    SOBJ port, readablep, fname;
    int fd;
    int mask;
    struct file_fun_arg *f;
    int apply_file_fun();

#ifdef TOUCH_ARG
    port.obj = touch_obj(getarg(1));
#else
    port.obj = getarg(1);
#endif
    if (GETtag(port.obj) != LTAG_PORT)
        err_illegal_argument_type(port.obj, "port");
#ifdef TOUCH_ARG
    readablep.obj = touch_obj(getarg(2));
#else
    readablep.obj = getarg(2);
#endif
#ifdef TOUCH_ARG
    fname.obj = touch_obj(getarg(3));
#else
    fname.obj = getarg(3);
#endif
    if (GETsym_tag(fname.obj) != LTAG_SYMBOL)
        err_illegal_argument_type(fname.obj, "symbol");

    s_push(port.obj);
    s_push(fname.obj);
    s_push(readablep.obj);

    f = (struct file_fun_arg *)malloc(sizeof(struct file_fun_arg));

    readablep.obj = s_pop();
    fname.obj = s_pop();
    port.obj = s_pop();

    f->fd = fileno(((PORT *)ADDRESS(port.obj))->fp);
    f->fname = strdup(strobj_to_str((((ENTITYP)ADDRESS(fname.obj))->sym.sym_name.obj)));
    mask = ((readablep.obj == LTAG_FALSE) ? TCL_WRITABLE : TCL_READABLE);
    Tcl_CreateFileHandler(f->fd, mask, (Tcl_FileProc *)apply_file_fun,
                          (ClientData)f);
    set_reg(port.obj);
}

#endif

void StdinProc(a, b)
ClientData a;
int b;
{
    extern int errno;

    for (;;) {
        count = read(fileno(stdin), buffer, BUFFER_SIZE);
	if (count != -1 || errno != EINTR) break;
    }
    filled =1;
}

int Getc(f)
FILE *f;
{
    if (f == stdin) {
        if (ungetted) {
	    ungetted = 0;
	    return previous_char;
	}
	if (bufidx < count)
	    return buffer[bufidx++];
	else {
	    if (Tk_initialized) {
	        filled = 0;
		while (!filled) {
/*
		    Tcl_DoOneEvent(TCL_FILE_EVENTS);
*/
                    StdinProc(NULL, 0);
		    if (Tk_GetNumMainWindows() <= 0) return EOF;
		}
	    }  else
	        StdinProc((ClientData)NULL, (int)NULL);
	}
	if (count <= 0)
	    return EOF;
	else {
	    bufidx = 1;
	    return *buffer;
	}
    } else
        return getc(f);
}

int Ungetc(c, f)
int c;
FILE *f;
{
    if (f == stdin) {
        ungetted = 1;
	previous_char = c;
    } else
        ungetc(c, f);
    return c;
}

void Stkgetchar()
{
    if (ungetted || bufidx < count)
        set_reg(mk_ch('\0', Getc(stdin)));
    else
        set_reg(LTAG_FALSE);
}

int apply_fun(ClientData clientData, Tcl_Interp *interp, int argc, char **argv)
{
    int set_up_stack();
    unsigned int *p;
    int i;

    if (argc <= 2) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }
    p = base_reg;
    *--p = get_sval(addsymbol(mk_str(ORDINARY_STRING, A_STRING,
                                     strlen(argv[1]), argv[1]),
                              LTAG_ORDINARY));
    for (i = 2; argv[i] != NULL; i++)
        *--p = mk_str(ORDINARY_STRING, A_STRING, strlen(argv[i]), argv[i]);
    sp_reg = p;
    set_up_stack();
    interp->result = "1";
    return TCL_OK;
}

#ifndef __CYGWIN32__

int apply_file_fun(ClientData file)
{
    int set_up_stack();
    unsigned int *p;
    int i;
    struct file_fun_arg *f = (struct file_fun_arg *)file;

    Tcl_CreateFileHandler(f->fd, 0, apply_file_fun, NULL);
    p = base_reg;
    *--p = get_sval(addsymbol(mk_str(ORDINARY_STRING, A_STRING,
                                     strlen(f->fname), f->fname),
                              LTAG_ORDINARY));
    free(f->fname);             /* ***** */
    free(f);                    /* ***** */
    sp_reg = p;
    set_up_stack();
    return TCL_OK;
}

#endif

int do_one_event(ClientData clientData, Tcl_Interp *interp,
                 int argc, char **argv)
{
    if (argc != 1) {
        interp->result = "wrong # args";
        return TCL_ERROR;
    }
    Tcl_DoOneEvent(0);
/*
    Tcl_DoOneEvent(TCL_ALL_EVENTS & ~TCL_FILE_EVENTS);
*/
    interp->result = "1";
    return TCL_OK;
}

#endif                          /* TK */

char    **genargs(a0, s)
char    *a0, *s;
{
    int i, num;
    char    c, *t, **argv;

    t = s;
    while (isspace(*t))
        t++;
    for (num = 0, c = '\0'; *t != '\0'; num++, c = '\0') {
        while (!isspace(*t) && *t != '\0') {
            if (*t == '\"' || *t == '\'') {
                c = *t++;
                while (*t != '\0' && *t != c)
                    t++;
                if (*t == c) 
                    t++;
                break;
            } else
                t++;
        }
        while (isspace(*t))
            t++;
    }
    argv = (char **)malloc(sizeof(char *) * (num + 2));
    argv[0] = a0;
    argv[num+1] = NULL;
    for (i = 0, c = '\0', t = s; i < num; i++, c = '\0') {
        while (isspace(*t))
            t++;
        argv[i+1] = t;
        while (!isspace(*t) && *t != '\0') {
            if (*t == '\"' || *t == '\'') {
                c = *t++;
                argv[i+1] = t;
                while (*t != '\0' && *t != c)
                    t++;
                break;
            } else
                t++;
        }
        *t++ = '\0';
    }
    return(argv);
}

#ifdef unix

void Sgetwd()
{
    char pathname[MAXPATHLEN];
    SOBJ obj;
    int len;
    char *s, *t;

#ifdef HP
    if (getcwd(pathname, MAXPATHLEN)) {
#else
    if (getwd(pathname)) {
#endif
        len = strlen(pathname);
        obj.obj = mk_estr(ORDINARY_STRING, A_STRING, len);
        s = (char *)(ADDRESS(obj.obj) + 12);
        t = pathname;
        for (; len > 0; len--)
            *s++ = *t++;
        *s = '\0';
        set_reg(obj.obj);
    } else
        set_reg(LTAG_FALSE);
}
    
void Schdir()
{
    SOBJ arg;

#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(1));
#else
    arg.obj = getarg(1);
#endif

    if (GETstr_tag(arg.obj) != LTAG_STRING)
        err_illegal_argument_type (arg.obj, "string");
    if (chdir(strobj_to_str(arg.obj)))
        set_reg(LTAG_FALSE);
    else
        set_reg(LTAG_T);
}

void Sgetpwnam()
{
    SOBJ arg;
    int len;
    struct passwd *p;
    char *s, *t;

#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(1));
#else
    arg.obj = getarg(1);
#endif

    if (GETstr_tag(arg.obj) != LTAG_STRING)
        err_illegal_argument_type (arg.obj, "string");
    if (p = getpwnam(strobj_to_str(arg.obj))) {
        len = strlen(p->pw_dir);
        arg.obj = mk_estr(ORDINARY_STRING, A_STRING, len);
        s = (char *)(ADDRESS(arg.obj) + 12);
        t = p->pw_dir;
        for (; len > 0; len--)
            *s++ = *t++;
        *s = '\0';
        set_reg(arg.obj);
    } else
        set_reg(LTAG_FALSE);
}

#endif

#ifndef THINK_C

extern int sigchld_enable;

void Sspawn()
{
    SOBJ path, arg;
    int pid;
#ifdef LUNA
    union wait status;
#else
    int status;
#endif
    char    **argv;
#ifndef WAITPID
    int proc_terminate_handler();
    int id;
#endif

#ifdef TOUCH_ARG
    path.obj = touch_obj(getarg(1));
#else
    path.obj = getarg(1);
#endif
#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(2));
#else
    arg.obj = getarg(2);
#endif
    if (GETstr_tag(path.obj) != LTAG_STRING){
        err_illegal_argument_type (path.obj, "string");
	return;
    }
    if (GETstr_tag(arg.obj) != LTAG_STRING){
        err_illegal_argument_type (arg.obj, "string");
	return;
    }
#ifndef WAITPID
    sigchld_enable = FALSE;
#endif
    if ((pid = fork()) < 0) {
        perror("fork error");
        exit(1);
    }
    if (pid == 0) {
        argv = genargs(strobj_to_str(path.obj), strobj_to_str(arg.obj));
        execvp(argv[0], argv);
        perror(argv[0]);
        _exit(1);
    }
#ifdef WAITPID
    waitpid(pid, &status, 0);
#else
/*
    while ((id = wait(&status)) >= 0 && id != pid)
        ;
*/
{
    struct rusage rus;
    while ((id = wait3(&status, WNOHANG, &rus)) >= 0 && id != pid)
        ;
}
    sigchld_enable = TRUE;
    proc_terminate_handler_aux(0);
#endif
#ifdef LUNA
    set_reg(mk_fix(status.w_retcode));
#else
    set_reg(mk_fix(status >> 8));
#endif
}

/*
 * (_run-process <hostname> <command path> <args> <ipipe?> <opipe?> <epipe?>)
 */
void Srun_process()
{
    SOBJ host, path, arg, ipipep, opipep, epipep;
    SOBJP res;
    int pid, i, pipes[3][2];
    char    **argv;

#ifdef TOUCH_ARG
    host.obj = touch_obj(getarg(1));
    path.obj = touch_obj(getarg(2));
    arg.obj = touch_obj(getarg(3));
    ipipep.obj = touch_obj(getarg(4));
    opipep.obj = touch_obj(getarg(5));
    epipep.obj = touch_obj(getarg(6));
#else
    host.obj = getarg(1);
    path.obj = getarg(2);
    arg.obj = getarg(3);
    ipipep.obj = getarg(4);
    opipep.obj = getarg(5);
    epipep.obj = getarg(6);
#endif

    if (host.obj != LTAG_FALSE && GETstr_tag(host.obj) != LTAG_STRING)
        err_illegal_argument("1st argument must be a string or #f.");
    if (GETstr_tag(path.obj) != LTAG_STRING)
        err_illegal_argument_type (path.obj, "string");
    if (GETstr_tag(arg.obj) != LTAG_STRING)
        err_illegal_argument_type (arg.obj, "string");


    for (i = 0; i < 3; i++)
        pipes[i][0] = pipes[i][1] = -1;

    if (ipipep.obj != LTAG_FALSE)
        if (pipe(pipes[0]) < 0)
            err_error("Cannot create pipe.");
    if (opipep.obj != LTAG_FALSE)
        if (pipe(pipes[1]) < 0)
            err_error("Cannot create pipe.");
    if (epipep.obj != LTAG_FALSE)
        if (pipe(pipes[2]) < 0)
            err_error("Cannot create pipe.");

    if ((pid = fork()) < 0) {
        perror("fork error");
        exit(1);
    }
    if (pid == 0) {             /* child */
        char *com, *av;

        for (i = 0; i < 3; i++)
            if (pipes[i][0] != -1) {
                close(i);
                dup(pipes[i][i == 0 ? 0 : 1]);
                close(pipes[i][0]);
                close(pipes[i][1]);
            }
        for (i = 3; i < NOFILE; i++) close(i);

        com = strobj_to_str(path.obj);
        av = strobj_to_str(arg.obj);
        if (host.obj != LTAG_FALSE) {
            char *h, *hh;

            hh = strobj_to_str(host.obj);            
            h = alloca(strlen(hh) + strlen(com) + strlen(av) + 3);
            strcpy(h, hh);
            strcat(h, " ");
            strcat(h, com);
            strcat(h, " ");
            strcat(h, av);
            av = h;
            com = "rsh";
        }
        argv = genargs(com, av);
        execvp(argv[0], argv);
        perror(argv[0]);
        _exit(1);
    } else {
        for (i = 0; i < 3; i++)
            if (pipes[i][0] != -1) {
                FILE *f;

                close(pipes[i][i == 0 ? 0 : 1]);
                f = (i == 0) ? fdopen(pipes[i][1], "w") : fdopen(pipes[i][0], "r");
                if (f == NULL)
                    err_error("Cannot fdopen().");
                s_push(mkpipe(f, (i == 0) ? OUTPUT : INPUT));
            } else
                s_push(LTAG_FALSE);
        res = (SOBJP)mk_evecp(4);
        (res + 4)->obj = s_pop();
        (res + 3)->obj = s_pop();
        (res + 2)->obj = s_pop();
        (res + 1)->obj = mk_fix(pid);
        set_reg(LTAG_VECTOR | SSERDDA(res));
    }
}

void Ssystem()
{
    SOBJ obj;
    int proc_terminate_handler_aux(), proc_terminate_handler();

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETstr_tag(obj.obj) != LTAG_STRING)
        err_illegal_argument_type (obj.obj, "string");
    sigchld_enable = FALSE;
#ifdef SUNSOL2
    signal(SIGCHLD, SIG_IGN);
#endif
    set_reg(mk_fix(system(strobj_to_str(obj.obj)) >> 8));
    sigchld_enable = TRUE;
    proc_terminate_handler_aux(0);
#ifdef SUNSOL2
{
    struct sigaction sigact;

    sigemptyset(&(sigact.sa_mask));
    sigact.sa_handler = proc_terminate_handler;
    sigact.sa_flags = SA_NOCLDSTOP | SA_RESTART;
    sigaction(SIGCHLD, &sigact, NULL);
}
#endif
}

#else

void Ssystem()
{
    set_reg(LTAG_FALSE);
}

void Sspawn()
{
    set_reg(LTAG_FALSE);
}

#endif

#ifndef ED_MINE

void Smine()
{
    set_reg(LTAG_FALSE);
}

#endif /* ED_MINE */

void Sbye()
{
    print_con("Bye.\n");
    exit(0);
}

void Sexit_tus()
{
    exit(0);
}


void Sgc2()               /* modified by T.Komiya (10/26) */
{
    int i, quarter_vacancy, vacancy_size;
    unsigned *compaction();

    if (gctype == COPY_GC)
        copygc(0);
    else {
        vacancy_size = mark_and_sweep_gc();
        last_entity = compaction(vacancy_size, 0);
        quarter_vacancy = vacancy_size / 4;
        *last_entity = LTAG_BLOCK2 | (vacancy_size - 4);
        for (i = 0; i < BLOCK_TABLE_SIZE; i++)
            block_table[i] = 0;
        big_block = 0;
        if (quarter_vacancy <= 1) {
#ifdef X
            draw_free_list();
#endif      
            return;
        } else if (quarter_vacancy < BLOCK_TABLE_SIZE)
            block_table[quarter_vacancy] = last_entity;
        else
            big_block = last_entity;
        *(last_entity + 1) = 0;

        /*    stackdump2(100);  */
    }
#ifdef X
    cell_mon(-((unsigned)last_entity - (unsigned)entity_start), 1);
    draw_free_list();
#endif  
    set_reg(LTAG_T);
}


void Satomp()
{
#ifdef TOUCH_ARG
    switch (GETtag(touch_obj(getarg(1)))) {
#else
    switch (GETtag(getarg(1))) {
#endif
    case LTAG_CONS :
    case LTAG_WEAKPAIR :
        reg_reg = LTAG_FALSE;
        break;
    default :
        reg_reg = LTAG_T;
    }
}


void Stranscript_on()
{
    SOBJ strobj;
    FILE * stream;

    if (transcript_flag == TRANSCRIPT_ON)
        bokkan("already transcript on.");
#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else{
            err_illegal_argument_type (strobj.obj, "string or symbol");
	    return;
	}
    }
    if ((stream = fopen(strobj_to_str(strobj.obj), "a")) == NULL){
        err_file_error("Can not open transcript file.", strobj.obj);
	return ;
    }
    transcript_fp = stream;
    transcript_flag = TRANSCRIPT_ON;
    reg_reg = LTAG_T;
}


void Stranscript_off()
{
    if (transcript_flag == TRANSCRIPT_OFF)
        reg_reg = LTAG_FALSE;
    else {
        transcript_flag = TRANSCRIPT_OFF;
        fclose(transcript_fp);
        reg_reg = LTAG_T;
    }
}


void Sfunc_def()                     /* dekisokonai */
{
    ENTITYP proc_entity;
    SOBJ proc;
    CARCDR * top;

#ifdef TOUCH_ARG
    proc.obj = touch_obj(getarg(1));
#else
    proc.obj = getarg(1);
#endif
    if ( !FUNp(proc.obj) ) {
        err_illegal_argument_type(proc.obj, "procedure");
	return ;
    }
    if (GETtag(proc.obj) == LTAG_CONTINUATION) {
        err_illegal_argument_type(proc.obj, "procedure");
	return;
    }

    proc_entity = (ENTITYP)ADDRESS(proc.obj);
    switch (GETtag(proc.obj)) {
    case LTAG_BCLOSURE :
    case LTAG_MBCLOSURE :
    case LTAG_SFUNCTION :
    case LTAG_MSFUNCTION :
    case LTAG_NCLOSURE :
    case LTAG_MNCLOSURE :
        s_push(proc.obj);
        top = (CARCDR * )mk_nconsp(5);
        proc.obj = s_pop();
        top->car.obj = proc_entity->bcc.const_vec.obj;
        (top + 1)->car.obj = proc_entity->bcc.fun_name.obj;
        (top + 2)->car.obj = proc_entity->bcc.source.obj;
        (top + 3)->car.obj = proc_entity->bcc.env.obj;
        (top + 4)->car.obj = proc_entity->bcc.body.obj;
        set_reg(SSERDDA(top) | LTAG_CONS);
        break;
    default :
        bokkan("system error : in Sfunc_def.");
    }
}


void Sfunc_arg()   /*  By N.Watanabe  Nov. 05, 1992  */
/*  Function : To return a number of arguments the function required.  */ 
{
    ENTITYP proc_entity;
    SOBJ proc;
    int argc;

#ifdef TOUCH_ARG
    proc.obj = touch_obj(getarg(1));
#else
    proc.obj = getarg(1);
#endif
    if ( !FUNp(proc.obj) ) {
        err_illegal_argument_type(proc.obj, "procedure");
        return ;
    }
    if (GETtag(proc.obj) == LTAG_CONTINUATION) {
        err_illegal_argument_type(proc.obj, "procedure");
        return ;
    }

    proc_entity = (ENTITYP)ADDRESS(proc.obj);
    switch (GETtag(proc.obj)) {
    case LTAG_BCLOSURE :
    case LTAG_MBCLOSURE :
    case LTAG_SFUNCTION :
    case LTAG_MSFUNCTION :
        argc = proc_entity->bcc.arg_info ;
        set_reg(mk_fix(argc));
        break;
    default :
        err_system_error("In Sfunc_arg.");
        return ;
    }
}

#ifdef GC_TIME

long gc_time_sec = 0;
long gc_time_usec = 0;

void Sgc_usage()
{
    set_reg(mk_fix((int)(gc_time_sec * 1000 + gc_time_usec / 1000)));
}

#endif

#ifdef HAVE_LIBREADLINE

void Sreadline()
{
    SOBJ arg, obj;
    char *strobj_to_str(), *readline();
    char *line, *s, *t;
    int len;

#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(1));
#else
    arg.obj = getarg(1);
#endif
    if (GETstr_tag(arg.obj) != LTAG_STRING){
        err_illegal_argument_type (arg.obj, "string");
	return;
    }
    if ((line = readline(strobj_to_str(arg.obj))) == NULL)
        set_reg(eof_obj.obj);
    else {
        len = strlen(line);
        obj.obj = mk_estr(ORDINARY_STRING, A_STRING, len);
        s = (char *)(ADDRESS(obj.obj) + 12);
        t = line;
        for (; len > 0; len--)
            *s++ = *t++;
        *s = '\0';
#ifndef __APPLE__               /* OS X's readline does not call our malloc */
        free(line);
#endif
        set_reg(obj.obj);
    }
}

void Saddhistory()
{
    SOBJ arg;

#ifdef TOUCH_ARG
    arg.obj = touch_obj(getarg(1));
#else
    arg.obj = getarg(1);
#endif
    if (GETstr_tag(arg.obj) != LTAG_STRING){
        err_illegal_argument_type (arg.obj, "string");
	return;
    }
    add_history(strobj_to_str(arg.obj));
    set_reg(arg.obj);
}

#endif
