/*
 * string.c - 
 */

/*
 * $Id: string.c,v 1.3 2014/10/28 02:22:55 komiya Exp $
 *
 *  ------
 *  STRING
 *  ------
 *  File Name : string.c
 *  written by Mikio Yamamoto  1990.8
 *  fair-copied by Yass.
 *
 */

static char *RCSid="$Id: string.c,v 1.3 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

#ifdef THINK_C
#include <string.h>
#else
#include <strings.h>
#endif

/*
 *   ---------
 *   PRIMITIVE
 *   ---------
 *
 */
#define NOT_CI 0
#define CI     1
#define BYTE_MASK 0xff

/*
#define STR_EQUAL
#define STR_PRECEDING
#define STR_FOLLOWING
     in scheme.h
*/

char    *strobj_to_str(strobj)
int strobj;
{
    char *sstr, *cstr, *cstrp;

    if (GETstr_tag(strobj) == LTAG_STRING) {
        if (GETtag(((STRING * )ADDRESS(strobj))->head) == LTAG_BLOCK1)
            strobj = ((STRING * )ADDRESS(strobj))->str_len;
	sstr = (char *)(ADDRESS(strobj) + 12);
        if (((STRING * )ADDRESS(strobj))->str_kind == K_STRING) {
	    if ((cstrp = cstr = (char *)malloc(((STRING * )ADDRESS(strobj))->str_len * 2)) == NULL)
		bokkan("INTERNAL ERROR.");
	    for (sstr++; *sstr != '\0'; sstr += 2) {
		if (*sstr & 0x80) {
		    *cstr++ = *(sstr - 1);
		    *cstr++ = *sstr;
		} else 
		    *cstr++ = *sstr;
	    }
	    *cstr = '\0';
	    return (cstrp);
        } else
            return((char *)(ADDRESS(strobj) + 12));
    } else
        bokkan("INTERNAL ERROR.");
}


/*
cp_ascii_to_kanji(str_body)
  char *str_body;
{ short *str_body2;
  int   length, i;

  length = *(((int *)str_body) + 1);
  reg1 = LTAG_STRING | (int)str_body;
  str_body2 = (short *)Pgetblock2(8 + (length * 2));
  str_body = (char *)ADDRESS(reg1);
  reg1 = LTAG_NIL;
  *(((unsigned *)str_body2) + 1) = *(((unsigned *)str_body) + 1);
  *(((unsigned *)str_body2) + 1) = K_STRING;
  str_body = str_body + 12;
  str_body2 = str_body2 + 6;
  for(i = 0; i < length; i++)
    *(str_body2 + i) = ((short)(*(str_body + i))) & BYTE_MASK;
  return(str_body2);
}
*/

int str_compare(strobj11, strobj22, ci_flag)
int strobj11, strobj22;
int ci_flag;
{
    char    *strp1, *strp2;
    int kind1, kind2, length1, length2, short_length,
    result;
    SOBJ strobj1, strobj2;
    strobj1.obj = strobj11;
    strobj2.obj = strobj22;

    if (GETtag(((STRING * )ADDRESS(strobj1.obj))->head) == LTAG_BLOCK1)
        strobj1.obj = ((STRING * )ADDRESS(strobj1.obj))->str_len;
    if (GETtag(((STRING * )ADDRESS(strobj2.obj))->head) == LTAG_BLOCK1)
        strobj2.obj = ((STRING * )ADDRESS(strobj2.obj))->str_len;

    length1 = ((STRING * )ADDRESS(strobj1.obj))->str_len;
    length2 = ((STRING * )ADDRESS(strobj2.obj))->str_len;
    kind1 = ((STRING * )ADDRESS(strobj1.obj))->str_kind;
    kind2 = ((STRING * )ADDRESS(strobj2.obj))->str_kind;
    short_length = (length1 > length2 ? length2 : length1);
    strp1 = (char *)(ADDRESS(strobj1.obj) + 12);
    strp2 = (char *)(ADDRESS(strobj2.obj) + 12);

    if (kind1 == A_STRING) {
        if (kind2 == A_STRING)  /* ascii vs ascii */
            result = str_compare_aa(strp1, strp2, short_length,
                ci_flag);
        else /* ascii vs kanji */
            result = str_compare_ak(strp1, strp2, short_length,
                ci_flag);
    } else {
        if (kind2 == A_STRING)  /* kanji vs ascii */
            result = str_compare_ka(strp1, strp2, short_length,
                ci_flag);
        else /* kanji vs kanji */
            result = str_compare_kk(strp1, strp2, short_length,
                ci_flag);
    }
    if (result == STR_EQUAL) {
        if (length1 == length2)
            return(STR_EQUAL);
        else if (length1 > length2)
            return(STR_FOLLOWING);
        else
            return(STR_PRECEDING);
    } else
        return(result);
}


int str_compare_aa(strp1, strp2, length, ci_flag)
char    *strp1, *strp2;
int length, ci_flag;
{
    unsigned char    ch1, ch2;

    if (ci_flag == NOT_CI) {
        for (; 0 < length ; length--) {
            ch1 = *(strp1++);
            ch2 = *(strp2++);
            if (ch1 < ch2)
                return(STR_PRECEDING);
            else if (ch1 > ch2)
                return(STR_FOLLOWING);
        }
        return(STR_EQUAL);
    } else {
        for (; 0 < length ; length--) {
            ch1 = *(strp1++);
            if ('A' <= ch1 && 'Z' >= ch1)
                ch1 -= ('A' - 'a');
            ch2 = *(strp2++);
            if ('A' <= ch2 && 'Z' >= ch2)
                ch2 -= ('A' - 'a');
            if (ch1 < ch2)
                return(STR_PRECEDING);
            else if (ch1 > ch2)
                return(STR_FOLLOWING);
        }
        return(STR_EQUAL);
    }
}


int str_compare_ak(strp1, strp2, length, ci_flag)
char    *strp1, *strp2;
int length, ci_flag;
{
    unsigned char    ch1, ch2;

    if (ci_flag == NOT_CI) {
        for (; 0 < length ; length--) {
            ch1 = *(strp1++);
            ch2 = *(strp2++);
            if (KANJI_p(ch2))
                return(STR_PRECEDING);
            else
             {
                ch2 = *(strp2++);
                if (ch1 < ch2)
                    return(STR_PRECEDING);
                else if (ch1 > ch2)
                    return(STR_FOLLOWING);
            }
        }
        return(STR_EQUAL);
    } else
     {
        for (; 0 < length ; length--) {
            ch1 = *(strp1++);
            ch2 = *(strp2++);
            if (KANJI_p(ch2))
                return(STR_PRECEDING);
            else
             {
                ch2 = *(strp2++);
                if ('A' <= ch1 && 'Z' >= ch1)
                    ch1 -= ('A' - 'a');
                if ('A' <= ch2 && 'Z' >= ch2)
                    ch2 -= ('A' - 'a');
                if (ch1 < ch2)
                    return(STR_PRECEDING);
                else if (ch1 > ch2)
                    return(STR_FOLLOWING);
            }
        }
        return(STR_EQUAL);
    }
}


int str_compare_ka(strp1, strp2, length, ci_flag)
char    *strp1, *strp2;
int length, ci_flag;
{
    int result;

    result = str_compare_ak(strp2, strp1, length, ci_flag);
    if (result == STR_FOLLOWING)
        return(STR_PRECEDING);
    else if (result == STR_PRECEDING)
        return(STR_FOLLOWING);
    else
        return(result);
}


int str_compare_kk(strp1, strp2, length, ci_flag)
char    *strp1, *strp2;
int length, ci_flag;
{
    unsigned char    ch1, ch2;
    int kanji1, kanji2;

    if (ci_flag == NOT_CI) {
        for (; 0 < length ; length--) {
            if (KANJI_p(*strp1)) {
                if (KANJI_p(*strp2)) {
                    kanji1 = (int)*((short *)strp1) & 
                        0x0000ffff;
                    kanji2 = (int)*((short *)strp2) & 
                        0x0000ffff;
                    if (kanji1 < kanji2)
                        return(STR_PRECEDING);
                    else if (kanji1 > kanji2)
                        return(STR_FOLLOWING);
                } else
                    return(STR_FOLLOWING);
            } else
             {
                if (KANJI_p(*strp2))
                    return(STR_PRECEDING);
                else     {
                    ch1 = *(strp1 + 1);
                    ch2 = *(strp2 + 1);
                    if (ch1 < ch2)
                        return(STR_PRECEDING);
                    else if (ch1 > ch2)
                        return(STR_FOLLOWING);
                }
            }
            strp1 += 2;
            strp2 += 2;
        }
        return(STR_EQUAL);
    } else {
        for (; 0 < length ; length--) {
            if (KANJI_p(*strp1)) {
                if (KANJI_p(*strp2)) {
                    kanji1 = (int)*((short *)strp1) & 
                        0x0000ffff;
                    kanji2 = (int)*((short *)strp2) & 
                        0x0000ffff;
                    if (kanji1 < kanji2)
                        return(STR_PRECEDING);
                    else if (kanji1 > kanji2)
                        return(STR_FOLLOWING);
                } else
                    return(STR_FOLLOWING);
            } else
             {
                if (KANJI_p(*strp2))
                    return(STR_PRECEDING);
                else     {
                    ch1 = *(strp1 + 1);
                    if ('A' <= ch1 && 'Z' >= ch1)
                        ch1 -= ('A' - 'a');
                    ch2 = *(strp2 + 1);
                    if ('A' <= ch2 && 'Z' >= ch2)
                        ch2 -= ('A' - 'a');
                    if (ch1 < ch2)
                        return(STR_PRECEDING);
                    else if (ch1 > ch2)
                        return(STR_FOLLOWING);
                }
            }
            strp1 += 2;
            strp2 += 2;
        }
        return(STR_EQUAL);
    }
}



/* 
 *  SCHEME FUNCTION
 *
 */

void Sstrp()
{
#ifdef TOUCH_ARG
    if (GETstr_tag(touch_obj(getarg(1))) == LTAG_STRING)
#else
    if (GETstr_tag(getarg(1)) == LTAG_STRING)
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Smakestring()
{
    SOBJ len, fill, str;
    int args, length,
    type = A_STRING;
/*    char    fill1 = '\0', */
    char    fill1 = ' ',
/*    fill2 = '\0', */
    fill2 = ' ',
    *strp;

    args = getargnum();
    if (args > 2){
        err_illegal_argument("Too many arguments.");
        return;
    }
#ifdef TOUCH_ARG
    len.obj = touch_obj(getarg(1));
#else
    len.obj = getarg(1);
#endif
    if (args == 2) {
#ifdef TOUCH_ARG
        fill.obj = touch_obj(getarg(2));
#else
        fill.obj = getarg(2);
#endif
        if (GETtag(fill.obj) == LTAG_ACHAR)
            fill1 = (char)(CH(fill.ch));
        else if (GETtag(fill.obj) == LTAG_KCHAR) {
            fill1 = (char)((KCH(fill.kch) >> 8) & CH_MASK);
            fill2 = (char)(KCH(fill.kch) & CH_MASK);
            type = K_STRING;
        } else {
            err_illegal_argument("2nd argument must be a character.");
	    return ;
	}
    }
    if (GETnum_tag(len.obj) == LTAG_NUMBER1) {
        length = fix_to_int(len.obj);
        if (length > STRLEN_MAX || length < 0) {
            err_illegal_argument("1st argument must be a non-negative number less than 33554428.");
	    return ;
	}
        str.obj = mk_estr(ORDINARY_STRING, type, length);
        strp = (char *)(ADDRESS(str.obj) + 12);
        if (type == A_STRING) {
            for (; length > 0 ; length--)
                *(strp++) = fill1;
        } else
         {
            for (; length > 0 ; length--) {
                *(strp++) = fill1;
                *(strp++) = fill2;
            }
            *(strp++) = '\0';
        }
        *strp = '\0';
        set_reg(str.obj);
    } else {
        err_illegal_argument("1st argument must be a non-negative fixnum.");
	return ;
    }
    
}


void Sstring()  /* this program use SOBJ */
{
    SOBJ  ch, str;
    int args, i,
    type = A_STRING;
    char    *strp;

    args = getargnum();
    for (i = 1 ; i <= args ; i++) {
#ifdef TOUCH_ARG
        ch.obj = touch_obj(getarg(i));
#else
        ch.obj = getarg(i);
#endif
        if (GETtag(ch.obj) != LTAG_ACHAR) {
            if (GETtag(ch.obj) == LTAG_KCHAR)
                type = K_STRING;
            else {
                err_illegal_argument("Arguments must be characters.");
		return ;
	    }
        }
    }
    str.obj = mk_estr(ORDINARY_STRING, type, args);
    strp = ((char *)ADDRESS(str.obj)) + 12;
    if (type == A_STRING) {
        for (i = 1 ; i <= args ; i++) {
            ch.obj = getarg(i);
            *(strp++) = (char)(CH(ch.ch));
        }
    } else
     {
        for (i = 1 ; i <= args ; i++) {
            ch.obj = getarg(i);
            if (GETtag(ch.obj) == LTAG_ACHAR) {
                *(strp++) = '\0';
                *(strp++) = (char)(CH(ch.ch));
            } else
             {
                *(strp++) = (char)((KCH(ch.kch) >> 8) & CH_MASK);
                *(strp++) = (char)(KCH(ch.kch) & CH_MASK);
            }
        }
        *(strp++) = '\0';
    }
    *(strp) = '\0';
    set_reg(str.obj);
}


void Sstringlength()
{
    SOBJ strobj;

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING){
        err_illegal_argument("Argument must be a string.");
	return ;
    }
    if (GETtag(((STRING * )ADDRESS(strobj.obj))->head) == LTAG_BLOCK1)
        strobj.obj = ((STRING * )ADDRESS(strobj.obj))->str_len;
    set_reg(mk_fix(((STRING * )ADDRESS(strobj.obj))->str_len));
}


void Sstringref()
{
    SOBJ strobj, indexobj;
    int index, strlen;
    char    ch1, ch2;

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING){
        err_illegal_argument("Argument must be a string.");
	return ;
    }
#ifdef TOUCH_ARG
    indexobj.obj = touch_obj(getarg(2));
#else
    indexobj.obj = getarg(2);
#endif
    if (GETnum_tag(indexobj.obj) != LTAG_NUMBER1){
        err_illegal_argument("2nd argument must be a non-negative fixnum.");
	return ;
    }
    index = fix_to_int(indexobj.obj);
    if (GETtag(((STRING * )ADDRESS(strobj.obj))->head) == LTAG_BLOCK1)
        strobj.obj = ((STRING * )ADDRESS(strobj.obj))->str_len;
    strlen = ((STRING * )ADDRESS(strobj.obj))->str_len;
    if (index < 0 || strlen <= index){
        err_illegal_argument("2nd argument is invalid.");
	return ;
    }
    if (((STRING * )ADDRESS(strobj.obj))->str_kind == A_STRING) {
        ch1 = (char)*((char *)(ADDRESS(strobj.obj) + 12 + index));
        set_reg(mk_ch('\0', ch1));
    } else
     {
        ch1 = (char)*((char *)(ADDRESS(strobj.obj) + 12 + (index * 
            2)));
        ch2 = (char)*((char *)(ADDRESS(strobj.obj) + 12 + (index * 
            2 + 1)));
        set_reg(mk_ch(ch1, ch2));
    }
}


void Sstring_set()
{
    SOBJ strobj, indexobj, chobj, newstr;
    int index, strlen, tag;

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING){
        err_illegal_argument("1st argument must be a string.");
	return ;
    }
    if (strobj.obj & SS_BIT) {
        err_illegal_argument("Symbol string can not be modified.");
	return ;
    }
#ifdef TOUCH_ARG
    indexobj.obj = touch_obj(getarg(2));
#else
    indexobj.obj = getarg(2);
#endif
    if (GETnum_tag(indexobj.obj) != LTAG_NUMBER1){
        err_illegal_argument("2nd argument must be a non-negative fixnum.");
	return ;
    }
    index = fix_to_int(indexobj.obj);
    if (GETtag(((STRING * )ADDRESS(strobj.obj))->head) == LTAG_BLOCK1)
        strobj.obj = ((STRING * )ADDRESS(strobj.obj))->str_len;
    strlen = ((STRING * )ADDRESS(strobj.obj))->str_len;
    if (index < 0 || strlen <= index){
        err_illegal_argument("2nd argument is invalid.");
	return ;
    }
#ifdef TOUCH_ARG
    chobj.obj = touch_obj(getarg(3));
#else
    chobj.obj = getarg(3);
#endif
    tag = GETtag(chobj.obj);
    if (tag != LTAG_ACHAR && tag != LTAG_KCHAR){
        err_illegal_argument("3rd argument must be a character.");
	return ;
    }
    if (((STRING * )ADDRESS(strobj.obj))->str_kind == A_STRING) {
        if (tag == LTAG_ACHAR)
            *((char *)(ADDRESS(strobj.obj)+ 12+ index)) = (char)(CH(chobj.ch));
        else /* need string extention */    {
            s_push(chobj.obj);
            newstr.obj = mk_str_gcok(ORDINARY_STRING, K_STRING, strlen,
                (char *)(ADDRESS(strobj.obj)), 12);
            chobj.obj = s_pop();
            *((char *)(ADDRESS(newstr.obj) + 12 + (index * 2)))
                = (char)((KCH(chobj.kch) >> 8) & CH_MASK);
            *((char *)(ADDRESS(newstr.obj) + 12 + (index * 2 +  1)))
                = (char)(KCH(chobj.kch) & CH_MASK);
#ifdef TOUCH_ARG
            strobj.obj = touch_obj(getarg(1));
#else
            strobj.obj = getarg(1);
#endif
            ((STRING * )ADDRESS(strobj.obj))->str_kind
                =  (int)(( IMM(((STRING *)ADDRESS(strobj.obj))->head) - 8)
                         | LTAG_BLOCK2);
            ((STRING * )ADDRESS(strobj.obj))->head = LTAG_BLOCK1 | (unsigned)4;
            ((STRING * )ADDRESS(strobj.obj))->str_len  = newstr.obj;
        }
    } else
     {
        if (tag == LTAG_ACHAR) {
            *((char *)(ADDRESS(strobj.obj) + 12 + (index * 2))) = '\0';
            *((char *)(ADDRESS(strobj.obj) + 12 + (index * 2 + 1)))
                = (char)(CH(chobj.ch));
        } else
         {
            *((char *)(ADDRESS(strobj.obj) + 12 + (index * 2)))
                = (char)((KCH(chobj.kch) >> 8) & CH_MASK);
            *((char *)(ADDRESS(strobj.obj) + 12 + (index * 2 + 1)))
                = (char)(KCH(chobj.kch) & CH_MASK);
        }
    }
#ifdef TOUCH_ARG
    set_reg(touch_obj(getarg(1)));
#else
    set_reg(getarg(1));
#endif
}


void Sstringequal()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING) {
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, NOT_CI) == STR_EQUAL)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sstringequalci()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, CI) == STR_EQUAL)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sstringlessthan()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, NOT_CI) == STR_PRECEDING)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sstringlessthanci()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, CI) == STR_PRECEDING)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sstringgreaterthan()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, NOT_CI) == STR_FOLLOWING)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sstringgreaterthanci()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, CI) == STR_FOLLOWING)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sstringlessthanequal()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, NOT_CI) == STR_FOLLOWING)
        set_reg(LTAG_FALSE);
    else
        set_reg(LTAG_T);
}


void Sstringlessthanequalci()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, CI) == STR_FOLLOWING)
        set_reg(LTAG_FALSE);
    else
        set_reg(LTAG_T);
}


void Sstringgreaterthanequal()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, NOT_CI) == STR_PRECEDING)
        set_reg(LTAG_FALSE);
    else
        set_reg(LTAG_T);
}


void Sstringgreaterthanequalci()
{
    SOBJ str1, str2;

#ifdef TOUCH_ARG
    str1.obj = touch_obj(getarg(1));
#else
    str1.obj = getarg(1);
#endif
    if (GETstr_tag(str1.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
#ifdef TOUCH_ARG
    str2.obj = touch_obj(getarg(2));
#else
    str2.obj = getarg(2);
#endif
    if (GETstr_tag(str2.obj) != LTAG_STRING){
        err_illegal_argument("All arguments must be strings.");
	return ;
    }
    if (str_compare(str1.obj, str2.obj, CI) == STR_PRECEDING)
        set_reg(LTAG_FALSE);
    else
        set_reg(LTAG_T);
}


void Sstringappend()
{
    SOBJ strobj, result;
    int i, args,
    k_flag = A_STRING,
    length = 0;
    char    *strp1, *strp2;

    args = getargnum();
    k_flag = 0;
    for (i = 1 ; i <= args ; i++) {
#ifdef TOUCH_ARG
        strobj.obj = touch_obj(getarg(i));
#else
        strobj.obj = getarg(i);
#endif
        if (GETstr_tag(strobj.obj) == LTAG_STRING) {
            if (GETtag(((STRING * )ADDRESS(strobj.obj))->head) == LTAG_BLOCK1)
                strobj.obj = ((STRING * )ADDRESS(strobj.obj))->str_len;
            length += ((STRING * )ADDRESS(strobj.obj))->str_len;
            if (length > STRLEN_MAX)
                bokkan("Too long length of string.");
            if (((STRING * )ADDRESS(strobj.obj))->str_kind == K_STRING)
                k_flag = K_STRING;
        } else {
            err_illegal_argument("All arguments must be strings.");
	    return ;
	}
    }

    result.obj = mk_estr(ORDINARY_STRING, k_flag, length);
    strp1 = (char *)(ADDRESS(result.obj) + 12);
    if (k_flag == A_STRING) {
        for (i = 1 ; i <= args ; i++) {
#ifdef TOUCH_ARG
            strobj.obj = touch_obj(getarg(i));
#else
            strobj.obj = getarg(i);
#endif
            if (GETtag(((STRING * )ADDRESS(strobj.obj))->head) == LTAG_BLOCK1)
                strobj.obj = ((STRING * )ADDRESS(strobj.obj))->str_len;
            length = ((STRING * )ADDRESS(strobj.obj))->str_len;
            strp2 = (char *)(ADDRESS(strobj.obj) + 12);
            for (; length > 0 ; length--)
                *(strp1++) = *(strp2++);
        }
        *strp1 = '\0';
    } else
     {
        for (i = 1 ; i <= args ; i++) {
#ifdef TOUCH_ARG
            strobj.obj = touch_obj(getarg(i));
#else
            strobj.obj = getarg(i);
#endif
            if (GETtag(((STRING * )ADDRESS(strobj.obj))->head) == LTAG_BLOCK1)
                strobj.obj = ((STRING * )ADDRESS(strobj.obj))->str_len;
            length = ((STRING * )ADDRESS(strobj.obj))->str_len;
            strp2 = (char *)(ADDRESS(strobj.obj) + 12);
            if (((STRING * )ADDRESS(strobj.obj))->str_kind == 
                A_STRING) {
                for (; length > 0 ; length--) {
                    *(strp1++) = '\0';
                    *(strp1++) = *(strp2++);
                }
            } else
             {
                for (; length > 0 ; length--) {
                    *(strp1++) = *(strp2++);
                    *(strp1++) = *(strp2++);
                }
            }
        }
        *(strp1++) = '\0';
        *strp1 = '\0';
    }
    set_reg(result.obj);
}


void Ssubstring()
{
    SOBJ strobj, result;
    int i, length, start, end;
    char *str_to, *str_from;

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) == LTAG_STRING) {
        if (GETtag(((STRING * )ADDRESS(strobj.obj))->head) == LTAG_BLOCK1)
            strobj.obj = ((STRING * )ADDRESS(strobj.obj))->str_len;
        length = ((STRING * )ADDRESS(strobj.obj))->str_len;
    } else {
        err_illegal_argument("1st argument must be a string.");
	return ;
    }

#ifdef TOUCH_ARG
    start = fix_to_int(touch_obj(getarg(2)));
#else
    start = fix_to_int(getarg(2));
#endif
#ifdef TOUCH_ARG
    end = fix_to_int(touch_obj(getarg(3)));
#else
    end = fix_to_int(getarg(3));
#endif
    if (start < 0 || start > length)
        bokkan("out of range in 2nd argument");
    if (end < 0 || end > length)
        bokkan("out of range in 3rd argument");
    if (start > end){
        err_illegal_argument("2nd argument must be less than or equal to 3rd argument.");
	return ;
    }
    if (((STRING * )ADDRESS(strobj.obj))->str_kind == A_STRING) {
	result.obj = mk_estr(ORDINARY_STRING, A_STRING, end - start);
	str_to = (char *)(ADDRESS(result.obj) + 12);
	str_from = (char *)(ADDRESS(strobj.obj) + 12) + start;
	for (i = 0; i < end - start; i++)
	    *str_to++ = *str_from++;
    } else {
	result.obj = mk_estr(ORDINARY_STRING, K_STRING, end - start);
	str_to = (char *)(ADDRESS(result.obj) + 12);
	str_from = (char *)(ADDRESS(strobj.obj) + 12) + start * 2;
	for (i = 0; i < end - start; i++) {
	    *str_to++ = *str_from++;
	    *str_to++ = *str_from++;
	}
	*str_to++ = '\0';
    }
    *str_to = '\0';
    set_reg(result.obj);
}
