/*
 * unixfasl.c - 
 */

/*
 * $Id: unixfasl.c,v 1.2 1998/10/29 05:12:05 shige Exp $
 */

static char *RCSid="$Id: unixfasl.c,v 1.2 1998/10/29 05:12:05 shige Exp $";

#include "scheme.h"

#ifdef UNIXFASL

#ifdef SUN
#include <string.h>
#else
#include <strings.h>
#endif

#ifndef THINK_C
#include <a.out.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#endif

extern int errno;

#define MAXPATHLEN  1024

extern char tus_self[];

fasload(faslfile)
int faslfile;
{
#ifndef THINK_C
    struct exec header, newheader;
#define textsize    header.a_text
#define datasize    header.a_data
#define bsssize     header.a_bss
#define textstart   sizeof(header)
#define newbsssize  newheader.a_bss
#endif

    SOBJ data, tempfile;
    FILE *fp;
    struct stat st;
    char filename[MAXPATHLEN], tempfilename[32], command[MAXPATHLEN * 2];
    char dfilename[MAXPATHLEN];
    char *memory;
    int i, datafile;
    unsigned *old_base_reg = base_reg;
    unsigned *old_sp_reg = sp_reg;

    if (GETstr_tag(faslfile) != LTAG_STRING) {
        if (GETsym_tag(faslfile) == LTAG_SYMBOL)
            faslfile = ((SYMBOL *)ADDRESS(faslfile))->sym_name.obj;
        else {
            err_illegal_argument_type(faslfile, "string or symbol");
            return;
        }
    }
    strcpy(filename, (char *)strobj_to_str(faslfile));
    strcpy(dfilename, (char *)strobj_to_str(faslfile));
    strcat(filename, ".o");
    strcat(dfilename, ".data");

    tempfile.obj = mk_str(ORDINARY_STRING, A_STRING, strlen(filename),
                          filename);
    if ((faslfile = mkport(tempfile.obj, INPUT)) == NULL) {
        fprintf(stderr, "file error");
        exit(1);
    }
    fp = ((PORT *)ADDRESS(faslfile))->fp;

#ifndef THINK_C
    fread(&header, sizeof(header), 1, fp);
#endif

    s_push(faslfile);
    memory = (char *)malloc(textsize + datasize + bsssize);
    faslfile = s_pop();

#ifndef THINK_C
    fseek(fp,
          header.a_text + header.a_data
          + header.a_syms + header.a_trsize + header.a_drsize,
          1);
    fread(&i, sizeof(i), 1, fp); /* i is size of string table */
    fseek(fp, i - sizeof(i), 1);
#endif

    s_push(faslfile);
    if ((stat(dfilename, &st) == 0 || errno != ENOENT)
        && !(st.st_mode & S_IFDIR)) {
        tempfile.obj = mk_str(ORDINARY_STRING, A_STRING, strlen(dfilename),
                              dfilename);
        datafile = mkport(tempfile.obj, INPUT);
        s_push(datafile);
        data.obj = read_fasl_vector(datafile);
        closeport(s_pop());
    } else {
        fseek(fp, 8, 1);
        data.obj = read_fasl_vector(faslfile);
    }
    closeport(s_pop());

    sprintf(tempfilename, "/tmp/fasltemp%d", getpid());

AGAIN:

#ifndef THINK_C
    sprintf(command,
#ifdef SUNOS4
        "ld -Bstatic -d -N -x -A %s -T %x %s -o %s",
#elif defined(MACHTEN)
        "ld -cross -d -N -x -A %s -T %x %s -o %s",
#else
        "ld -d -N -x -A %s -T %x %s -o %s",
#endif
        tus_self,
        memory,
        filename,
        tempfilename);
#endif

    if (system(command) != 0) {
        fprintf(stderr, "The linkage editor failed.");
        exit(1);
    }
    s_push(data.obj);
    tempfile.obj = mk_str(ORDINARY_STRING, A_STRING, strlen(tempfilename),
                          tempfilename);
    if ((tempfile.obj = mkport(tempfile.obj, INPUT)) == NULL) {
        fprintf(stderr, "file error");
        exit(1);
    }
    data.obj = s_pop();
    fp = ((PORT *)ADDRESS(tempfile.obj))->fp;

#ifndef THINK_C
    fread(&newheader, sizeof(header), 1, fp);
    if (newbsssize != bsssize) {
        free(memory);
        bsssize = newbsssize;
        s_push(data.obj);
        s_push(tempfile.obj);
        memory = (char *)malloc(textsize + datasize + bsssize);
        tempfile.obj = s_pop();
        data.obj = s_pop();
        closeport(tempfile.obj);
        unlink(tempfilename);
        goto AGAIN;
    }
#endif

    if (fseek(fp, textstart, 0) < 0) {
        fprintf(stderr, "file seek error");
        exit(1);
    }

    fread(memory, textsize + datasize, 1, fp);

    closeport(tempfile.obj);

    unlink(tempfilename);

    (*(int (*)())(memory))
        (memory, data.obj);

    base_reg = old_base_reg;
    sp_reg = old_sp_reg;

    return(1);
}

read_fasl_vector(in)
int in;
{
    int vec;

    s_push(c_in_port.obj);
    c_in_port.obj = in;
    vec = readexp();
    if (GETtag(vec) != LTAG_VECTOR)
        vec = LTAG_NILVECTOR;
    c_in_port.obj = s_pop();
    return(vec);
}

#endif /* UNIXFASL */

#define TAG_AND_ADDRESS_MASK 0xfffffffc

free_garbage_ncc()
{
    NCCLOS *lost_ncc_entity;
    unsigned *nccp, *carp, *lost_ncc;

    nccp = &(((ENTITYP)ADDRESS(ncclist.obj))->sym.sym_val.obj);

    while (GETtag(*nccp) != LTAG_NIL) { 
        carp = (unsigned *)((unsigned *)ADDRESS(*nccp) + 3);
        if (GETlo_tag(*carp) == LTAG_LOSTOBJ) {
            lost_ncc_entity = (NCCLOS *)ADDRESS(*carp);
            if (lost_ncc_entity->start_addr != NULL) {
                free(lost_ncc_entity->start_addr);
                lost_ncc_entity->start_addr = (int)NULL;
            }
            *nccp = *(carp - 2);
            *(carp - 3) = *(carp - 3) & TAG_AND_ADDRESS_MASK;
            *(carp - 1) = *(carp - 1) & TAG_AND_ADDRESS_MASK;
        } else
            nccp = carp - 2;        /* cdr */
    }
}

#ifdef UNIXFASL

Sfasload()
{
#ifdef TOUCH_ARG
    fasload(touch_obj(getarg(1)));
#else
    fasload(getarg(1));
#endif
    set_reg(LTAG_T);
}

#endif /* UNIXFASL */
