/*
 * vector.c - 
 */

/*
 * $Id: vector.c,v 1.4 2014/10/28 02:22:55 komiya Exp $
 */

/************************************/
/*                                  */
/*  File Name : vector.c            */
/*  Update    : Yass.  Jul. 19 '90  */
/*              Yass.  Jul. 18 '90  */
/*              Myama. ?            */
/*                                  */
/*    Vector operations             */
/*                                  */
/************************************/

static char *RCSid="$Id: vector.c,v 1.4 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"


/********************************/
/*                              */
/*  Internal useful procedures  */
/*                              */
/********************************/

void set_vec(vec_obj, index, obj)  /*  Yass. Jul. 18 '90  */
unsigned vec_obj;
int index;
unsigned obj;
{
    *((unsigned *)(ADDRESS(vec_obj) + (index + 1) * 4)) = obj;
}


get_vec(vec_obj, index)  /*  Yass. Jul. 18 '90  */
unsigned vec_obj;
int index;
{
    return(*((unsigned *)(ADDRESS(vec_obj) + (index + 1) * 4)));
}


int nonnil_vector_length(vec_obj)  /*  Yass. Jul. 18 '90  */
unsigned vec_obj;
{
    return((int)(IMM(((ENTITYP)ADDRESS(vec_obj))->vec.head) >> 2));
}


void Pset_vec(vecp, element, obj)
unsigned *vecp;
int element;
unsigned obj;
{
    *( vecp + element + 1 ) = obj;
}


/***********************************/
/*                                 */
/*  Essential standard procedures  */
/*                                 */
/***********************************/

void Svectorp()  /*  Yass. Jul. 18 '90  */
{
#ifdef TOUCH_ARG
    if (GETtag(touch_obj(getarg(1))) == LTAG_VECTOR
	|| GETtag(touch_obj(getarg(1))) == LTAG_NILVECTOR)
#else
    if (GETtag(getarg(1)) == LTAG_VECTOR || GETtag(getarg(1)) == LTAG_NILVECTOR)
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Smakevector()  /*  Yass. Jul. 19 '90  */
{ 
    SOBJ  obj, init;
    SOBJP result;
    int tag, len, i;

    switch (getargnum()) {
/*  case 0:
        too few arguments --- checked by xcall() */
    case 1:
        init.obj = LTAG_NIL;
        break;
    case 2:
        init.obj = getarg(2);
        break;
    default:
        err_illegal_argument("Too many arguments.");
        return;
    }
#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
/*    if ((tag = GETtag(obj.obj)) != LTAG_FIXNUM && tag != LTAG_FIXNUM1) */
    if ((tag = GETtag(obj.obj)) != LTAG_FIXNUM
        || (len = fix_to_int(obj.obj)) > BSIZE_MAX){ /* by T.Komiya */
        err_illegal_argument_type(obj.obj, "non-negative number less than 16777216");
	return ;
    }
    if (len > 0) {
        result = (SOBJP)mk_evecp(len);
        for (i = 1; i <= len; i++)
            (result + i)->obj = init.obj;
        set_reg(LTAG_VECTOR | SSERDDA(result));
    } else
        set_reg(LTAG_NILVECTOR);
}


void Svector()  /*  Yass. Jul. 19 '90  */
{ 
    SOBJP result;
    int len, i;

    len = getargnum();
    if (len > BSIZE_MAX){
        err_illegal_argument("Too many arguments.");
	return ;
    }
    if (len > 0) {
        result = (SOBJP)mk_evecp(len);
        for (i = 1; i <= len; i++)
            (result + i)->obj = getarg(i);
        set_reg(LTAG_VECTOR | SSERDDA(result));
    } else
        set_reg(LTAG_NILVECTOR);
}


void Svectorlength()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) != LTAG_VECTOR)
        if (GETtag(obj.obj) != LTAG_NILVECTOR){
            err_illegal_argument_type(obj.obj, "vector");
	    return ;
	}
        else
            set_reg(SCOBJ_0);
    else
        set_reg(mk_fix(nonnil_vector_length(obj.obj)));
}


void Svectorref()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj1, obj2;
    int index, tag;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
#else
    obj1.obj = getarg(1);
#endif
    if (GETtag(obj1.obj) != LTAG_VECTOR)
        if (GETtag(obj1.obj) != LTAG_NILVECTOR){
            err_illegal_argument_type(obj1.obj, "vector");
	    return ;
	}
        else{
            err_illegal_argument("2nd argument is out of vector length.");
	    return ;
	}
#ifdef TOUCH_ARG
    obj2.obj = touch_obj(getarg(2));
#else
    obj2.obj = getarg(2);
#endif
    if ((tag = GETtag(obj2.obj)) != LTAG_FIXNUM && tag != LTAG_FIXNUM1){
        err_illegal_argument_type(obj2.obj, "non-negative fixnum");
	return ;
    }
    index = fix_to_int(obj2.obj);
    if (nonnil_vector_length(obj1.obj) <= index){
        err_illegal_argument("2nd argument is out of vector length.");
	return ;
    }
    set_reg(*((unsigned *)(ADDRESS(obj1.obj) + (index + 1) * 4)));
}


void Svectorset()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ obj1, obj2;
    int index, tag;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
#else
    obj1.obj = getarg(1);
#endif
    if (GETtag(obj1.obj) != LTAG_VECTOR)
        if (GETtag(obj1.obj) != LTAG_NILVECTOR){
            err_illegal_argument_type(obj1.obj,"vector");
	    return ;
	}
        else{
            err_illegal_argument("2nd argument is out of vector length.");
	    return ;
	}
#ifdef TOUCH_ARG
    obj2.obj = touch_obj(getarg(2));
#else
    obj2.obj = getarg(2);
#endif
    if ((tag = GETtag(obj2.obj)) != LTAG_FIXNUM && tag != LTAG_FIXNUM1){
        err_illegal_argument_type(obj2.obj, "non-negative fixnum");
	return ;
    }
    index = fix_to_int(obj2.obj);
    if (nonnil_vector_length(obj1.obj) <= index){
        err_illegal_argument("2nd argument is out of vector length.");
	return ;
    }
    *((unsigned *)(ADDRESS(obj1.obj) + (index + 1) * 4)) = getarg(3);
    set_reg(obj1.obj);
}


/*************************/
/*                       */
/*  Original procedures  */
/*                       */
/*************************/

void Svectorlist()  /*  Yass. Jul. 18 '90  */
{ 
    SOBJ    obj, result;
    CARCDR * cell;
    int len, i, tag;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) != LTAG_VECTOR)
        if (GETtag(obj.obj) != LTAG_NILVECTOR){
            err_illegal_argument_type(obj.obj, "vector");
	    return ;
	}
        else
            set_reg(LTAG_NIL);
    else {
        len = nonnil_vector_length(obj.obj);
        if (len == 0)
            set_reg(LTAG_NIL);
        else {
            s_push(obj.obj);    /* T.Komiya */
            result.entity = (ENTITYP)(LTAG_CONS | SSERDDA(mk_nconsp(len)));
            obj.obj = s_pop();  /* T.Komiya */
#ifdef SPECIAL_CONS_TAG
            cell = (CARCDR * )result.entity;
#else
            cell = (CARCDR * )ADDRESS(result.entity);
#endif
            for (i = 0 ; i < len ; i++) { 
                cell->car.obj = *((unsigned *)(ADDRESS(obj.obj) + (i + 1) * 4));
                cell++;
            }
            set_reg(result.obj);
        }
    }
}
