/*
 * weakpair.c - 
 */

/*
 * $Id: weakpair.c,v 1.3 2014/10/28 02:22:55 komiya Exp $
 */

/************************************/
/*                                  */
/*  File Name : weakpair.c          */
/*    Mikio Yamamoto  1990.6        */
/*                                  */
/*  Update    : Yass.  Jul. 19 '90  */
/*              Yass.  Jul. 18 '90  */
/*              Myama. ?            */
/*              Komiya Oct. 26 '90  */
/*                                  */
/*    Weakpair operations           */
/*                                  */
/************************************/

static char *RCSid="$Id: weakpair.c,v 1.3 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

/* mkweakpair is not used */
/*
mkweakpair(){
  unsigned *weakpair;
  weakpair = (unsigned *)memget(8);
  *weakpair = reg1;
  *(weakpair + 1) = reg2;
}
*/

void Sweakpairp()
{
    unsigned weakpair;
#ifdef TOUCH_ARG
    weakpair = touch_obj(getsv(-2));
#else
    weakpair = getsv(-2);
#endif
    if ( GETtag(weakpair) == LTAG_WEAKPAIR)
        set_reg(LTAG_T);
    else 
        set_reg(LTAG_FALSE);
}


void Slostobjp()
{
#ifdef TOUCH_ARG
    if (GETlo_tag(touch_obj(getsv(-2))) == LTAG_LOSTOBJ)
#else
    if (GETlo_tag(getsv(-2)) == LTAG_LOSTOBJ)
#endif
        set_reg(LTAG_T);
    else 
        set_reg(LTAG_FALSE);
}


void Sweakcons()
{
    unsigned *weakpair;

    weakpair = (unsigned *)memget(20);
    *weakpair = LTAG_BLOCK1 | 16;
    *(weakpair + 1) = getsv(-3);                            /* cdr */
    *(weakpair + 2) = LTAG_BLOCK2 | 8;
    *(weakpair + 3) = getsv(-2);                            /* car */
    *(weakpair + 4) = get_sval(wplist.obj);                 /* link */
    set_sval(wplist.obj, LTAG_WEAKPAIR | SSERDDA(weakpair));

    set_reg(LTAG_WEAKPAIR | SSERDDA(weakpair));
}


void Sweakpaircarp()
{
    unsigned weakpair;
    unsigned *body;

#ifdef TOUCH_ARG
    weakpair = touch_obj(getsv(-2));
#else
    weakpair = getsv(-2);
#endif
    if (GETtag(weakpair) != LTAG_WEAKPAIR){
        err_illegal_argument_type(weakpair, "weakpair");
	return ;
    }
    body = (unsigned *)(ADDRESS(weakpair));
#ifdef TOUCH_ARG
    if (GETlo_tag(touch_obj(*(body + 3))) == LTAG_LOSTOBJ)
#else
    if (GETlo_tag(*(body + 3)) == LTAG_LOSTOBJ)
#endif
        set_reg(LTAG_FALSE);
    else 
        set_reg(LTAG_T);
}


void Sweakcar()
{
    unsigned weakpair;
    int car;

#ifdef TOUCH_ARG
    weakpair = touch_obj(getsv(-2));
#else
    weakpair = getsv(-2);
#endif
    if (GETtag(weakpair) != LTAG_WEAKPAIR){
        err_illegal_argument_type(weakpair, "weakpair");
	return ;
    }
    car = *((unsigned *)ADDRESS(weakpair) + 3);
#ifdef TOUCH_ARG
    if (GETlo_tag(touch_obj(car)) == LTAG_LOSTOBJ)
#else
    if (GETlo_tag(car) == LTAG_LOSTOBJ)
#endif
        set_reg(LTAG_FALSE);
    else 
        set_reg(car);
}


void Sweakcdr()
{
    unsigned weakpair;
    SOBJ car;

#ifdef TOUCH_ARG
    weakpair = touch_obj(getsv(-2));
#else
    weakpair = getsv(-2);
#endif
    if (GETtag(weakpair) != LTAG_WEAKPAIR){
        err_illegal_argument_type(weakpair, "weakpair");
	return ;
    }
    set_reg(*((unsigned *)ADDRESS(weakpair) + 1));
}


void Sweaksetcar()
{
    unsigned weakpair;
    unsigned car;

#ifdef TOUCH_ARG
    weakpair = touch_obj(getsv(-2));
#else
    weakpair = getsv(-2);
#endif
    if (GETtag(weakpair) != LTAG_WEAKPAIR){
        err_illegal_argument_type(weakpair, "weakpair");
	return ;
    }
    car = getsv(-3);
    *((unsigned *)ADDRESS(weakpair) + 3) = car;
    if (GETtag(*((unsigned *)ADDRESS(weakpair) + 4)) == LTAG_NILVECTOR) {
        *((unsigned *)ADDRESS(weakpair) + 4) = get_sval(wplist.obj);
        set_sval(wplist.obj, LTAG_WEAKPAIR | SSERDDA(ADDRESS(weakpair)));
    }
    set_reg(car);
}


void Sweaksetcdr()
{
    unsigned weakpair;
    unsigned cdr;

#ifdef TOUCH_ARG
    weakpair = touch_obj(getsv(-2));
#else
    weakpair = getsv(-2);
#endif
    if (GETtag(weakpair) != LTAG_WEAKPAIR){
        err_illegal_argument_type(weakpair, "weakpair");
	return ;
    }
    cdr = getsv(-3);
    *((unsigned *)ADDRESS(weakpair) + 1) = cdr;
    set_reg(cdr);
}
